import * as resources from "./resources";
export { _subscription } from "./resources/subscription";
export { _contract_term } from "./resources/contract_term";
export { _discount } from "./resources/discount";
export { _advance_invoice_schedule } from "./resources/advance_invoice_schedule";
export { _customer } from "./resources/customer";
export { _hierarchy } from "./resources/hierarchy";
export { _contact } from "./resources/contact";
export { _business_entity_transfer } from "./resources/business_entity_transfer";
export { _token } from "./resources/token";
export { _payment_source } from "./resources/payment_source";
export { _third_party_payment_method } from "./resources/third_party_payment_method";
export { _virtual_bank_account } from "./resources/virtual_bank_account";
export { _card } from "./resources/card";
export { _promotional_credit } from "./resources/promotional_credit";
export { _invoice } from "./resources/invoice";
export { _payment_reference_number } from "./resources/payment_reference_number";
export { _payment_schedule } from "./resources/payment_schedule";
export { _tax_withheld } from "./resources/tax_withheld";
export { _credit_note } from "./resources/credit_note";
export { _unbilled_charge } from "./resources/unbilled_charge";
export { _order } from "./resources/order";
export { _gift } from "./resources/gift";
export { _transaction } from "./resources/transaction";
export { _hosted_page } from "./resources/hosted_page";
export { _estimate } from "./resources/estimate";
export { _quote } from "./resources/quote";
export { _quoted_subscription } from "./resources/quoted_subscription";
export { _quoted_charge } from "./resources/quoted_charge";
export { _quoted_ramp } from "./resources/quoted_ramp";
export { _quote_line_group } from "./resources/quote_line_group";
export { _plan } from "./resources/plan";
export { _addon } from "./resources/addon";
export { _coupon } from "./resources/coupon";
export { _coupon_set } from "./resources/coupon_set";
export { _coupon_code } from "./resources/coupon_code";
export { _address } from "./resources/address";
export { _usage } from "./resources/usage";
export { _event } from "./resources/event";
export { _comment } from "./resources/comment";
export { _download } from "./resources/download";
export { _portal_session } from "./resources/portal_session";
export { _site_migration_detail } from "./resources/site_migration_detail";
export { _resource_migration } from "./resources/resource_migration";
export { _time_machine } from "./resources/time_machine";
export { _export } from "./resources/export";
export { _payment_intent } from "./resources/payment_intent";
export { _gateway_error_detail } from "./resources/gateway_error_detail";
export { _item_family } from "./resources/item_family";
export { _item } from "./resources/item";
export { _price_variant } from "./resources/price_variant";
export { _attribute } from "./resources/attribute";
export { _item_price } from "./resources/item_price";
export { _attached_item } from "./resources/attached_item";
export { _differential_price } from "./resources/differential_price";
export { _configuration } from "./resources/configuration";
export { _feature } from "./resources/feature";
export { _impacted_subscription } from "./resources/impacted_subscription";
export { _impacted_item } from "./resources/impacted_item";
export { _impacted_item_price } from "./resources/impacted_item_price";
export { _metadata } from "./resources/metadata";
export { _subscription_entitlement } from "./resources/subscription_entitlement";
export { _customer_entitlement } from "./resources/customer_entitlement";
export { _item_entitlement } from "./resources/item_entitlement";
export { _entitlement } from "./resources/entitlement";
export { _in_app_subscription } from "./resources/in_app_subscription";
export { _non_subscription } from "./resources/non_subscription";
export { _entitlement_override } from "./resources/entitlement_override";
export { _business_entity } from "./resources/business_entity";
export { _purchase } from "./resources/purchase";
export { _payment_voucher } from "./resources/payment_voucher";
export { _currency } from "./resources/currency";
export { _ramp } from "./resources/ramp";
export { _payment_schedule_scheme } from "./resources/payment_schedule_scheme";
export { _pricing_page_session } from "./resources/pricing_page_session";
export { _omnichannel_subscription } from "./resources/omnichannel_subscription";
export { _omnichannel_transaction } from "./resources/omnichannel_transaction";
export { _omnichannel_subscription_item } from "./resources/omnichannel_subscription_item";
export { _recorded_purchase } from "./resources/recorded_purchase";
export { _rule } from "./resources/rule";
export { _usage_event } from "./resources/usage_event";
export { _omnichannel_subscription_item_scheduled_change } from "./resources/omnichannel_subscription_item_scheduled_change";
export { _usage_file } from "./resources/usage_file";
interface Conf {
    api_key: string;
    site: string;
}
export declare class ChargeBee {
    static _env: any;
    static _api_version: string;
    configure(conf: Partial<typeof ChargeBee._env & Conf>): void;
    updateRequestTimeoutInMillis(timeout: any): void;
    get subscription(): typeof resources.Subscription;
    get contract_term(): typeof resources.ContractTerm;
    get discount(): typeof resources.Discount;
    get advance_invoice_schedule(): typeof resources.AdvanceInvoiceSchedule;
    get customer(): typeof resources.Customer;
    get hierarchy(): typeof resources.Hierarchy;
    get contact(): typeof resources.Contact;
    get business_entity_transfer(): typeof resources.BusinessEntityTransfer;
    get token(): typeof resources.Token;
    get payment_source(): typeof resources.PaymentSource;
    get third_party_payment_method(): typeof resources.ThirdPartyPaymentMethod;
    get virtual_bank_account(): typeof resources.VirtualBankAccount;
    get card(): typeof resources.Card;
    get promotional_credit(): typeof resources.PromotionalCredit;
    get invoice(): typeof resources.Invoice;
    get payment_reference_number(): typeof resources.PaymentReferenceNumber;
    get payment_schedule(): typeof resources.PaymentSchedule;
    get tax_withheld(): typeof resources.TaxWithheld;
    get credit_note(): typeof resources.CreditNote;
    get unbilled_charge(): typeof resources.UnbilledCharge;
    get order(): typeof resources.Order;
    get gift(): typeof resources.Gift;
    get transaction(): typeof resources.Transaction;
    get hosted_page(): typeof resources.HostedPage;
    get estimate(): typeof resources.Estimate;
    get quote(): typeof resources.Quote;
    get quoted_subscription(): typeof resources.QuotedSubscription;
    get quoted_charge(): typeof resources.QuotedCharge;
    get quoted_ramp(): typeof resources.QuotedRamp;
    get quote_line_group(): typeof resources.QuoteLineGroup;
    get plan(): typeof resources.Plan;
    get addon(): typeof resources.Addon;
    get coupon(): typeof resources.Coupon;
    get coupon_set(): typeof resources.CouponSet;
    get coupon_code(): typeof resources.CouponCode;
    get address(): typeof resources.Address;
    get usage(): typeof resources.Usage;
    get event(): typeof resources.Event;
    get comment(): typeof resources.Comment;
    get download(): typeof resources.Download;
    get portal_session(): typeof resources.PortalSession;
    get site_migration_detail(): typeof resources.SiteMigrationDetail;
    get resource_migration(): typeof resources.ResourceMigration;
    get time_machine(): typeof resources.TimeMachine;
    get export(): typeof resources.Export;
    get payment_intent(): typeof resources.PaymentIntent;
    get gateway_error_detail(): typeof resources.GatewayErrorDetail;
    get item_family(): typeof resources.ItemFamily;
    get item(): typeof resources.Item;
    get price_variant(): typeof resources.PriceVariant;
    get attribute(): typeof resources.Attribute;
    get item_price(): typeof resources.ItemPrice;
    get attached_item(): typeof resources.AttachedItem;
    get differential_price(): typeof resources.DifferentialPrice;
    get configuration(): typeof resources.Configuration;
    get feature(): typeof resources.Feature;
    get impacted_subscription(): typeof resources.ImpactedSubscription;
    get impacted_item(): typeof resources.ImpactedItem;
    get impacted_item_price(): typeof resources.ImpactedItemPrice;
    get metadata(): typeof resources.Metadata;
    get subscription_entitlement(): typeof resources.SubscriptionEntitlement;
    get customer_entitlement(): typeof resources.CustomerEntitlement;
    get item_entitlement(): typeof resources.ItemEntitlement;
    get entitlement(): typeof resources.Entitlement;
    get in_app_subscription(): typeof resources.InAppSubscription;
    get non_subscription(): typeof resources.NonSubscription;
    get entitlement_override(): typeof resources.EntitlementOverride;
    get business_entity(): typeof resources.BusinessEntity;
    get purchase(): typeof resources.Purchase;
    get payment_voucher(): typeof resources.PaymentVoucher;
    get currency(): typeof resources.Currency;
    get ramp(): typeof resources.Ramp;
    get payment_schedule_scheme(): typeof resources.PaymentScheduleScheme;
    get pricing_page_session(): typeof resources.PricingPageSession;
    get omnichannel_subscription(): typeof resources.OmnichannelSubscription;
    get omnichannel_transaction(): typeof resources.OmnichannelTransaction;
    get omnichannel_subscription_item(): typeof resources.OmnichannelSubscriptionItem;
    get recorded_purchase(): typeof resources.RecordedPurchase;
    get rule(): typeof resources.Rule;
    get usage_event(): typeof resources.UsageEvent;
    get omnichannel_subscription_item_scheduled_change(): typeof resources.OmnichannelSubscriptionItemScheduledChange;
    get usage_file(): typeof resources.UsageFile;
}
