"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChargeBee = void 0;
const util_1 = require("./util");
const resources = require("./resources");
class ChargeBee {
    configure(conf) {
        util_1.Util.extend(true, ChargeBee._env, conf);
    }
    updateRequestTimeoutInMillis(timeout) {
        ChargeBee._env.timeout = timeout;
    }
    get subscription() {
        return resources.Subscription;
    }
    get contract_term() {
        return resources.ContractTerm;
    }
    get discount() {
        return resources.Discount;
    }
    get advance_invoice_schedule() {
        return resources.AdvanceInvoiceSchedule;
    }
    get customer() {
        return resources.Customer;
    }
    get hierarchy() {
        return resources.Hierarchy;
    }
    get contact() {
        return resources.Contact;
    }
    get business_entity_transfer() {
        return resources.BusinessEntityTransfer;
    }
    get token() {
        return resources.Token;
    }
    get payment_source() {
        return resources.PaymentSource;
    }
    get third_party_payment_method() {
        return resources.ThirdPartyPaymentMethod;
    }
    get virtual_bank_account() {
        return resources.VirtualBankAccount;
    }
    get card() {
        return resources.Card;
    }
    get promotional_credit() {
        return resources.PromotionalCredit;
    }
    get invoice() {
        return resources.Invoice;
    }
    get payment_reference_number() {
        return resources.PaymentReferenceNumber;
    }
    get payment_schedule() {
        return resources.PaymentSchedule;
    }
    get tax_withheld() {
        return resources.TaxWithheld;
    }
    get credit_note() {
        return resources.CreditNote;
    }
    get unbilled_charge() {
        return resources.UnbilledCharge;
    }
    get order() {
        return resources.Order;
    }
    get gift() {
        return resources.Gift;
    }
    get transaction() {
        return resources.Transaction;
    }
    get hosted_page() {
        return resources.HostedPage;
    }
    get estimate() {
        return resources.Estimate;
    }
    get quote() {
        return resources.Quote;
    }
    get quoted_subscription() {
        return resources.QuotedSubscription;
    }
    get quoted_charge() {
        return resources.QuotedCharge;
    }
    get quoted_ramp() {
        return resources.QuotedRamp;
    }
    get quote_line_group() {
        return resources.QuoteLineGroup;
    }
    get plan() {
        return resources.Plan;
    }
    get addon() {
        return resources.Addon;
    }
    get coupon() {
        return resources.Coupon;
    }
    get coupon_set() {
        return resources.CouponSet;
    }
    get coupon_code() {
        return resources.CouponCode;
    }
    get address() {
        return resources.Address;
    }
    get usage() {
        return resources.Usage;
    }
    get event() {
        return resources.Event;
    }
    get comment() {
        return resources.Comment;
    }
    get download() {
        return resources.Download;
    }
    get portal_session() {
        return resources.PortalSession;
    }
    get site_migration_detail() {
        return resources.SiteMigrationDetail;
    }
    get resource_migration() {
        return resources.ResourceMigration;
    }
    get time_machine() {
        return resources.TimeMachine;
    }
    get export() {
        return resources.Export;
    }
    get payment_intent() {
        return resources.PaymentIntent;
    }
    get gateway_error_detail() {
        return resources.GatewayErrorDetail;
    }
    get item_family() {
        return resources.ItemFamily;
    }
    get item() {
        return resources.Item;
    }
    get price_variant() {
        return resources.PriceVariant;
    }
    get attribute() {
        return resources.Attribute;
    }
    get item_price() {
        return resources.ItemPrice;
    }
    get attached_item() {
        return resources.AttachedItem;
    }
    get differential_price() {
        return resources.DifferentialPrice;
    }
    get configuration() {
        return resources.Configuration;
    }
    get feature() {
        return resources.Feature;
    }
    get impacted_subscription() {
        return resources.ImpactedSubscription;
    }
    get impacted_item() {
        return resources.ImpactedItem;
    }
    get impacted_item_price() {
        return resources.ImpactedItemPrice;
    }
    get metadata() {
        return resources.Metadata;
    }
    get subscription_entitlement() {
        return resources.SubscriptionEntitlement;
    }
    get customer_entitlement() {
        return resources.CustomerEntitlement;
    }
    get item_entitlement() {
        return resources.ItemEntitlement;
    }
    get entitlement() {
        return resources.Entitlement;
    }
    get in_app_subscription() {
        return resources.InAppSubscription;
    }
    get non_subscription() {
        return resources.NonSubscription;
    }
    get entitlement_override() {
        return resources.EntitlementOverride;
    }
    get business_entity() {
        return resources.BusinessEntity;
    }
    get purchase() {
        return resources.Purchase;
    }
    get payment_voucher() {
        return resources.PaymentVoucher;
    }
    get currency() {
        return resources.Currency;
    }
    get ramp() {
        return resources.Ramp;
    }
    get payment_schedule_scheme() {
        return resources.PaymentScheduleScheme;
    }
    get pricing_page_session() {
        return resources.PricingPageSession;
    }
    get omnichannel_subscription() {
        return resources.OmnichannelSubscription;
    }
    get omnichannel_transaction() {
        return resources.OmnichannelTransaction;
    }
    get omnichannel_subscription_item() {
        return resources.OmnichannelSubscriptionItem;
    }
    get recorded_purchase() {
        return resources.RecordedPurchase;
    }
    get rule() {
        return resources.Rule;
    }
    get usage_event() {
        return resources.UsageEvent;
    }
    get omnichannel_subscription_item_scheduled_change() {
        return resources.OmnichannelSubscriptionItemScheduledChange;
    }
    get usage_file() {
        return resources.UsageFile;
    }
}
exports.ChargeBee = ChargeBee;
ChargeBee._env = require('./environment');
ChargeBee._api_version = 'v2';
