"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListResult = void 0;
const result_1 = require("./result");
const util_1 = require("./util");
class ListResult {
    constructor(response, responseHeaders, responseStatusCode) {
        this.list = [];
        this.next_offset = response.next_offset;
        if (util_1.Util.isArray(response.list)) {
            for (let res of response.list) {
                this.list.push(new result_1.Result(res));
            }
        }
        if (responseHeaders) {
            this.responseHeaders = responseHeaders;
        }
        if (responseStatusCode) {
            this.responseStatusCode = responseStatusCode;
        }
        return this;
    }
    getResponseHeaders() {
        return this.responseHeaders;
    }
    getResponseStatusCode() {
        return this.responseStatusCode;
    }
}
exports.ListResult = ListResult;
