"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TaxProvidersField = exports.Tier = exports.Addon = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class Addon extends model_1.Model {
    // OPERATIONS
    //-----------
    static create(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create',
            'httpMethod': 'POST',
            'urlPrefix': '/addons',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "meta_data": 0,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static update(addon_id, params) {
        return new request_wrapper_1.RequestWrapper([addon_id, params], {
            'methodName': 'update',
            'httpMethod': 'POST',
            'urlPrefix': '/addons',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "meta_data": 0,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static list(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'list',
            'httpMethod': 'GET',
            'urlPrefix': '/addons',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static retrieve(addon_id, params) {
        return new request_wrapper_1.RequestWrapper([addon_id, params], {
            'methodName': 'retrieve',
            'httpMethod': 'GET',
            'urlPrefix': '/addons',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static delete(addon_id, params) {
        return new request_wrapper_1.RequestWrapper([addon_id, params], {
            'methodName': 'delete',
            'httpMethod': 'POST',
            'urlPrefix': '/addons',
            'urlSuffix': '/delete',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static copy(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'copy',
            'httpMethod': 'POST',
            'urlPrefix': '/addons',
            'urlSuffix': '/copy',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static unarchive(addon_id, params) {
        return new request_wrapper_1.RequestWrapper([addon_id, params], {
            'methodName': 'unarchive',
            'httpMethod': 'POST',
            'urlPrefix': '/addons',
            'urlSuffix': '/unarchive',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~Addon
exports.Addon = Addon;
class Tier extends model_1.Model {
} // ~Tier
exports.Tier = Tier;
class TaxProvidersField extends model_1.Model {
} // ~TaxProvidersField
exports.TaxProvidersField = TaxProvidersField;
