import { ListResult } from '../list_result';
import { RequestWrapper } from "../request_wrapper";
import { Model } from "./model";
import { filter } from "../filter";
export declare class AttachedItem extends Model {
    id: string;
    parent_item_id: string;
    item_id: string;
    type: string;
    status?: string;
    quantity?: number;
    quantity_in_decimal?: string;
    billing_cycles?: number;
    charge_on_event: string;
    charge_once: boolean;
    created_at: number;
    resource_version?: number;
    updated_at?: number;
    channel?: string;
    business_entity_id?: string;
    deleted: boolean;
    static create(item_id: string, params?: _attached_item.create_params): RequestWrapper;
    static update(attached_item_id: string, params?: _attached_item.update_params): RequestWrapper;
    static retrieve(attached_item_id: string, params?: _attached_item.retrieve_params): RequestWrapper;
    static delete(attached_item_id: string, params?: _attached_item.delete_params): RequestWrapper;
    static list(item_id: string, params?: _attached_item.attached_item_list_params): RequestWrapper<ListResult>;
}
export declare namespace _attached_item {
    interface create_params {
        item_id: string;
        type?: string;
        billing_cycles?: number;
        quantity?: number;
        quantity_in_decimal?: string;
        charge_on_event?: string;
        charge_once?: boolean;
        business_entity_id?: string;
    }
    interface update_params {
        parent_item_id: string;
        type?: string;
        billing_cycles?: number;
        quantity?: number;
        quantity_in_decimal?: string;
        charge_on_event?: string;
        charge_once?: boolean;
    }
    interface retrieve_params {
        parent_item_id: string;
    }
    interface delete_params {
        parent_item_id: string;
    }
    interface attached_item_list_params {
        limit?: number;
        offset?: string;
        id?: filter._string;
        item_id?: filter._string;
        type?: filter._enum;
        item_type?: filter._enum;
        charge_on_event?: filter._enum;
        updated_at?: filter._timestamp;
    }
}
