"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AttachedItem = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class AttachedItem extends model_1.Model {
    // OPERATIONS
    //-----------
    static create(item_id, params) {
        return new request_wrapper_1.RequestWrapper([item_id, params], {
            'methodName': 'create',
            'httpMethod': 'POST',
            'urlPrefix': '/items',
            'urlSuffix': '/attached_items',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static update(attached_item_id, params) {
        return new request_wrapper_1.RequestWrapper([attached_item_id, params], {
            'methodName': 'update',
            'httpMethod': 'POST',
            'urlPrefix': '/attached_items',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static retrieve(attached_item_id, params) {
        return new request_wrapper_1.RequestWrapper([attached_item_id, params], {
            'methodName': 'retrieve',
            'httpMethod': 'GET',
            'urlPrefix': '/attached_items',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static delete(attached_item_id, params) {
        return new request_wrapper_1.RequestWrapper([attached_item_id, params], {
            'methodName': 'delete',
            'httpMethod': 'POST',
            'urlPrefix': '/attached_items',
            'urlSuffix': '/delete',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static list(item_id, params) {
        return new request_wrapper_1.RequestWrapper([item_id, params], {
            'methodName': 'list',
            'httpMethod': 'GET',
            'urlPrefix': '/items',
            'urlSuffix': '/attached_items',
            'hasIdInUrl': true,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~AttachedItem
exports.AttachedItem = AttachedItem;
