import { ListResult } from '../list_result';
import { RequestWrapper } from "../request_wrapper";
import { Model } from "./model";
import { filter } from "../filter";
export declare class BusinessEntity extends Model {
    id: string;
    name: string;
    status: string;
    deleted: boolean;
    created_at: number;
    resource_version?: number;
    updated_at?: number;
    static create_transfers(params?: _business_entity.create_transfers_params): RequestWrapper;
    static get_transfers(params?: _business_entity.business_entity_get_transfers_params): RequestWrapper<ListResult>;
}
export declare namespace _business_entity {
    interface create_transfers_params {
        active_resource_ids: Array<string>;
        destination_business_entity_ids: Array<string>;
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        source_business_entity_ids?: Array<string>;
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        resource_types: Array<string>;
        reason_codes: Array<string>;
    }
    interface business_entity_get_transfers_params {
        limit?: number;
        offset?: string;
        resource_type?: filter._string;
        resource_id?: filter._string;
        active_resource_id?: filter._string;
        created_at?: filter._timestamp;
        "sort_by[asc]"?: string;
        "sort_by[desc]"?: string;
    }
}
