"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BusinessEntity = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class BusinessEntity extends model_1.Model {
    // OPERATIONS
    //-----------
    static create_transfers(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create_transfers',
            'httpMethod': 'POST',
            'urlPrefix': '/business_entities',
            'urlSuffix': '/transfers',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static get_transfers(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'get_transfers',
            'httpMethod': 'GET',
            'urlPrefix': '/business_entities',
            'urlSuffix': '/transfers',
            'hasIdInUrl': false,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~BusinessEntity
exports.BusinessEntity = BusinessEntity;
