import { RequestWrapper } from "../request_wrapper";
import { Model } from "./model";
export declare class Card extends Model {
    payment_source_id: string;
    status: string;
    gateway: string;
    gateway_account_id?: string;
    ref_tx_id?: string;
    first_name?: string;
    last_name?: string;
    iin: string;
    last4: string;
    card_type?: string;
    funding_type: string;
    expiry_month: number;
    expiry_year: number;
    issuing_country?: string;
    billing_addr1?: string;
    billing_addr2?: string;
    billing_city?: string;
    billing_state_code?: string;
    billing_state?: string;
    billing_country?: string;
    billing_zip?: string;
    created_at: number;
    resource_version?: number;
    updated_at?: number;
    ip_address?: string;
    powered_by?: string;
    customer_id: string;
    masked_number?: string;
    static retrieve(card_id: string, params?: any): RequestWrapper;
    static update_card_for_customer(customer_id: string, params?: _card.update_card_for_customer_params): RequestWrapper;
    static switch_gateway_for_customer(customer_id: string, params?: _card.switch_gateway_for_customer_params): RequestWrapper;
    static copy_card_for_customer(customer_id: string, params?: _card.copy_card_for_customer_params): RequestWrapper;
    static delete_card_for_customer(customer_id: string, params?: any): RequestWrapper;
}
export declare namespace _card {
    interface update_card_for_customer_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        gateway?: string;
        gateway_account_id?: string;
        tmp_token?: string;
        first_name?: string;
        last_name?: string;
        number: string;
        expiry_month: number;
        expiry_year: number;
        cvv?: string;
        preferred_scheme?: string;
        billing_addr1?: string;
        billing_addr2?: string;
        billing_city?: string;
        billing_state_code?: string;
        billing_state?: string;
        billing_zip?: string;
        billing_country?: string;
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        ip_address?: string;
        customer?: customer_update_card_for_customer_params;
    }
    interface switch_gateway_for_customer_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        gateway?: string;
        gateway_account_id: string;
    }
    interface copy_card_for_customer_params {
        gateway_account_id: string;
    }
    interface customer_update_card_for_customer_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        vat_number?: string;
    }
}
