"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Card = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class Card extends model_1.Model {
    // OPERATIONS
    //-----------
    static retrieve(card_id, params) {
        return new request_wrapper_1.RequestWrapper([card_id, params], {
            'methodName': 'retrieve',
            'httpMethod': 'GET',
            'urlPrefix': '/cards',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static update_card_for_customer(customer_id, params) {
        return new request_wrapper_1.RequestWrapper([customer_id, params], {
            'methodName': 'update_card_for_customer',
            'httpMethod': 'POST',
            'urlPrefix': '/customers',
            'urlSuffix': '/credit_card',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static switch_gateway_for_customer(customer_id, params) {
        return new request_wrapper_1.RequestWrapper([customer_id, params], {
            'methodName': 'switch_gateway_for_customer',
            'httpMethod': 'POST',
            'urlPrefix': '/customers',
            'urlSuffix': '/switch_gateway',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static copy_card_for_customer(customer_id, params) {
        return new request_wrapper_1.RequestWrapper([customer_id, params], {
            'methodName': 'copy_card_for_customer',
            'httpMethod': 'POST',
            'urlPrefix': '/customers',
            'urlSuffix': '/copy_card',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static delete_card_for_customer(customer_id, params) {
        return new request_wrapper_1.RequestWrapper([customer_id, params], {
            'methodName': 'delete_card_for_customer',
            'httpMethod': 'POST',
            'urlPrefix': '/customers',
            'urlSuffix': '/delete_card',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~Card
exports.Card = Card;
