import { ListResult } from '../list_result';
import { RequestWrapper } from "../request_wrapper";
import { Model } from "./model";
import { filter } from "../filter";
export declare class Comment extends Model {
    id: string;
    entity_type: string;
    added_by?: string;
    notes: string;
    created_at: number;
    type: string;
    entity_id: string;
    static create(params?: _comment.create_params): RequestWrapper;
    static retrieve(comment_id: string, params?: any): RequestWrapper;
    static list(params?: _comment.comment_list_params): RequestWrapper<ListResult>;
    static delete(comment_id: string, params?: any): RequestWrapper;
}
export declare namespace _comment {
    interface create_params {
        entity_type: string;
        entity_id: string;
        notes: string;
        added_by?: string;
    }
    interface comment_list_params {
        limit?: number;
        offset?: string;
        entity_type?: string;
        entity_id?: string;
        created_at?: filter._timestamp;
        "sort_by[asc]"?: string;
        "sort_by[desc]"?: string;
    }
}
