import { ListResult } from '../list_result';
import { RequestWrapper } from "../request_wrapper";
import { Model } from "./model";
import { filter } from "../filter";
export declare class CouponSet extends Model {
    id: string;
    coupon_id: string;
    name: string;
    total_count?: number;
    redeemed_count?: number;
    archived_count?: number;
    meta_data?: any;
    static create(params?: _coupon_set.create_params): RequestWrapper;
    static add_coupon_codes(coupon_set_id: string, params?: _coupon_set.add_coupon_codes_params): RequestWrapper;
    static list(params?: _coupon_set.coupon_set_list_params): RequestWrapper<ListResult>;
    static retrieve(coupon_set_id: string, params?: any): RequestWrapper;
    static update(coupon_set_id: string, params?: _coupon_set.update_params): RequestWrapper;
    static delete(coupon_set_id: string, params?: any): RequestWrapper;
    static delete_unused_coupon_codes(coupon_set_id: string, params?: any): RequestWrapper;
}
export declare namespace _coupon_set {
    interface create_params {
        coupon_id: string;
        name: string;
        id: string;
        meta_data?: any;
    }
    interface add_coupon_codes_params {
        code?: Array<string>;
    }
    interface coupon_set_list_params {
        limit?: number;
        offset?: string;
        id?: filter._string;
        name?: filter._string;
        coupon_id?: filter._string;
        total_count?: filter._number;
        redeemed_count?: filter._number;
        archived_count?: filter._number;
    }
    interface update_params {
        name?: string;
        meta_data?: any;
    }
}
