"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CouponSet = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class CouponSet extends model_1.Model {
    // OPERATIONS
    //-----------
    static create(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create',
            'httpMethod': 'POST',
            'urlPrefix': '/coupon_sets',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "meta_data": 0,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static add_coupon_codes(coupon_set_id, params) {
        return new request_wrapper_1.RequestWrapper([coupon_set_id, params], {
            'methodName': 'add_coupon_codes',
            'httpMethod': 'POST',
            'urlPrefix': '/coupon_sets',
            'urlSuffix': '/add_coupon_codes',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static list(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'list',
            'httpMethod': 'GET',
            'urlPrefix': '/coupon_sets',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static retrieve(coupon_set_id, params) {
        return new request_wrapper_1.RequestWrapper([coupon_set_id, params], {
            'methodName': 'retrieve',
            'httpMethod': 'GET',
            'urlPrefix': '/coupon_sets',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static update(coupon_set_id, params) {
        return new request_wrapper_1.RequestWrapper([coupon_set_id, params], {
            'methodName': 'update',
            'httpMethod': 'POST',
            'urlPrefix': '/coupon_sets',
            'urlSuffix': '/update',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "meta_data": 0,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static delete(coupon_set_id, params) {
        return new request_wrapper_1.RequestWrapper([coupon_set_id, params], {
            'methodName': 'delete',
            'httpMethod': 'POST',
            'urlPrefix': '/coupon_sets',
            'urlSuffix': '/delete',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static delete_unused_coupon_codes(coupon_set_id, params) {
        return new request_wrapper_1.RequestWrapper([coupon_set_id, params], {
            'methodName': 'delete_unused_coupon_codes',
            'httpMethod': 'POST',
            'urlPrefix': '/coupon_sets',
            'urlSuffix': '/delete_unused_coupon_codes',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~CouponSet
exports.CouponSet = CouponSet;
