"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LineItemAddress = exports.TaxOrigin = exports.SiteDetailsAtCreation = exports.BillingAddress = exports.ShippingAddress = exports.Allocation = exports.LinkedRefund = exports.LineItemTax = exports.Tax = exports.LineItemTier = exports.LineItemDiscount = exports.Discount = exports.LineItem = exports.Einvoice = exports.CreditNote = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class CreditNote extends model_1.Model {
    // OPERATIONS
    //-----------
    static create(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create',
            'httpMethod': 'POST',
            'urlPrefix': '/credit_notes',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static retrieve(credit_note_id, params) {
        return new request_wrapper_1.RequestWrapper([credit_note_id, params], {
            'methodName': 'retrieve',
            'httpMethod': 'GET',
            'urlPrefix': '/credit_notes',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static pdf(credit_note_id, params) {
        return new request_wrapper_1.RequestWrapper([credit_note_id, params], {
            'methodName': 'pdf',
            'httpMethod': 'POST',
            'urlPrefix': '/credit_notes',
            'urlSuffix': '/pdf',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static download_einvoice(credit_note_id, params) {
        return new request_wrapper_1.RequestWrapper([credit_note_id, params], {
            'methodName': 'download_einvoice',
            'httpMethod': 'GET',
            'urlPrefix': '/credit_notes',
            'urlSuffix': '/download_einvoice',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static refund(credit_note_id, params) {
        return new request_wrapper_1.RequestWrapper([credit_note_id, params], {
            'methodName': 'refund',
            'httpMethod': 'POST',
            'urlPrefix': '/credit_notes',
            'urlSuffix': '/refund',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static record_refund(credit_note_id, params) {
        return new request_wrapper_1.RequestWrapper([credit_note_id, params], {
            'methodName': 'record_refund',
            'httpMethod': 'POST',
            'urlPrefix': '/credit_notes',
            'urlSuffix': '/record_refund',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static void_credit_note(credit_note_id, params) {
        return new request_wrapper_1.RequestWrapper([credit_note_id, params], {
            'methodName': 'void_credit_note',
            'httpMethod': 'POST',
            'urlPrefix': '/credit_notes',
            'urlSuffix': '/void',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static list(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'list',
            'httpMethod': 'GET',
            'urlPrefix': '/credit_notes',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static credit_notes_for_customer(customer_id, params) {
        return new request_wrapper_1.RequestWrapper([customer_id, params], {
            'methodName': 'credit_notes_for_customer',
            'httpMethod': 'GET',
            'urlPrefix': '/customers',
            'urlSuffix': '/credit_notes',
            'hasIdInUrl': true,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static delete(credit_note_id, params) {
        return new request_wrapper_1.RequestWrapper([credit_note_id, params], {
            'methodName': 'delete',
            'httpMethod': 'POST',
            'urlPrefix': '/credit_notes',
            'urlSuffix': '/delete',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static remove_tax_withheld_refund(credit_note_id, params) {
        return new request_wrapper_1.RequestWrapper([credit_note_id, params], {
            'methodName': 'remove_tax_withheld_refund',
            'httpMethod': 'POST',
            'urlPrefix': '/credit_notes',
            'urlSuffix': '/remove_tax_withheld_refund',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static resend_einvoice(credit_note_id, params) {
        return new request_wrapper_1.RequestWrapper([credit_note_id, params], {
            'methodName': 'resend_einvoice',
            'httpMethod': 'POST',
            'urlPrefix': '/credit_notes',
            'urlSuffix': '/resend_einvoice',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static send_einvoice(credit_note_id, params) {
        return new request_wrapper_1.RequestWrapper([credit_note_id, params], {
            'methodName': 'send_einvoice',
            'httpMethod': 'POST',
            'urlPrefix': '/credit_notes',
            'urlSuffix': '/send_einvoice',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static import_credit_note(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'import_credit_note',
            'httpMethod': 'POST',
            'urlPrefix': '/credit_notes',
            'urlSuffix': '/import_credit_note',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~CreditNote
exports.CreditNote = CreditNote;
class Einvoice extends model_1.Model {
} // ~Einvoice
exports.Einvoice = Einvoice;
class LineItem extends model_1.Model {
} // ~LineItem
exports.LineItem = LineItem;
class Discount extends model_1.Model {
} // ~Discount
exports.Discount = Discount;
class LineItemDiscount extends model_1.Model {
} // ~LineItemDiscount
exports.LineItemDiscount = LineItemDiscount;
class LineItemTier extends model_1.Model {
} // ~LineItemTier
exports.LineItemTier = LineItemTier;
class Tax extends model_1.Model {
} // ~Tax
exports.Tax = Tax;
class LineItemTax extends model_1.Model {
} // ~LineItemTax
exports.LineItemTax = LineItemTax;
class LinkedRefund extends model_1.Model {
} // ~LinkedRefund
exports.LinkedRefund = LinkedRefund;
class Allocation extends model_1.Model {
} // ~Allocation
exports.Allocation = Allocation;
class ShippingAddress extends model_1.Model {
} // ~ShippingAddress
exports.ShippingAddress = ShippingAddress;
class BillingAddress extends model_1.Model {
} // ~BillingAddress
exports.BillingAddress = BillingAddress;
class SiteDetailsAtCreation extends model_1.Model {
} // ~SiteDetailsAtCreation
exports.SiteDetailsAtCreation = SiteDetailsAtCreation;
class TaxOrigin extends model_1.Model {
} // ~TaxOrigin
exports.TaxOrigin = TaxOrigin;
class LineItemAddress extends model_1.Model {
} // ~LineItemAddress
exports.LineItemAddress = LineItemAddress;
