import { Model } from "./model";
export declare class CreditNoteEstimate extends Model {
    reference_invoice_id: string;
    type: string;
    price_type: string;
    currency_code: string;
    sub_total: number;
    total: number;
    amount_allocated: number;
    amount_available: number;
    line_items?: Array<LineItem>;
    discounts?: Array<Discount>;
    taxes?: Array<Tax>;
    line_item_taxes?: Array<LineItemTax>;
    line_item_discounts?: Array<LineItemDiscount>;
    line_item_tiers?: Array<LineItemTier>;
    round_off_amount?: number;
    customer_id?: string;
}
export declare class LineItem extends Model {
    id?: string;
    subscription_id?: string;
    date_from: number;
    date_to: number;
    unit_amount: number;
    quantity?: number;
    amount?: number;
    pricing_model?: string;
    is_taxed: boolean;
    tax_amount?: number;
    tax_rate?: number;
    unit_amount_in_decimal?: string;
    quantity_in_decimal?: string;
    amount_in_decimal?: string;
    discount_amount?: number;
    item_level_discount_amount?: number;
    metered?: boolean;
    is_percentage_pricing?: boolean;
    reference_line_item_id?: string;
    description: string;
    entity_description?: string;
    entity_type: string;
    tax_exempt_reason?: string;
    entity_id?: string;
    customer_id?: string;
}
export declare class Discount extends Model {
    amount: number;
    description?: string;
    entity_type: string;
    discount_type?: string;
    entity_id?: string;
    coupon_set_code?: string;
}
export declare class Tax extends Model {
    name: string;
    amount: number;
    description?: string;
}
export declare class LineItemTax extends Model {
    line_item_id?: string;
    tax_name: string;
    tax_rate: number;
    date_to?: number;
    date_from?: number;
    prorated_taxable_amount?: number;
    is_partial_tax_applied?: boolean;
    is_non_compliance_tax?: boolean;
    taxable_amount: number;
    tax_amount: number;
    tax_juris_type?: string;
    tax_juris_name?: string;
    tax_juris_code?: string;
    tax_amount_in_local_currency?: number;
    local_currency_code?: string;
}
export declare class LineItemDiscount extends Model {
    line_item_id: string;
    discount_type: string;
    coupon_id?: string;
    entity_id?: string;
    discount_amount: number;
}
export declare class LineItemTier extends Model {
    line_item_id?: string;
    starting_unit: number;
    ending_unit?: number;
    quantity_used: number;
    unit_amount: number;
    starting_unit_in_decimal?: string;
    ending_unit_in_decimal?: string;
    quantity_used_in_decimal?: string;
    unit_amount_in_decimal?: string;
    pricing_type?: string;
    package_size?: number;
}
export declare namespace _credit_note_estimate {
}
