import { RequestWrapper } from "../request_wrapper";
import { Model } from "./model";
export declare class Currency extends Model {
    id?: string;
    enabled: boolean;
    forex_type?: string;
    currency_code?: string;
    is_base_currency?: boolean;
    manual_exchange_rate?: string;
    static list(params?: any): RequestWrapper;
    static retrieve(currency_id: string, params?: any): RequestWrapper;
    static create(params?: _currency.create_params): RequestWrapper;
    static update(currency_id: string, params?: _currency.update_params): RequestWrapper;
    static add_schedule(currency_id: string, params?: _currency.add_schedule_params): RequestWrapper;
    static remove_schedule(currency_id: string, params?: any): RequestWrapper;
}
export declare namespace _currency {
    interface create_params {
        currency_code: string;
        forex_type: string;
        manual_exchange_rate?: string;
    }
    interface update_params {
        forex_type: string;
        manual_exchange_rate?: string;
    }
    interface add_schedule_params {
        manual_exchange_rate: string;
        schedule_at: number;
    }
}
