"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Currency = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class Currency extends model_1.Model {
    // OPERATIONS
    //-----------
    static list(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'list',
            'httpMethod': 'GET',
            'urlPrefix': '/currencies',
            'urlSuffix': '/list',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static retrieve(currency_id, params) {
        return new request_wrapper_1.RequestWrapper([currency_id, params], {
            'methodName': 'retrieve',
            'httpMethod': 'GET',
            'urlPrefix': '/currencies',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static create(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create',
            'httpMethod': 'POST',
            'urlPrefix': '/currencies',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static update(currency_id, params) {
        return new request_wrapper_1.RequestWrapper([currency_id, params], {
            'methodName': 'update',
            'httpMethod': 'POST',
            'urlPrefix': '/currencies',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static add_schedule(currency_id, params) {
        return new request_wrapper_1.RequestWrapper([currency_id, params], {
            'methodName': 'add_schedule',
            'httpMethod': 'POST',
            'urlPrefix': '/currencies',
            'urlSuffix': '/add_schedule',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static remove_schedule(currency_id, params) {
        return new request_wrapper_1.RequestWrapper([currency_id, params], {
            'methodName': 'remove_schedule',
            'httpMethod': 'POST',
            'urlPrefix': '/currencies',
            'urlSuffix': '/remove_schedule',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~Currency
exports.Currency = Currency;
