"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomerEntitlement = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class CustomerEntitlement extends model_1.Model {
    // OPERATIONS
    //-----------
    static entitlements_for_customer(customer_id, params) {
        return new request_wrapper_1.RequestWrapper([customer_id, params], {
            'methodName': 'entitlements_for_customer',
            'httpMethod': 'GET',
            'urlPrefix': '/customers',
            'urlSuffix': '/customer_entitlements',
            'hasIdInUrl': true,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~CustomerEntitlement
exports.CustomerEntitlement = CustomerEntitlement;
