"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParentPeriod = exports.Tier = exports.DifferentialPrice = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class DifferentialPrice extends model_1.Model {
    // OPERATIONS
    //-----------
    static create(item_price_id, params) {
        return new request_wrapper_1.RequestWrapper([item_price_id, params], {
            'methodName': 'create',
            'httpMethod': 'POST',
            'urlPrefix': '/item_prices',
            'urlSuffix': '/differential_prices',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "period": 1,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static retrieve(differential_price_id, params) {
        return new request_wrapper_1.RequestWrapper([differential_price_id, params], {
            'methodName': 'retrieve',
            'httpMethod': 'GET',
            'urlPrefix': '/differential_prices',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static update(differential_price_id, params) {
        return new request_wrapper_1.RequestWrapper([differential_price_id, params], {
            'methodName': 'update',
            'httpMethod': 'POST',
            'urlPrefix': '/differential_prices',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "period": 1,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static delete(differential_price_id, params) {
        return new request_wrapper_1.RequestWrapper([differential_price_id, params], {
            'methodName': 'delete',
            'httpMethod': 'POST',
            'urlPrefix': '/differential_prices',
            'urlSuffix': '/delete',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static list(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'list',
            'httpMethod': 'GET',
            'urlPrefix': '/differential_prices',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~DifferentialPrice
exports.DifferentialPrice = DifferentialPrice;
class Tier extends model_1.Model {
} // ~Tier
exports.Tier = Tier;
class ParentPeriod extends model_1.Model {
} // ~ParentPeriod
exports.ParentPeriod = ParentPeriod;
