import { ListResult } from '../list_result';
import { RequestWrapper } from "../request_wrapper";
import { Model } from "./model";
import { filter } from "../filter";
export declare class Entitlement extends Model {
    id: string;
    entity_id?: string;
    entity_type?: string;
    feature_id?: string;
    feature_name?: string;
    value?: string;
    name?: string;
    static list(params?: _entitlement.entitlement_list_params): RequestWrapper<ListResult>;
    static create(params?: _entitlement.create_params): RequestWrapper;
}
export declare namespace _entitlement {
    interface entitlement_list_params {
        limit?: number;
        offset?: string;
        feature_id?: filter._string;
        entity_type?: filter._enum;
        entity_id?: filter._string;
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        include_drafts?: boolean;
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        embed?: string;
    }
    interface create_params {
        action: string;
        entitlements?: Array<entitlements_create_params>;
    }
    interface entitlements_create_params {
        entity_id: string;
    }
    interface entitlements_create_params {
        feature_id: string;
    }
    interface entitlements_create_params {
        entity_type?: string;
    }
    interface entitlements_create_params {
        value?: string;
    }
}
