"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EntitlementOverride = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class EntitlementOverride extends model_1.Model {
    // OPERATIONS
    //-----------
    static add_entitlement_override_for_subscription(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'add_entitlement_override_for_subscription',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/entitlement_overrides',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static list_entitlement_override_for_subscription(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'list_entitlement_override_for_subscription',
            'httpMethod': 'GET',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/entitlement_overrides',
            'hasIdInUrl': true,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~EntitlementOverride
exports.EntitlementOverride = EntitlementOverride;
