import * as resources from ".";
import { RequestWrapper } from "../request_wrapper";
import { Model } from "./model";
export declare class Estimate extends Model {
    created_at: number;
    subscription_estimate?: resources.SubscriptionEstimate;
    subscription_estimates?: Array<resources.SubscriptionEstimate>;
    invoice_estimate?: resources.InvoiceEstimate;
    invoice_estimates?: Array<resources.InvoiceEstimate>;
    payment_schedule_estimates?: Array<resources.PaymentScheduleEstimate>;
    next_invoice_estimate?: resources.InvoiceEstimate;
    credit_note_estimates?: Array<resources.CreditNoteEstimate>;
    unbilled_charge_estimates?: Array<resources.UnbilledCharge>;
    static create_subscription(params?: _estimate.create_subscription_params): RequestWrapper;
    static create_sub_item_estimate(params?: _estimate.create_sub_item_estimate_params): RequestWrapper;
    static create_sub_for_customer_estimate(customer_id: string, params?: _estimate.create_sub_for_customer_estimate_params): RequestWrapper;
    static create_sub_item_for_customer_estimate(customer_id: string, params?: _estimate.create_sub_item_for_customer_estimate_params): RequestWrapper;
    static update_subscription(params?: _estimate.update_subscription_params): RequestWrapper;
    static update_subscription_for_items(params?: _estimate.update_subscription_for_items_params): RequestWrapper;
    static renewal_estimate(subscription_id: string, params?: _estimate.renewal_estimate_params): RequestWrapper;
    static advance_invoice_estimate(subscription_id: string, params?: _estimate.advance_invoice_estimate_params): RequestWrapper;
    static regenerate_invoice_estimate(subscription_id: string, params?: _estimate.regenerate_invoice_estimate_params): RequestWrapper;
    static upcoming_invoices_estimate(customer_id: string, params?: any): RequestWrapper;
    static change_term_end(subscription_id: string, params?: _estimate.change_term_end_params): RequestWrapper;
    static cancel_subscription(subscription_id: string, params?: _estimate.cancel_subscription_params): RequestWrapper;
    static cancel_subscription_for_items(subscription_id: string, params?: _estimate.cancel_subscription_for_items_params): RequestWrapper;
    static pause_subscription(subscription_id: string, params?: _estimate.pause_subscription_params): RequestWrapper;
    static resume_subscription(subscription_id: string, params?: _estimate.resume_subscription_params): RequestWrapper;
    static gift_subscription(params?: _estimate.gift_subscription_params): RequestWrapper;
    static gift_subscription_for_items(params?: _estimate.gift_subscription_for_items_params): RequestWrapper;
    static create_invoice(params?: _estimate.create_invoice_params): RequestWrapper;
    static create_invoice_for_items(params?: _estimate.create_invoice_for_items_params): RequestWrapper;
    static payment_schedules(params?: _estimate.payment_schedules_params): RequestWrapper;
}
export declare namespace _estimate {
    interface create_subscription_params {
        billing_cycles?: number;
        mandatory_addons_to_remove?: Array<string>;
        terms_to_charge?: number;
        billing_alignment_mode?: string;
        coupon_ids?: Array<string>;
        invoice_immediately?: boolean;
        invoice_date?: number;
        client_profile_id?: string;
        subscription?: subscription_create_subscription_params;
        billing_address?: billing_address_create_subscription_params;
        shipping_address?: shipping_address_create_subscription_params;
        customer?: customer_create_subscription_params;
        contract_term?: contract_term_create_subscription_params;
        addons?: Array<addons_create_subscription_params>;
        event_based_addons?: Array<event_based_addons_create_subscription_params>;
        tax_providers_fields?: Array<tax_providers_fields_create_subscription_params>;
    }
    interface create_sub_item_estimate_params {
        billing_cycles?: number;
        mandatory_items_to_remove?: Array<string>;
        terms_to_charge?: number;
        billing_alignment_mode?: string;
        coupon_ids?: Array<string>;
        invoice_immediately?: boolean;
        invoice_date?: number;
        client_profile_id?: string;
        subscription?: subscription_create_sub_item_estimate_params;
        billing_address?: billing_address_create_sub_item_estimate_params;
        shipping_address?: shipping_address_create_sub_item_estimate_params;
        customer?: customer_create_sub_item_estimate_params;
        contract_term?: contract_term_create_sub_item_estimate_params;
        subscription_items?: Array<subscription_items_create_sub_item_estimate_params>;
        discounts?: Array<discounts_create_sub_item_estimate_params>;
        item_tiers?: Array<item_tiers_create_sub_item_estimate_params>;
        tax_providers_fields?: Array<tax_providers_fields_create_sub_item_estimate_params>;
    }
    interface create_sub_for_customer_estimate_params {
        use_existing_balances?: boolean;
        invoice_immediately?: boolean;
        billing_cycles?: number;
        mandatory_addons_to_remove?: Array<string>;
        terms_to_charge?: number;
        billing_alignment_mode?: string;
        invoice_date?: number;
        coupon_ids?: Array<string>;
        subscription?: subscription_create_sub_for_customer_estimate_params;
        shipping_address?: shipping_address_create_sub_for_customer_estimate_params;
        contract_term?: contract_term_create_sub_for_customer_estimate_params;
        addons?: Array<addons_create_sub_for_customer_estimate_params>;
        event_based_addons?: Array<event_based_addons_create_sub_for_customer_estimate_params>;
    }
    interface create_sub_item_for_customer_estimate_params {
        use_existing_balances?: boolean;
        invoice_immediately?: boolean;
        billing_cycles?: number;
        mandatory_items_to_remove?: Array<string>;
        terms_to_charge?: number;
        billing_alignment_mode?: string;
        invoice_date?: number;
        coupon_ids?: Array<string>;
        subscription?: subscription_create_sub_item_for_customer_estimate_params;
        shipping_address?: shipping_address_create_sub_item_for_customer_estimate_params;
        billing_address?: billing_address_create_sub_item_for_customer_estimate_params;
        contract_term?: contract_term_create_sub_item_for_customer_estimate_params;
        billing_override?: billing_override_create_sub_item_for_customer_estimate_params;
        subscription_items?: Array<subscription_items_create_sub_item_for_customer_estimate_params>;
        discounts?: Array<discounts_create_sub_item_for_customer_estimate_params>;
        item_tiers?: Array<item_tiers_create_sub_item_for_customer_estimate_params>;
    }
    interface update_subscription_params {
        changes_scheduled_at?: number;
        change_option?: string;
        replace_addon_list?: boolean;
        mandatory_addons_to_remove?: Array<string>;
        invoice_date?: number;
        billing_cycles?: number;
        terms_to_charge?: number;
        reactivate_from?: number;
        billing_alignment_mode?: string;
        coupon_ids?: Array<string>;
        replace_coupon_list?: boolean;
        prorate?: boolean;
        end_of_term?: boolean;
        force_term_reset?: boolean;
        reactivate?: boolean;
        include_delayed_charges?: boolean;
        use_existing_balances?: boolean;
        invoice_immediately?: boolean;
        subscription?: subscription_update_subscription_params;
        billing_address?: billing_address_update_subscription_params;
        shipping_address?: shipping_address_update_subscription_params;
        customer?: customer_update_subscription_params;
        addons?: Array<addons_update_subscription_params>;
        event_based_addons?: Array<event_based_addons_update_subscription_params>;
    }
    interface update_subscription_for_items_params {
        changes_scheduled_at?: number;
        change_option?: string;
        mandatory_items_to_remove?: Array<string>;
        replace_items_list?: boolean;
        invoice_date?: number;
        billing_cycles?: number;
        terms_to_charge?: number;
        reactivate_from?: number;
        billing_alignment_mode?: string;
        coupon_ids?: Array<string>;
        replace_coupon_list?: boolean;
        prorate?: boolean;
        end_of_term?: boolean;
        force_term_reset?: boolean;
        reactivate?: boolean;
        include_delayed_charges?: boolean;
        use_existing_balances?: boolean;
        invoice_immediately?: boolean;
        invoice_usages?: boolean;
        subscription?: subscription_update_subscription_for_items_params;
        billing_address?: billing_address_update_subscription_for_items_params;
        shipping_address?: shipping_address_update_subscription_for_items_params;
        customer?: customer_update_subscription_for_items_params;
        billing_override?: billing_override_update_subscription_for_items_params;
        subscription_items?: Array<subscription_items_update_subscription_for_items_params>;
        discounts?: Array<discounts_update_subscription_for_items_params>;
        item_tiers?: Array<item_tiers_update_subscription_for_items_params>;
    }
    interface renewal_estimate_params {
        include_delayed_charges?: boolean;
        use_existing_balances?: boolean;
        ignore_scheduled_cancellation?: boolean;
        ignore_scheduled_changes?: boolean;
    }
    interface advance_invoice_estimate_params {
        terms_to_charge?: number;
        invoice_immediately?: boolean;
        schedule_type?: string;
        fixed_interval_schedule?: fixed_interval_schedule_advance_invoice_estimate_params;
        specific_dates_schedule?: Array<specific_dates_schedule_advance_invoice_estimate_params>;
    }
    interface regenerate_invoice_estimate_params {
        date_from?: number;
        date_to?: number;
        prorate?: boolean;
        invoice_immediately?: boolean;
    }
    interface change_term_end_params {
        term_ends_at: number;
        prorate?: boolean;
        invoice_immediately?: boolean;
    }
    interface cancel_subscription_params {
        cancel_option?: string;
        end_of_term?: boolean;
        cancel_at?: number;
        credit_option_for_current_term_charges?: string;
        unbilled_charges_option?: string;
        account_receivables_handling?: string;
        refundable_credits_handling?: string;
        contract_term_cancel_option?: string;
        invoice_date?: number;
        cancel_reason_code?: string;
        event_based_addons?: Array<event_based_addons_cancel_subscription_params>;
    }
    interface cancel_subscription_for_items_params {
        cancel_option?: string;
        end_of_term?: boolean;
        cancel_at?: number;
        credit_option_for_current_term_charges?: string;
        unbilled_charges_option?: string;
        account_receivables_handling?: string;
        refundable_credits_handling?: string;
        contract_term_cancel_option?: string;
        invoice_date?: number;
        cancel_reason_code?: string;
        subscription_items?: Array<subscription_items_cancel_subscription_for_items_params>;
    }
    interface pause_subscription_params {
        pause_option?: string;
        unbilled_charges_handling?: string;
        subscription?: subscription_pause_subscription_params;
    }
    interface resume_subscription_params {
        resume_option?: string;
        charges_handling?: string;
        subscription?: subscription_resume_subscription_params;
    }
    interface gift_subscription_params {
        coupon_ids?: Array<string>;
        gift?: gift_gift_subscription_params;
        gifter?: gifter_gift_subscription_params;
        gift_receiver?: gift_receiver_gift_subscription_params;
        payment_intent?: payment_intent_gift_subscription_params;
        shipping_address?: shipping_address_gift_subscription_params;
        subscription?: subscription_gift_subscription_params;
        addons?: Array<addons_gift_subscription_params>;
    }
    interface gift_subscription_for_items_params {
        coupon_ids?: Array<string>;
        gift?: gift_gift_subscription_for_items_params;
        gifter?: gifter_gift_subscription_for_items_params;
        gift_receiver?: gift_receiver_gift_subscription_for_items_params;
        payment_intent?: payment_intent_gift_subscription_for_items_params;
        shipping_address?: shipping_address_gift_subscription_for_items_params;
        subscription_items?: Array<subscription_items_gift_subscription_for_items_params>;
    }
    interface create_invoice_params {
        currency_code?: string;
        invoice_note?: string;
        remove_general_note?: boolean;
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        coupon?: string;
        coupon_ids?: Array<string>;
        authorization_transaction_id?: string;
        payment_source_id?: string;
        auto_collection?: string;
        invoice_date?: number;
        invoice?: invoice_create_invoice_params;
        shipping_address?: shipping_address_create_invoice_params;
        addons?: Array<addons_create_invoice_params>;
        charges?: Array<charges_create_invoice_params>;
        notes_to_remove?: Array<notes_to_remove_create_invoice_params>;
        tax_providers_fields?: Array<tax_providers_fields_create_invoice_params>;
    }
    interface create_invoice_for_items_params {
        currency_code?: string;
        invoice_note?: string;
        remove_general_note?: boolean;
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        coupon?: string;
        coupon_ids?: Array<string>;
        authorization_transaction_id?: string;
        payment_source_id?: string;
        auto_collection?: string;
        invoice_date?: number;
        invoice?: invoice_create_invoice_for_items_params;
        shipping_address?: shipping_address_create_invoice_for_items_params;
        billing_address?: billing_address_create_invoice_for_items_params;
        item_prices?: Array<item_prices_create_invoice_for_items_params>;
        item_tiers?: Array<item_tiers_create_invoice_for_items_params>;
        charges?: Array<charges_create_invoice_for_items_params>;
        notes_to_remove?: Array<notes_to_remove_create_invoice_for_items_params>;
        discounts?: Array<discounts_create_invoice_for_items_params>;
        tax_providers_fields?: Array<tax_providers_fields_create_invoice_for_items_params>;
    }
    interface payment_schedules_params {
        scheme_id: string;
        amount?: number;
        invoice_id?: string;
        payment_schedule_start_date?: number;
    }
    interface subscription_create_subscription_params {
        id?: string;
    }
    interface subscription_create_subscription_params {
        plan_id: string;
    }
    interface subscription_create_subscription_params {
        plan_quantity?: number;
    }
    interface subscription_create_subscription_params {
        plan_quantity_in_decimal?: string;
    }
    interface subscription_create_subscription_params {
        plan_unit_price?: number;
    }
    interface subscription_create_subscription_params {
        plan_unit_price_in_decimal?: string;
    }
    interface subscription_create_subscription_params {
        setup_fee?: number;
    }
    interface subscription_create_subscription_params {
        trial_end?: number;
    }
    interface subscription_create_subscription_params {
        start_date?: number;
    }
    interface subscription_create_subscription_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        coupon?: string;
    }
    interface subscription_create_subscription_params {
        offline_payment_method?: string;
    }
    interface subscription_create_subscription_params {
        free_period?: number;
    }
    interface subscription_create_subscription_params {
        free_period_unit?: string;
    }
    interface subscription_create_subscription_params {
        contract_term_billing_cycle_on_renewal?: number;
    }
    interface subscription_create_subscription_params {
        trial_end_action?: string;
    }
    interface billing_address_create_subscription_params {
        line1?: string;
    }
    interface billing_address_create_subscription_params {
        line2?: string;
    }
    interface billing_address_create_subscription_params {
        line3?: string;
    }
    interface billing_address_create_subscription_params {
        city?: string;
    }
    interface billing_address_create_subscription_params {
        state_code?: string;
    }
    interface billing_address_create_subscription_params {
        zip?: string;
    }
    interface billing_address_create_subscription_params {
        country?: string;
    }
    interface billing_address_create_subscription_params {
        validation_status?: string;
    }
    interface shipping_address_create_subscription_params {
        line1?: string;
    }
    interface shipping_address_create_subscription_params {
        line2?: string;
    }
    interface shipping_address_create_subscription_params {
        line3?: string;
    }
    interface shipping_address_create_subscription_params {
        city?: string;
    }
    interface shipping_address_create_subscription_params {
        state_code?: string;
    }
    interface shipping_address_create_subscription_params {
        zip?: string;
    }
    interface shipping_address_create_subscription_params {
        country?: string;
    }
    interface shipping_address_create_subscription_params {
        validation_status?: string;
    }
    interface customer_create_subscription_params {
        vat_number?: string;
    }
    interface customer_create_subscription_params {
        vat_number_prefix?: string;
    }
    interface customer_create_subscription_params {
        registered_for_gst?: boolean;
    }
    interface customer_create_subscription_params {
        taxability?: string;
    }
    interface customer_create_subscription_params {
        entity_code?: string;
    }
    interface customer_create_subscription_params {
        exempt_number?: string;
    }
    interface customer_create_subscription_params {
        exemption_details?: any;
    }
    interface customer_create_subscription_params {
        customer_type?: string;
    }
    interface contract_term_create_subscription_params {
        action_at_term_end?: string;
    }
    interface contract_term_create_subscription_params {
        cancellation_cutoff_period?: number;
    }
    interface addons_create_subscription_params {
        id?: string;
    }
    interface addons_create_subscription_params {
        quantity?: number;
    }
    interface addons_create_subscription_params {
        quantity_in_decimal?: string;
    }
    interface addons_create_subscription_params {
        unit_price?: number;
    }
    interface addons_create_subscription_params {
        unit_price_in_decimal?: string;
    }
    interface addons_create_subscription_params {
        billing_cycles?: number;
    }
    interface event_based_addons_create_subscription_params {
        id?: string;
    }
    interface event_based_addons_create_subscription_params {
        quantity?: number;
    }
    interface event_based_addons_create_subscription_params {
        unit_price?: number;
    }
    interface event_based_addons_create_subscription_params {
        quantity_in_decimal?: string;
    }
    interface event_based_addons_create_subscription_params {
        unit_price_in_decimal?: string;
    }
    interface event_based_addons_create_subscription_params {
        service_period_in_days?: number;
    }
    interface event_based_addons_create_subscription_params {
        on_event?: string;
    }
    interface event_based_addons_create_subscription_params {
        charge_once?: boolean;
    }
    interface event_based_addons_create_subscription_params {
        charge_on?: string;
    }
    interface addons_create_subscription_params {
        trial_end?: number;
    }
    interface tax_providers_fields_create_subscription_params {
        provider_name?: string;
    }
    interface tax_providers_fields_create_subscription_params {
        field_id?: string;
    }
    interface tax_providers_fields_create_subscription_params {
        field_value?: string;
    }
    interface subscription_create_sub_item_estimate_params {
        id?: string;
    }
    interface subscription_create_sub_item_estimate_params {
        trial_end?: number;
    }
    interface subscription_create_sub_item_estimate_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        setup_fee?: number;
    }
    interface subscription_create_sub_item_estimate_params {
        start_date?: number;
    }
    interface subscription_create_sub_item_estimate_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        coupon?: string;
    }
    interface subscription_create_sub_item_estimate_params {
        free_period?: number;
    }
    interface subscription_create_sub_item_estimate_params {
        free_period_unit?: string;
    }
    interface subscription_create_sub_item_estimate_params {
        contract_term_billing_cycle_on_renewal?: number;
    }
    interface subscription_create_sub_item_estimate_params {
        trial_end_action?: string;
    }
    interface billing_address_create_sub_item_estimate_params {
        line1?: string;
    }
    interface billing_address_create_sub_item_estimate_params {
        line2?: string;
    }
    interface billing_address_create_sub_item_estimate_params {
        line3?: string;
    }
    interface billing_address_create_sub_item_estimate_params {
        city?: string;
    }
    interface billing_address_create_sub_item_estimate_params {
        state_code?: string;
    }
    interface billing_address_create_sub_item_estimate_params {
        zip?: string;
    }
    interface billing_address_create_sub_item_estimate_params {
        country?: string;
    }
    interface billing_address_create_sub_item_estimate_params {
        validation_status?: string;
    }
    interface shipping_address_create_sub_item_estimate_params {
        line1?: string;
    }
    interface shipping_address_create_sub_item_estimate_params {
        line2?: string;
    }
    interface shipping_address_create_sub_item_estimate_params {
        line3?: string;
    }
    interface shipping_address_create_sub_item_estimate_params {
        city?: string;
    }
    interface shipping_address_create_sub_item_estimate_params {
        state_code?: string;
    }
    interface shipping_address_create_sub_item_estimate_params {
        zip?: string;
    }
    interface shipping_address_create_sub_item_estimate_params {
        country?: string;
    }
    interface shipping_address_create_sub_item_estimate_params {
        validation_status?: string;
    }
    interface customer_create_sub_item_estimate_params {
        vat_number?: string;
    }
    interface customer_create_sub_item_estimate_params {
        vat_number_prefix?: string;
    }
    interface customer_create_sub_item_estimate_params {
        registered_for_gst?: boolean;
    }
    interface customer_create_sub_item_estimate_params {
        taxability?: string;
    }
    interface customer_create_sub_item_estimate_params {
        entity_code?: string;
    }
    interface customer_create_sub_item_estimate_params {
        exempt_number?: string;
    }
    interface customer_create_sub_item_estimate_params {
        exemption_details?: any;
    }
    interface customer_create_sub_item_estimate_params {
        customer_type?: string;
    }
    interface contract_term_create_sub_item_estimate_params {
        action_at_term_end?: string;
    }
    interface contract_term_create_sub_item_estimate_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        contract_start?: number;
    }
    interface contract_term_create_sub_item_estimate_params {
        cancellation_cutoff_period?: number;
    }
    interface subscription_items_create_sub_item_estimate_params {
        item_price_id: string;
    }
    interface subscription_items_create_sub_item_estimate_params {
        quantity?: number;
    }
    interface subscription_items_create_sub_item_estimate_params {
        quantity_in_decimal?: string;
    }
    interface subscription_items_create_sub_item_estimate_params {
        unit_price?: number;
    }
    interface subscription_items_create_sub_item_estimate_params {
        unit_price_in_decimal?: string;
    }
    interface subscription_items_create_sub_item_estimate_params {
        billing_cycles?: number;
    }
    interface subscription_items_create_sub_item_estimate_params {
        trial_end?: number;
    }
    interface subscription_items_create_sub_item_estimate_params {
        service_period_days?: number;
    }
    interface subscription_items_create_sub_item_estimate_params {
        charge_on_event?: string;
    }
    interface subscription_items_create_sub_item_estimate_params {
        charge_once?: boolean;
    }
    interface subscription_items_create_sub_item_estimate_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        item_type?: string;
    }
    interface discounts_create_sub_item_estimate_params {
        apply_on?: string;
    }
    interface discounts_create_sub_item_estimate_params {
        duration_type: string;
    }
    interface discounts_create_sub_item_estimate_params {
        percentage?: number;
    }
    interface discounts_create_sub_item_estimate_params {
        amount?: number;
    }
    interface discounts_create_sub_item_estimate_params {
        period?: number;
    }
    interface discounts_create_sub_item_estimate_params {
        period_unit?: string;
    }
    interface discounts_create_sub_item_estimate_params {
        included_in_mrr?: boolean;
    }
    interface discounts_create_sub_item_estimate_params {
        item_price_id?: string;
    }
    interface subscription_items_create_sub_item_estimate_params {
        charge_on_option?: string;
    }
    interface item_tiers_create_sub_item_estimate_params {
        item_price_id?: string;
    }
    interface item_tiers_create_sub_item_estimate_params {
        starting_unit?: number;
    }
    interface item_tiers_create_sub_item_estimate_params {
        ending_unit?: number;
    }
    interface item_tiers_create_sub_item_estimate_params {
        price?: number;
    }
    interface item_tiers_create_sub_item_estimate_params {
        starting_unit_in_decimal?: string;
    }
    interface item_tiers_create_sub_item_estimate_params {
        ending_unit_in_decimal?: string;
    }
    interface item_tiers_create_sub_item_estimate_params {
        price_in_decimal?: string;
    }
    interface item_tiers_create_sub_item_estimate_params {
        pricing_type?: string;
    }
    interface item_tiers_create_sub_item_estimate_params {
        package_size?: number;
    }
    interface tax_providers_fields_create_sub_item_estimate_params {
        provider_name?: string;
    }
    interface tax_providers_fields_create_sub_item_estimate_params {
        field_id?: string;
    }
    interface tax_providers_fields_create_sub_item_estimate_params {
        field_value?: string;
    }
    interface subscription_create_sub_for_customer_estimate_params {
        id?: string;
    }
    interface subscription_create_sub_for_customer_estimate_params {
        plan_id: string;
    }
    interface subscription_create_sub_for_customer_estimate_params {
        plan_quantity?: number;
    }
    interface subscription_create_sub_for_customer_estimate_params {
        plan_quantity_in_decimal?: string;
    }
    interface subscription_create_sub_for_customer_estimate_params {
        plan_unit_price?: number;
    }
    interface subscription_create_sub_for_customer_estimate_params {
        plan_unit_price_in_decimal?: string;
    }
    interface subscription_create_sub_for_customer_estimate_params {
        setup_fee?: number;
    }
    interface subscription_create_sub_for_customer_estimate_params {
        trial_end?: number;
    }
    interface subscription_create_sub_for_customer_estimate_params {
        start_date?: number;
    }
    interface subscription_create_sub_for_customer_estimate_params {
        offline_payment_method?: string;
    }
    interface subscription_create_sub_for_customer_estimate_params {
        free_period?: number;
    }
    interface subscription_create_sub_for_customer_estimate_params {
        free_period_unit?: string;
    }
    interface subscription_create_sub_for_customer_estimate_params {
        contract_term_billing_cycle_on_renewal?: number;
    }
    interface subscription_create_sub_for_customer_estimate_params {
        trial_end_action?: string;
    }
    interface shipping_address_create_sub_for_customer_estimate_params {
        line1?: string;
    }
    interface shipping_address_create_sub_for_customer_estimate_params {
        line2?: string;
    }
    interface shipping_address_create_sub_for_customer_estimate_params {
        line3?: string;
    }
    interface shipping_address_create_sub_for_customer_estimate_params {
        city?: string;
    }
    interface shipping_address_create_sub_for_customer_estimate_params {
        state_code?: string;
    }
    interface shipping_address_create_sub_for_customer_estimate_params {
        zip?: string;
    }
    interface shipping_address_create_sub_for_customer_estimate_params {
        country?: string;
    }
    interface shipping_address_create_sub_for_customer_estimate_params {
        validation_status?: string;
    }
    interface contract_term_create_sub_for_customer_estimate_params {
        action_at_term_end?: string;
    }
    interface contract_term_create_sub_for_customer_estimate_params {
        cancellation_cutoff_period?: number;
    }
    interface addons_create_sub_for_customer_estimate_params {
        id?: string;
    }
    interface addons_create_sub_for_customer_estimate_params {
        quantity?: number;
    }
    interface addons_create_sub_for_customer_estimate_params {
        quantity_in_decimal?: string;
    }
    interface addons_create_sub_for_customer_estimate_params {
        unit_price?: number;
    }
    interface addons_create_sub_for_customer_estimate_params {
        unit_price_in_decimal?: string;
    }
    interface addons_create_sub_for_customer_estimate_params {
        billing_cycles?: number;
    }
    interface event_based_addons_create_sub_for_customer_estimate_params {
        id?: string;
    }
    interface event_based_addons_create_sub_for_customer_estimate_params {
        quantity?: number;
    }
    interface event_based_addons_create_sub_for_customer_estimate_params {
        unit_price?: number;
    }
    interface event_based_addons_create_sub_for_customer_estimate_params {
        quantity_in_decimal?: string;
    }
    interface event_based_addons_create_sub_for_customer_estimate_params {
        unit_price_in_decimal?: string;
    }
    interface event_based_addons_create_sub_for_customer_estimate_params {
        service_period_in_days?: number;
    }
    interface event_based_addons_create_sub_for_customer_estimate_params {
        on_event?: string;
    }
    interface event_based_addons_create_sub_for_customer_estimate_params {
        charge_once?: boolean;
    }
    interface event_based_addons_create_sub_for_customer_estimate_params {
        charge_on?: string;
    }
    interface addons_create_sub_for_customer_estimate_params {
        trial_end?: number;
    }
    interface subscription_create_sub_item_for_customer_estimate_params {
        id?: string;
    }
    interface subscription_create_sub_item_for_customer_estimate_params {
        trial_end?: number;
    }
    interface subscription_create_sub_item_for_customer_estimate_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        setup_fee?: number;
    }
    interface subscription_create_sub_item_for_customer_estimate_params {
        start_date?: number;
    }
    interface subscription_create_sub_item_for_customer_estimate_params {
        free_period?: number;
    }
    interface subscription_create_sub_item_for_customer_estimate_params {
        free_period_unit?: string;
    }
    interface subscription_create_sub_item_for_customer_estimate_params {
        contract_term_billing_cycle_on_renewal?: number;
    }
    interface subscription_create_sub_item_for_customer_estimate_params {
        trial_end_action?: string;
    }
    interface shipping_address_create_sub_item_for_customer_estimate_params {
        line1?: string;
    }
    interface shipping_address_create_sub_item_for_customer_estimate_params {
        line2?: string;
    }
    interface shipping_address_create_sub_item_for_customer_estimate_params {
        line3?: string;
    }
    interface shipping_address_create_sub_item_for_customer_estimate_params {
        city?: string;
    }
    interface shipping_address_create_sub_item_for_customer_estimate_params {
        state_code?: string;
    }
    interface shipping_address_create_sub_item_for_customer_estimate_params {
        zip?: string;
    }
    interface shipping_address_create_sub_item_for_customer_estimate_params {
        country?: string;
    }
    interface shipping_address_create_sub_item_for_customer_estimate_params {
        validation_status?: string;
    }
    interface billing_address_create_sub_item_for_customer_estimate_params {
        line1?: string;
    }
    interface billing_address_create_sub_item_for_customer_estimate_params {
        line2?: string;
    }
    interface billing_address_create_sub_item_for_customer_estimate_params {
        line3?: string;
    }
    interface billing_address_create_sub_item_for_customer_estimate_params {
        city?: string;
    }
    interface billing_address_create_sub_item_for_customer_estimate_params {
        state_code?: string;
    }
    interface billing_address_create_sub_item_for_customer_estimate_params {
        zip?: string;
    }
    interface billing_address_create_sub_item_for_customer_estimate_params {
        country?: string;
    }
    interface billing_address_create_sub_item_for_customer_estimate_params {
        validation_status?: string;
    }
    interface contract_term_create_sub_item_for_customer_estimate_params {
        action_at_term_end?: string;
    }
    interface contract_term_create_sub_item_for_customer_estimate_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        contract_start?: number;
    }
    interface contract_term_create_sub_item_for_customer_estimate_params {
        cancellation_cutoff_period?: number;
    }
    interface billing_override_create_sub_item_for_customer_estimate_params {
        max_excess_payment_usage?: number;
    }
    interface billing_override_create_sub_item_for_customer_estimate_params {
        max_refundable_credits_usage?: number;
    }
    interface subscription_items_create_sub_item_for_customer_estimate_params {
        item_price_id: string;
    }
    interface subscription_items_create_sub_item_for_customer_estimate_params {
        quantity?: number;
    }
    interface subscription_items_create_sub_item_for_customer_estimate_params {
        quantity_in_decimal?: string;
    }
    interface subscription_items_create_sub_item_for_customer_estimate_params {
        unit_price?: number;
    }
    interface subscription_items_create_sub_item_for_customer_estimate_params {
        unit_price_in_decimal?: string;
    }
    interface subscription_items_create_sub_item_for_customer_estimate_params {
        billing_cycles?: number;
    }
    interface subscription_items_create_sub_item_for_customer_estimate_params {
        trial_end?: number;
    }
    interface subscription_items_create_sub_item_for_customer_estimate_params {
        service_period_days?: number;
    }
    interface subscription_items_create_sub_item_for_customer_estimate_params {
        charge_on_event?: string;
    }
    interface subscription_items_create_sub_item_for_customer_estimate_params {
        charge_once?: boolean;
    }
    interface subscription_items_create_sub_item_for_customer_estimate_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        item_type?: string;
    }
    interface discounts_create_sub_item_for_customer_estimate_params {
        apply_on?: string;
    }
    interface discounts_create_sub_item_for_customer_estimate_params {
        duration_type: string;
    }
    interface discounts_create_sub_item_for_customer_estimate_params {
        percentage?: number;
    }
    interface discounts_create_sub_item_for_customer_estimate_params {
        amount?: number;
    }
    interface discounts_create_sub_item_for_customer_estimate_params {
        period?: number;
    }
    interface discounts_create_sub_item_for_customer_estimate_params {
        period_unit?: string;
    }
    interface discounts_create_sub_item_for_customer_estimate_params {
        included_in_mrr?: boolean;
    }
    interface discounts_create_sub_item_for_customer_estimate_params {
        item_price_id?: string;
    }
    interface subscription_items_create_sub_item_for_customer_estimate_params {
        charge_on_option?: string;
    }
    interface item_tiers_create_sub_item_for_customer_estimate_params {
        item_price_id?: string;
    }
    interface item_tiers_create_sub_item_for_customer_estimate_params {
        starting_unit?: number;
    }
    interface item_tiers_create_sub_item_for_customer_estimate_params {
        ending_unit?: number;
    }
    interface item_tiers_create_sub_item_for_customer_estimate_params {
        price?: number;
    }
    interface item_tiers_create_sub_item_for_customer_estimate_params {
        starting_unit_in_decimal?: string;
    }
    interface item_tiers_create_sub_item_for_customer_estimate_params {
        ending_unit_in_decimal?: string;
    }
    interface item_tiers_create_sub_item_for_customer_estimate_params {
        price_in_decimal?: string;
    }
    interface item_tiers_create_sub_item_for_customer_estimate_params {
        pricing_type?: string;
    }
    interface item_tiers_create_sub_item_for_customer_estimate_params {
        package_size?: number;
    }
    interface subscription_update_subscription_params {
        id: string;
    }
    interface subscription_update_subscription_params {
        plan_id?: string;
    }
    interface subscription_update_subscription_params {
        plan_quantity?: number;
    }
    interface subscription_update_subscription_params {
        plan_unit_price?: number;
    }
    interface subscription_update_subscription_params {
        setup_fee?: number;
    }
    interface subscription_update_subscription_params {
        plan_quantity_in_decimal?: string;
    }
    interface subscription_update_subscription_params {
        plan_unit_price_in_decimal?: string;
    }
    interface subscription_update_subscription_params {
        start_date?: number;
    }
    interface subscription_update_subscription_params {
        trial_end?: number;
    }
    interface subscription_update_subscription_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        coupon?: string;
    }
    interface subscription_update_subscription_params {
        auto_collection?: string;
    }
    interface subscription_update_subscription_params {
        offline_payment_method?: string;
    }
    interface subscription_update_subscription_params {
        free_period?: number;
    }
    interface subscription_update_subscription_params {
        free_period_unit?: string;
    }
    interface subscription_update_subscription_params {
        trial_end_action?: string;
    }
    interface billing_address_update_subscription_params {
        line1?: string;
    }
    interface billing_address_update_subscription_params {
        line2?: string;
    }
    interface billing_address_update_subscription_params {
        line3?: string;
    }
    interface billing_address_update_subscription_params {
        city?: string;
    }
    interface billing_address_update_subscription_params {
        state_code?: string;
    }
    interface billing_address_update_subscription_params {
        zip?: string;
    }
    interface billing_address_update_subscription_params {
        country?: string;
    }
    interface billing_address_update_subscription_params {
        validation_status?: string;
    }
    interface shipping_address_update_subscription_params {
        line1?: string;
    }
    interface shipping_address_update_subscription_params {
        line2?: string;
    }
    interface shipping_address_update_subscription_params {
        line3?: string;
    }
    interface shipping_address_update_subscription_params {
        city?: string;
    }
    interface shipping_address_update_subscription_params {
        state_code?: string;
    }
    interface shipping_address_update_subscription_params {
        zip?: string;
    }
    interface shipping_address_update_subscription_params {
        country?: string;
    }
    interface shipping_address_update_subscription_params {
        validation_status?: string;
    }
    interface customer_update_subscription_params {
        vat_number?: string;
    }
    interface customer_update_subscription_params {
        vat_number_prefix?: string;
    }
    interface customer_update_subscription_params {
        registered_for_gst?: boolean;
    }
    interface customer_update_subscription_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        taxability?: string;
    }
    interface addons_update_subscription_params {
        id?: string;
    }
    interface addons_update_subscription_params {
        quantity?: number;
    }
    interface addons_update_subscription_params {
        unit_price?: number;
    }
    interface addons_update_subscription_params {
        billing_cycles?: number;
    }
    interface addons_update_subscription_params {
        quantity_in_decimal?: string;
    }
    interface addons_update_subscription_params {
        unit_price_in_decimal?: string;
    }
    interface addons_update_subscription_params {
        trial_end?: number;
    }
    interface addons_update_subscription_params {
        proration_type?: string;
    }
    interface event_based_addons_update_subscription_params {
        id?: string;
    }
    interface event_based_addons_update_subscription_params {
        quantity?: number;
    }
    interface event_based_addons_update_subscription_params {
        unit_price?: number;
    }
    interface event_based_addons_update_subscription_params {
        service_period_in_days?: number;
    }
    interface event_based_addons_update_subscription_params {
        charge_on?: string;
    }
    interface event_based_addons_update_subscription_params {
        on_event?: string;
    }
    interface event_based_addons_update_subscription_params {
        charge_once?: boolean;
    }
    interface event_based_addons_update_subscription_params {
        quantity_in_decimal?: string;
    }
    interface event_based_addons_update_subscription_params {
        unit_price_in_decimal?: string;
    }
    interface subscription_update_subscription_for_items_params {
        id: string;
    }
    interface subscription_update_subscription_for_items_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        setup_fee?: number;
    }
    interface subscription_update_subscription_for_items_params {
        start_date?: number;
    }
    interface subscription_update_subscription_for_items_params {
        trial_end?: number;
    }
    interface subscription_update_subscription_for_items_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        coupon?: string;
    }
    interface subscription_update_subscription_for_items_params {
        auto_collection?: string;
    }
    interface subscription_update_subscription_for_items_params {
        offline_payment_method?: string;
    }
    interface subscription_update_subscription_for_items_params {
        free_period?: number;
    }
    interface subscription_update_subscription_for_items_params {
        free_period_unit?: string;
    }
    interface subscription_update_subscription_for_items_params {
        trial_end_action?: string;
    }
    interface billing_address_update_subscription_for_items_params {
        line1?: string;
    }
    interface billing_address_update_subscription_for_items_params {
        line2?: string;
    }
    interface billing_address_update_subscription_for_items_params {
        line3?: string;
    }
    interface billing_address_update_subscription_for_items_params {
        city?: string;
    }
    interface billing_address_update_subscription_for_items_params {
        state_code?: string;
    }
    interface billing_address_update_subscription_for_items_params {
        zip?: string;
    }
    interface billing_address_update_subscription_for_items_params {
        country?: string;
    }
    interface billing_address_update_subscription_for_items_params {
        validation_status?: string;
    }
    interface shipping_address_update_subscription_for_items_params {
        line1?: string;
    }
    interface shipping_address_update_subscription_for_items_params {
        line2?: string;
    }
    interface shipping_address_update_subscription_for_items_params {
        line3?: string;
    }
    interface shipping_address_update_subscription_for_items_params {
        city?: string;
    }
    interface shipping_address_update_subscription_for_items_params {
        state_code?: string;
    }
    interface shipping_address_update_subscription_for_items_params {
        zip?: string;
    }
    interface shipping_address_update_subscription_for_items_params {
        country?: string;
    }
    interface shipping_address_update_subscription_for_items_params {
        validation_status?: string;
    }
    interface customer_update_subscription_for_items_params {
        vat_number?: string;
    }
    interface customer_update_subscription_for_items_params {
        vat_number_prefix?: string;
    }
    interface customer_update_subscription_for_items_params {
        registered_for_gst?: boolean;
    }
    interface customer_update_subscription_for_items_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        taxability?: string;
    }
    interface billing_override_update_subscription_for_items_params {
        max_excess_payment_usage?: number;
    }
    interface billing_override_update_subscription_for_items_params {
        max_refundable_credits_usage?: number;
    }
    interface subscription_items_update_subscription_for_items_params {
        item_price_id: string;
    }
    interface subscription_items_update_subscription_for_items_params {
        quantity?: number;
    }
    interface subscription_items_update_subscription_for_items_params {
        quantity_in_decimal?: string;
    }
    interface subscription_items_update_subscription_for_items_params {
        unit_price?: number;
    }
    interface subscription_items_update_subscription_for_items_params {
        unit_price_in_decimal?: string;
    }
    interface subscription_items_update_subscription_for_items_params {
        billing_cycles?: number;
    }
    interface subscription_items_update_subscription_for_items_params {
        trial_end?: number;
    }
    interface subscription_items_update_subscription_for_items_params {
        service_period_days?: number;
    }
    interface subscription_items_update_subscription_for_items_params {
        charge_on_event?: string;
    }
    interface subscription_items_update_subscription_for_items_params {
        charge_once?: boolean;
    }
    interface subscription_items_update_subscription_for_items_params {
        charge_on_option?: string;
    }
    interface subscription_items_update_subscription_for_items_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        item_type?: string;
    }
    interface discounts_update_subscription_for_items_params {
        apply_on?: string;
    }
    interface discounts_update_subscription_for_items_params {
        duration_type: string;
    }
    interface discounts_update_subscription_for_items_params {
        percentage?: number;
    }
    interface discounts_update_subscription_for_items_params {
        amount?: number;
    }
    interface discounts_update_subscription_for_items_params {
        period?: number;
    }
    interface discounts_update_subscription_for_items_params {
        period_unit?: string;
    }
    interface discounts_update_subscription_for_items_params {
        included_in_mrr?: boolean;
    }
    interface discounts_update_subscription_for_items_params {
        item_price_id?: string;
    }
    interface discounts_update_subscription_for_items_params {
        operation_type: string;
    }
    interface discounts_update_subscription_for_items_params {
        id?: string;
    }
    interface item_tiers_update_subscription_for_items_params {
        item_price_id?: string;
    }
    interface item_tiers_update_subscription_for_items_params {
        starting_unit?: number;
    }
    interface item_tiers_update_subscription_for_items_params {
        ending_unit?: number;
    }
    interface item_tiers_update_subscription_for_items_params {
        price?: number;
    }
    interface item_tiers_update_subscription_for_items_params {
        starting_unit_in_decimal?: string;
    }
    interface item_tiers_update_subscription_for_items_params {
        ending_unit_in_decimal?: string;
    }
    interface item_tiers_update_subscription_for_items_params {
        price_in_decimal?: string;
    }
    interface item_tiers_update_subscription_for_items_params {
        pricing_type?: string;
    }
    interface item_tiers_update_subscription_for_items_params {
        package_size?: number;
    }
    interface subscription_items_update_subscription_for_items_params {
        proration_type?: string;
    }
    interface fixed_interval_schedule_advance_invoice_estimate_params {
        number_of_occurrences?: number;
    }
    interface fixed_interval_schedule_advance_invoice_estimate_params {
        days_before_renewal?: number;
    }
    interface fixed_interval_schedule_advance_invoice_estimate_params {
        end_schedule_on?: string;
    }
    interface fixed_interval_schedule_advance_invoice_estimate_params {
        end_date?: number;
    }
    interface specific_dates_schedule_advance_invoice_estimate_params {
        terms_to_charge?: number;
    }
    interface specific_dates_schedule_advance_invoice_estimate_params {
        date?: number;
    }
    interface event_based_addons_cancel_subscription_params {
        id?: string;
    }
    interface event_based_addons_cancel_subscription_params {
        quantity?: number;
    }
    interface event_based_addons_cancel_subscription_params {
        unit_price?: number;
    }
    interface event_based_addons_cancel_subscription_params {
        service_period_in_days?: number;
    }
    interface subscription_items_cancel_subscription_for_items_params {
        item_price_id?: string;
    }
    interface subscription_items_cancel_subscription_for_items_params {
        quantity?: number;
    }
    interface subscription_items_cancel_subscription_for_items_params {
        quantity_in_decimal?: string;
    }
    interface subscription_items_cancel_subscription_for_items_params {
        unit_price?: number;
    }
    interface subscription_items_cancel_subscription_for_items_params {
        unit_price_in_decimal?: string;
    }
    interface subscription_items_cancel_subscription_for_items_params {
        service_period_days?: number;
    }
    interface subscription_pause_subscription_params {
        pause_date?: number;
    }
    interface subscription_pause_subscription_params {
        resume_date?: number;
    }
    interface subscription_pause_subscription_params {
        skip_billing_cycles?: number;
    }
    interface subscription_resume_subscription_params {
        resume_date?: number;
    }
    interface gift_gift_subscription_params {
        scheduled_at?: number;
    }
    interface gift_gift_subscription_params {
        auto_claim?: boolean;
    }
    interface gift_gift_subscription_params {
        no_expiry?: boolean;
    }
    interface gift_gift_subscription_params {
        claim_expiry_date?: number;
    }
    interface gifter_gift_subscription_params {
        customer_id: string;
    }
    interface gifter_gift_subscription_params {
        signature: string;
    }
    interface gifter_gift_subscription_params {
        note?: string;
    }
    interface gifter_gift_subscription_params {
        payment_src_id?: string;
    }
    interface gift_receiver_gift_subscription_params {
        customer_id: string;
    }
    interface gift_receiver_gift_subscription_params {
        first_name: string;
    }
    interface gift_receiver_gift_subscription_params {
        last_name: string;
    }
    interface gift_receiver_gift_subscription_params {
        email: string;
    }
    interface payment_intent_gift_subscription_params {
        id?: string;
    }
    interface payment_intent_gift_subscription_params {
        gateway_account_id?: string;
    }
    interface payment_intent_gift_subscription_params {
        gw_token?: string;
    }
    interface payment_intent_gift_subscription_params {
        payment_method_type?: string;
    }
    interface payment_intent_gift_subscription_params {
        reference_id?: string;
    }
    interface payment_intent_gift_subscription_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        gw_payment_method_id?: string;
    }
    interface payment_intent_gift_subscription_params {
        additional_information?: any;
    }
    interface shipping_address_gift_subscription_params {
        first_name?: string;
    }
    interface shipping_address_gift_subscription_params {
        last_name?: string;
    }
    interface shipping_address_gift_subscription_params {
        email?: string;
    }
    interface shipping_address_gift_subscription_params {
        company?: string;
    }
    interface shipping_address_gift_subscription_params {
        phone?: string;
    }
    interface shipping_address_gift_subscription_params {
        line1?: string;
    }
    interface shipping_address_gift_subscription_params {
        line2?: string;
    }
    interface shipping_address_gift_subscription_params {
        line3?: string;
    }
    interface shipping_address_gift_subscription_params {
        city?: string;
    }
    interface shipping_address_gift_subscription_params {
        state_code?: string;
    }
    interface shipping_address_gift_subscription_params {
        state?: string;
    }
    interface shipping_address_gift_subscription_params {
        zip?: string;
    }
    interface shipping_address_gift_subscription_params {
        country?: string;
    }
    interface shipping_address_gift_subscription_params {
        validation_status?: string;
    }
    interface subscription_gift_subscription_params {
        plan_id: string;
    }
    interface subscription_gift_subscription_params {
        plan_quantity?: number;
    }
    interface subscription_gift_subscription_params {
        plan_quantity_in_decimal?: string;
    }
    interface addons_gift_subscription_params {
        id?: string;
    }
    interface addons_gift_subscription_params {
        quantity?: number;
    }
    interface addons_gift_subscription_params {
        quantity_in_decimal?: string;
    }
    interface gift_gift_subscription_for_items_params {
        scheduled_at?: number;
    }
    interface gift_gift_subscription_for_items_params {
        auto_claim?: boolean;
    }
    interface gift_gift_subscription_for_items_params {
        no_expiry?: boolean;
    }
    interface gift_gift_subscription_for_items_params {
        claim_expiry_date?: number;
    }
    interface gifter_gift_subscription_for_items_params {
        customer_id: string;
    }
    interface gifter_gift_subscription_for_items_params {
        signature: string;
    }
    interface gifter_gift_subscription_for_items_params {
        note?: string;
    }
    interface gifter_gift_subscription_for_items_params {
        payment_src_id?: string;
    }
    interface gift_receiver_gift_subscription_for_items_params {
        customer_id: string;
    }
    interface gift_receiver_gift_subscription_for_items_params {
        first_name: string;
    }
    interface gift_receiver_gift_subscription_for_items_params {
        last_name: string;
    }
    interface gift_receiver_gift_subscription_for_items_params {
        email: string;
    }
    interface payment_intent_gift_subscription_for_items_params {
        id?: string;
    }
    interface payment_intent_gift_subscription_for_items_params {
        gateway_account_id?: string;
    }
    interface payment_intent_gift_subscription_for_items_params {
        gw_token?: string;
    }
    interface payment_intent_gift_subscription_for_items_params {
        payment_method_type?: string;
    }
    interface payment_intent_gift_subscription_for_items_params {
        reference_id?: string;
    }
    interface payment_intent_gift_subscription_for_items_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        gw_payment_method_id?: string;
    }
    interface payment_intent_gift_subscription_for_items_params {
        additional_information?: any;
    }
    interface shipping_address_gift_subscription_for_items_params {
        first_name?: string;
    }
    interface shipping_address_gift_subscription_for_items_params {
        last_name?: string;
    }
    interface shipping_address_gift_subscription_for_items_params {
        email?: string;
    }
    interface shipping_address_gift_subscription_for_items_params {
        company?: string;
    }
    interface shipping_address_gift_subscription_for_items_params {
        phone?: string;
    }
    interface shipping_address_gift_subscription_for_items_params {
        line1?: string;
    }
    interface shipping_address_gift_subscription_for_items_params {
        line2?: string;
    }
    interface shipping_address_gift_subscription_for_items_params {
        line3?: string;
    }
    interface shipping_address_gift_subscription_for_items_params {
        city?: string;
    }
    interface shipping_address_gift_subscription_for_items_params {
        state_code?: string;
    }
    interface shipping_address_gift_subscription_for_items_params {
        state?: string;
    }
    interface shipping_address_gift_subscription_for_items_params {
        zip?: string;
    }
    interface shipping_address_gift_subscription_for_items_params {
        country?: string;
    }
    interface shipping_address_gift_subscription_for_items_params {
        validation_status?: string;
    }
    interface subscription_items_gift_subscription_for_items_params {
        item_price_id?: string;
    }
    interface subscription_items_gift_subscription_for_items_params {
        quantity?: number;
    }
    interface subscription_items_gift_subscription_for_items_params {
        quantity_in_decimal?: string;
    }
    interface invoice_create_invoice_params {
        customer_id?: string;
    }
    interface invoice_create_invoice_params {
        subscription_id?: string;
    }
    interface invoice_create_invoice_params {
        po_number?: string;
    }
    interface shipping_address_create_invoice_params {
        first_name?: string;
    }
    interface shipping_address_create_invoice_params {
        last_name?: string;
    }
    interface shipping_address_create_invoice_params {
        email?: string;
    }
    interface shipping_address_create_invoice_params {
        company?: string;
    }
    interface shipping_address_create_invoice_params {
        phone?: string;
    }
    interface shipping_address_create_invoice_params {
        line1?: string;
    }
    interface shipping_address_create_invoice_params {
        line2?: string;
    }
    interface shipping_address_create_invoice_params {
        line3?: string;
    }
    interface shipping_address_create_invoice_params {
        city?: string;
    }
    interface shipping_address_create_invoice_params {
        state_code?: string;
    }
    interface shipping_address_create_invoice_params {
        state?: string;
    }
    interface shipping_address_create_invoice_params {
        zip?: string;
    }
    interface shipping_address_create_invoice_params {
        country?: string;
    }
    interface shipping_address_create_invoice_params {
        validation_status?: string;
    }
    interface addons_create_invoice_params {
        id?: string;
    }
    interface addons_create_invoice_params {
        quantity?: number;
    }
    interface addons_create_invoice_params {
        quantity_in_decimal?: string;
    }
    interface addons_create_invoice_params {
        unit_price?: number;
    }
    interface addons_create_invoice_params {
        unit_price_in_decimal?: string;
    }
    interface addons_create_invoice_params {
        date_from?: number;
    }
    interface addons_create_invoice_params {
        date_to?: number;
    }
    interface charges_create_invoice_params {
        amount?: number;
    }
    interface charges_create_invoice_params {
        amount_in_decimal?: string;
    }
    interface charges_create_invoice_params {
        description?: string;
    }
    interface charges_create_invoice_params {
        taxable?: boolean;
    }
    interface charges_create_invoice_params {
        tax_profile_id?: string;
    }
    interface charges_create_invoice_params {
        avalara_tax_code?: string;
    }
    interface charges_create_invoice_params {
        hsn_code?: string;
    }
    interface charges_create_invoice_params {
        taxjar_product_code?: string;
    }
    interface charges_create_invoice_params {
        avalara_sale_type?: string;
    }
    interface charges_create_invoice_params {
        avalara_transaction_type?: number;
    }
    interface charges_create_invoice_params {
        avalara_service_type?: number;
    }
    interface charges_create_invoice_params {
        date_from?: number;
    }
    interface charges_create_invoice_params {
        date_to?: number;
    }
    interface notes_to_remove_create_invoice_params {
        entity_type?: string;
    }
    interface notes_to_remove_create_invoice_params {
        entity_id?: string;
    }
    interface tax_providers_fields_create_invoice_params {
        provider_name?: string;
    }
    interface tax_providers_fields_create_invoice_params {
        field_id?: string;
    }
    interface tax_providers_fields_create_invoice_params {
        field_value?: string;
    }
    interface invoice_create_invoice_for_items_params {
        customer_id?: string;
    }
    interface invoice_create_invoice_for_items_params {
        subscription_id?: string;
    }
    interface invoice_create_invoice_for_items_params {
        po_number?: string;
    }
    interface shipping_address_create_invoice_for_items_params {
        first_name?: string;
    }
    interface shipping_address_create_invoice_for_items_params {
        last_name?: string;
    }
    interface shipping_address_create_invoice_for_items_params {
        email?: string;
    }
    interface shipping_address_create_invoice_for_items_params {
        company?: string;
    }
    interface shipping_address_create_invoice_for_items_params {
        phone?: string;
    }
    interface shipping_address_create_invoice_for_items_params {
        line1?: string;
    }
    interface shipping_address_create_invoice_for_items_params {
        line2?: string;
    }
    interface shipping_address_create_invoice_for_items_params {
        line3?: string;
    }
    interface shipping_address_create_invoice_for_items_params {
        city?: string;
    }
    interface shipping_address_create_invoice_for_items_params {
        state_code?: string;
    }
    interface shipping_address_create_invoice_for_items_params {
        state?: string;
    }
    interface shipping_address_create_invoice_for_items_params {
        zip?: string;
    }
    interface shipping_address_create_invoice_for_items_params {
        country?: string;
    }
    interface shipping_address_create_invoice_for_items_params {
        validation_status?: string;
    }
    interface billing_address_create_invoice_for_items_params {
        line1?: string;
    }
    interface billing_address_create_invoice_for_items_params {
        line2?: string;
    }
    interface billing_address_create_invoice_for_items_params {
        line3?: string;
    }
    interface billing_address_create_invoice_for_items_params {
        city?: string;
    }
    interface billing_address_create_invoice_for_items_params {
        state_code?: string;
    }
    interface billing_address_create_invoice_for_items_params {
        zip?: string;
    }
    interface billing_address_create_invoice_for_items_params {
        country?: string;
    }
    interface billing_address_create_invoice_for_items_params {
        validation_status?: string;
    }
    interface item_prices_create_invoice_for_items_params {
        item_price_id?: string;
    }
    interface item_prices_create_invoice_for_items_params {
        quantity?: number;
    }
    interface item_prices_create_invoice_for_items_params {
        quantity_in_decimal?: string;
    }
    interface item_prices_create_invoice_for_items_params {
        unit_price?: number;
    }
    interface item_prices_create_invoice_for_items_params {
        unit_price_in_decimal?: string;
    }
    interface item_prices_create_invoice_for_items_params {
        date_from?: number;
    }
    interface item_prices_create_invoice_for_items_params {
        date_to?: number;
    }
    interface item_tiers_create_invoice_for_items_params {
        item_price_id?: string;
    }
    interface item_tiers_create_invoice_for_items_params {
        starting_unit?: number;
    }
    interface item_tiers_create_invoice_for_items_params {
        ending_unit?: number;
    }
    interface item_tiers_create_invoice_for_items_params {
        price?: number;
    }
    interface item_tiers_create_invoice_for_items_params {
        starting_unit_in_decimal?: string;
    }
    interface item_tiers_create_invoice_for_items_params {
        ending_unit_in_decimal?: string;
    }
    interface item_tiers_create_invoice_for_items_params {
        price_in_decimal?: string;
    }
    interface item_tiers_create_invoice_for_items_params {
        pricing_type?: string;
    }
    interface item_tiers_create_invoice_for_items_params {
        package_size?: number;
    }
    interface charges_create_invoice_for_items_params {
        amount?: number;
    }
    interface charges_create_invoice_for_items_params {
        amount_in_decimal?: string;
    }
    interface charges_create_invoice_for_items_params {
        description?: string;
    }
    interface charges_create_invoice_for_items_params {
        taxable?: boolean;
    }
    interface charges_create_invoice_for_items_params {
        tax_profile_id?: string;
    }
    interface charges_create_invoice_for_items_params {
        avalara_tax_code?: string;
    }
    interface charges_create_invoice_for_items_params {
        hsn_code?: string;
    }
    interface charges_create_invoice_for_items_params {
        taxjar_product_code?: string;
    }
    interface charges_create_invoice_for_items_params {
        avalara_sale_type?: string;
    }
    interface charges_create_invoice_for_items_params {
        avalara_transaction_type?: number;
    }
    interface charges_create_invoice_for_items_params {
        avalara_service_type?: number;
    }
    interface charges_create_invoice_for_items_params {
        date_from?: number;
    }
    interface charges_create_invoice_for_items_params {
        date_to?: number;
    }
    interface notes_to_remove_create_invoice_for_items_params {
        entity_type?: string;
    }
    interface notes_to_remove_create_invoice_for_items_params {
        entity_id?: string;
    }
    interface discounts_create_invoice_for_items_params {
        percentage?: number;
    }
    interface discounts_create_invoice_for_items_params {
        amount?: number;
    }
    interface discounts_create_invoice_for_items_params {
        apply_on: string;
    }
    interface discounts_create_invoice_for_items_params {
        item_price_id?: string;
    }
    interface tax_providers_fields_create_invoice_for_items_params {
        provider_name?: string;
    }
    interface tax_providers_fields_create_invoice_for_items_params {
        field_id?: string;
    }
    interface tax_providers_fields_create_invoice_for_items_params {
        field_value?: string;
    }
}
