"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Estimate = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class Estimate extends model_1.Model {
    // OPERATIONS
    //-----------
    static create_subscription(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create_subscription',
            'httpMethod': 'POST',
            'urlPrefix': '/estimates',
            'urlSuffix': '/create_subscription',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "exemption_details": 1,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static create_sub_item_estimate(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create_sub_item_estimate',
            'httpMethod': 'POST',
            'urlPrefix': '/estimates',
            'urlSuffix': '/create_subscription_for_items',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "exemption_details": 1,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static create_sub_for_customer_estimate(customer_id, params) {
        return new request_wrapper_1.RequestWrapper([customer_id, params], {
            'methodName': 'create_sub_for_customer_estimate',
            'httpMethod': 'GET',
            'urlPrefix': '/customers',
            'urlSuffix': '/create_subscription_estimate',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static create_sub_item_for_customer_estimate(customer_id, params) {
        return new request_wrapper_1.RequestWrapper([customer_id, params], {
            'methodName': 'create_sub_item_for_customer_estimate',
            'httpMethod': 'POST',
            'urlPrefix': '/customers',
            'urlSuffix': '/create_subscription_for_items_estimate',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static update_subscription(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'update_subscription',
            'httpMethod': 'POST',
            'urlPrefix': '/estimates',
            'urlSuffix': '/update_subscription',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static update_subscription_for_items(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'update_subscription_for_items',
            'httpMethod': 'POST',
            'urlPrefix': '/estimates',
            'urlSuffix': '/update_subscription_for_items',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static renewal_estimate(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'renewal_estimate',
            'httpMethod': 'GET',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/renewal_estimate',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static advance_invoice_estimate(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'advance_invoice_estimate',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/advance_invoice_estimate',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static regenerate_invoice_estimate(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'regenerate_invoice_estimate',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/regenerate_invoice_estimate',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static upcoming_invoices_estimate(customer_id, params) {
        return new request_wrapper_1.RequestWrapper([customer_id, params], {
            'methodName': 'upcoming_invoices_estimate',
            'httpMethod': 'GET',
            'urlPrefix': '/customers',
            'urlSuffix': '/upcoming_invoices_estimate',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static change_term_end(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'change_term_end',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/change_term_end_estimate',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static cancel_subscription(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'cancel_subscription',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/cancel_subscription_estimate',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static cancel_subscription_for_items(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'cancel_subscription_for_items',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/cancel_subscription_for_items_estimate',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static pause_subscription(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'pause_subscription',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/pause_subscription_estimate',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static resume_subscription(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'resume_subscription',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/resume_subscription_estimate',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static gift_subscription(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'gift_subscription',
            'httpMethod': 'POST',
            'urlPrefix': '/estimates',
            'urlSuffix': '/gift_subscription',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "additional_information": 1,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static gift_subscription_for_items(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'gift_subscription_for_items',
            'httpMethod': 'POST',
            'urlPrefix': '/estimates',
            'urlSuffix': '/gift_subscription_for_items',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "additional_information": 1,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static create_invoice(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create_invoice',
            'httpMethod': 'POST',
            'urlPrefix': '/estimates',
            'urlSuffix': '/create_invoice',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static create_invoice_for_items(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create_invoice_for_items',
            'httpMethod': 'POST',
            'urlPrefix': '/estimates',
            'urlSuffix': '/create_invoice_for_items',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static payment_schedules(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'payment_schedules',
            'httpMethod': 'POST',
            'urlPrefix': '/estimates',
            'urlSuffix': '/payment_schedules',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~Estimate
exports.Estimate = Estimate;
