import * as resources from ".";
import { ListResult } from '../list_result';
import { RequestWrapper } from "../request_wrapper";
import { Model } from "./model";
import { filter } from "../filter";
import { Result } from "../result";
export declare class Event extends Model {
    id: string;
    occurred_at: number;
    source: string;
    user?: string;
    webhook_status: string;
    webhook_failure_reason?: string;
    webhooks?: Array<Webhook>;
    event_type?: string;
    api_version?: string;
    origin_user?: string;
    get content(): Result;
    set content(content: Result);
    static deserialize(json: string): resources.Event;
    static list(params?: _event.event_list_params): RequestWrapper<ListResult>;
    static retrieve(event_id: string, params?: any): RequestWrapper;
}
export declare class Webhook extends Model {
    id: string;
    webhook_status: string;
}
export declare namespace _event {
    interface event_list_params {
        limit?: number;
        offset?: string;
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        start_time?: number;
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        end_time?: number;
        id?: filter._string;
        webhook_status?: filter._enum;
        event_type?: filter._enum;
        source?: filter._enum;
        occurred_at?: filter._timestamp;
        "sort_by[asc]"?: string;
        "sort_by[desc]"?: string;
    }
}
