"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Level = exports.Feature = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class Feature extends model_1.Model {
    // OPERATIONS
    //-----------
    static list(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'list',
            'httpMethod': 'GET',
            'urlPrefix': '/features',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static create(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create',
            'httpMethod': 'POST',
            'urlPrefix': '/features',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static update(feature_id, params) {
        return new request_wrapper_1.RequestWrapper([feature_id, params], {
            'methodName': 'update',
            'httpMethod': 'POST',
            'urlPrefix': '/features',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static retrieve(feature_id, params) {
        return new request_wrapper_1.RequestWrapper([feature_id, params], {
            'methodName': 'retrieve',
            'httpMethod': 'GET',
            'urlPrefix': '/features',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static delete(feature_id, params) {
        return new request_wrapper_1.RequestWrapper([feature_id, params], {
            'methodName': 'delete',
            'httpMethod': 'POST',
            'urlPrefix': '/features',
            'urlSuffix': '/delete',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static activate(feature_id, params) {
        return new request_wrapper_1.RequestWrapper([feature_id, params], {
            'methodName': 'activate',
            'httpMethod': 'POST',
            'urlPrefix': '/features',
            'urlSuffix': '/activate_command',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static archive(feature_id, params) {
        return new request_wrapper_1.RequestWrapper([feature_id, params], {
            'methodName': 'archive',
            'httpMethod': 'POST',
            'urlPrefix': '/features',
            'urlSuffix': '/archive_command',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static reactivate(feature_id, params) {
        return new request_wrapper_1.RequestWrapper([feature_id, params], {
            'methodName': 'reactivate',
            'httpMethod': 'POST',
            'urlPrefix': '/features',
            'urlSuffix': '/reactivate_command',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~Feature
exports.Feature = Feature;
class Level extends model_1.Model {
} // ~Level
exports.Level = Level;
