"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GiftTimeline = exports.GiftReceiver = exports.Gifter = exports.Gift = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class Gift extends model_1.Model {
    // OPERATIONS
    //-----------
    static create(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create',
            'httpMethod': 'POST',
            'urlPrefix': '/gifts',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "additional_information": 1,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static create_for_items(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create_for_items',
            'httpMethod': 'POST',
            'urlPrefix': '/gifts',
            'urlSuffix': '/create_for_items',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "additional_information": 1,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static retrieve(gift_id, params) {
        return new request_wrapper_1.RequestWrapper([gift_id, params], {
            'methodName': 'retrieve',
            'httpMethod': 'GET',
            'urlPrefix': '/gifts',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static list(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'list',
            'httpMethod': 'GET',
            'urlPrefix': '/gifts',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static claim(gift_id, params) {
        return new request_wrapper_1.RequestWrapper([gift_id, params], {
            'methodName': 'claim',
            'httpMethod': 'POST',
            'urlPrefix': '/gifts',
            'urlSuffix': '/claim',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static cancel(gift_id, params) {
        return new request_wrapper_1.RequestWrapper([gift_id, params], {
            'methodName': 'cancel',
            'httpMethod': 'POST',
            'urlPrefix': '/gifts',
            'urlSuffix': '/cancel',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static update_gift(gift_id, params) {
        return new request_wrapper_1.RequestWrapper([gift_id, params], {
            'methodName': 'update_gift',
            'httpMethod': 'POST',
            'urlPrefix': '/gifts',
            'urlSuffix': '/update_gift',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~Gift
exports.Gift = Gift;
class Gifter extends model_1.Model {
} // ~Gifter
exports.Gifter = Gifter;
class GiftReceiver extends model_1.Model {
} // ~GiftReceiver
exports.GiftReceiver = GiftReceiver;
class GiftTimeline extends model_1.Model {
} // ~GiftTimeline
exports.GiftTimeline = GiftTimeline;
