import { ListResult } from '../list_result';
import { RequestWrapper } from "../request_wrapper";
import { Model } from "./model";
import { filter } from "../filter";
export declare class HostedPage extends Model {
    id?: string;
    type?: string;
    url?: string;
    state?: string;
    failure_reason?: string;
    pass_thru_content?: string;
    embed: boolean;
    created_at?: number;
    expires_at?: number;
    updated_at?: number;
    resource_version?: number;
    checkout_info?: any;
    business_entity_id?: string;
    static checkout_new(params?: _hosted_page.checkout_new_params): RequestWrapper;
    static checkout_one_time(params?: _hosted_page.checkout_one_time_params): RequestWrapper;
    static checkout_one_time_for_items(params?: _hosted_page.checkout_one_time_for_items_params): RequestWrapper;
    static checkout_new_for_items(params?: _hosted_page.checkout_new_for_items_params): RequestWrapper;
    static checkout_existing(params?: _hosted_page.checkout_existing_params): RequestWrapper;
    static checkout_existing_for_items(params?: _hosted_page.checkout_existing_for_items_params): RequestWrapper;
    static update_card(params?: _hosted_page.update_card_params): RequestWrapper;
    static update_payment_method(params?: _hosted_page.update_payment_method_params): RequestWrapper;
    static manage_payment_sources(params?: _hosted_page.manage_payment_sources_params): RequestWrapper;
    static collect_now(params?: _hosted_page.collect_now_params): RequestWrapper;
    static accept_quote(params?: _hosted_page.accept_quote_params): RequestWrapper;
    static extend_subscription(params?: _hosted_page.extend_subscription_params): RequestWrapper;
    static checkout_gift(params?: _hosted_page.checkout_gift_params): RequestWrapper;
    static checkout_gift_for_items(params?: _hosted_page.checkout_gift_for_items_params): RequestWrapper;
    static claim_gift(params?: _hosted_page.claim_gift_params): RequestWrapper;
    static retrieve_agreement_pdf(params?: _hosted_page.retrieve_agreement_pdf_params): RequestWrapper;
    static acknowledge(hosted_page_id: string, params?: any): RequestWrapper;
    static retrieve(hosted_page_id: string, params?: any): RequestWrapper;
    static list(params?: _hosted_page.hosted_page_list_params): RequestWrapper<ListResult>;
    static pre_cancel(params?: _hosted_page.pre_cancel_params): RequestWrapper;
    static events(params?: _hosted_page.events_params): RequestWrapper;
    static view_voucher(params?: _hosted_page.view_voucher_params): RequestWrapper;
}
export declare namespace _hosted_page {
    interface checkout_new_params {
        billing_cycles?: number;
        mandatory_addons_to_remove?: Array<string>;
        terms_to_charge?: number;
        billing_alignment_mode?: string;
        coupon_ids?: Array<string>;
        redirect_url?: string;
        cancel_url?: string;
        pass_thru_content?: string;
        embed?: boolean;
        iframe_messaging?: boolean;
        allow_offline_payment_methods?: boolean;
        subscription?: subscription_checkout_new_params;
        customer?: customer_checkout_new_params;
        card?: card_checkout_new_params;
        billing_address?: billing_address_checkout_new_params;
        shipping_address?: shipping_address_checkout_new_params;
        contract_term?: contract_term_checkout_new_params;
        addons?: Array<addons_checkout_new_params>;
        event_based_addons?: Array<event_based_addons_checkout_new_params>;
    }
    interface checkout_one_time_params {
        currency_code?: string;
        invoice_note?: string;
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        coupon?: string;
        coupon_ids?: Array<string>;
        redirect_url?: string;
        cancel_url?: string;
        pass_thru_content?: string;
        embed?: boolean;
        iframe_messaging?: boolean;
        customer?: customer_checkout_one_time_params;
        invoice?: invoice_checkout_one_time_params;
        card?: card_checkout_one_time_params;
        billing_address?: billing_address_checkout_one_time_params;
        shipping_address?: shipping_address_checkout_one_time_params;
        addons?: Array<addons_checkout_one_time_params>;
        charges?: Array<charges_checkout_one_time_params>;
    }
    interface checkout_one_time_for_items_params {
        business_entity_id?: string;
        layout?: string;
        invoice_note?: string;
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        coupon?: string;
        coupon_ids?: Array<string>;
        currency_code?: string;
        redirect_url?: string;
        cancel_url?: string;
        pass_thru_content?: string;
        customer?: customer_checkout_one_time_for_items_params;
        invoice?: invoice_checkout_one_time_for_items_params;
        card?: card_checkout_one_time_for_items_params;
        billing_address?: billing_address_checkout_one_time_for_items_params;
        shipping_address?: shipping_address_checkout_one_time_for_items_params;
        item_prices?: Array<item_prices_checkout_one_time_for_items_params>;
        item_tiers?: Array<item_tiers_checkout_one_time_for_items_params>;
        charges?: Array<charges_checkout_one_time_for_items_params>;
        discounts?: Array<discounts_checkout_one_time_for_items_params>;
        entity_identifiers?: Array<entity_identifiers_checkout_one_time_for_items_params>;
    }
    interface checkout_new_for_items_params {
        layout?: string;
        business_entity_id?: string;
        billing_cycles?: number;
        mandatory_items_to_remove?: Array<string>;
        terms_to_charge?: number;
        billing_alignment_mode?: string;
        coupon_ids?: Array<string>;
        redirect_url?: string;
        cancel_url?: string;
        pass_thru_content?: string;
        allow_offline_payment_methods?: boolean;
        subscription?: subscription_checkout_new_for_items_params;
        customer?: customer_checkout_new_for_items_params;
        card?: card_checkout_new_for_items_params;
        billing_address?: billing_address_checkout_new_for_items_params;
        shipping_address?: shipping_address_checkout_new_for_items_params;
        contract_term?: contract_term_checkout_new_for_items_params;
        subscription_items?: Array<subscription_items_checkout_new_for_items_params>;
        discounts?: Array<discounts_checkout_new_for_items_params>;
        item_tiers?: Array<item_tiers_checkout_new_for_items_params>;
        entity_identifiers?: Array<entity_identifiers_checkout_new_for_items_params>;
    }
    interface checkout_existing_params {
        replace_addon_list?: boolean;
        mandatory_addons_to_remove?: Array<string>;
        invoice_date?: number;
        billing_cycles?: number;
        terms_to_charge?: number;
        reactivate_from?: number;
        billing_alignment_mode?: string;
        coupon_ids?: Array<string>;
        replace_coupon_list?: boolean;
        reactivate?: boolean;
        force_term_reset?: boolean;
        redirect_url?: string;
        cancel_url?: string;
        pass_thru_content?: string;
        embed?: boolean;
        iframe_messaging?: boolean;
        allow_offline_payment_methods?: boolean;
        subscription?: subscription_checkout_existing_params;
        customer?: customer_checkout_existing_params;
        card?: card_checkout_existing_params;
        contract_term?: contract_term_checkout_existing_params;
        addons?: Array<addons_checkout_existing_params>;
        event_based_addons?: Array<event_based_addons_checkout_existing_params>;
    }
    interface checkout_existing_for_items_params {
        layout?: string;
        mandatory_items_to_remove?: Array<string>;
        replace_items_list?: boolean;
        invoice_date?: number;
        billing_cycles?: number;
        terms_to_charge?: number;
        reactivate_from?: number;
        billing_alignment_mode?: string;
        coupon_ids?: Array<string>;
        replace_coupon_list?: boolean;
        reactivate?: boolean;
        force_term_reset?: boolean;
        change_option?: string;
        changes_scheduled_at?: number;
        redirect_url?: string;
        cancel_url?: string;
        pass_thru_content?: string;
        allow_offline_payment_methods?: boolean;
        subscription?: subscription_checkout_existing_for_items_params;
        customer?: customer_checkout_existing_for_items_params;
        card?: card_checkout_existing_for_items_params;
        contract_term?: contract_term_checkout_existing_for_items_params;
        subscription_items?: Array<subscription_items_checkout_existing_for_items_params>;
        discounts?: Array<discounts_checkout_existing_for_items_params>;
        item_tiers?: Array<item_tiers_checkout_existing_for_items_params>;
        entity_identifiers?: Array<entity_identifiers_checkout_existing_for_items_params>;
    }
    interface update_card_params {
        redirect_url?: string;
        cancel_url?: string;
        pass_thru_content?: string;
        embed?: boolean;
        iframe_messaging?: boolean;
        customer?: customer_update_card_params;
        card?: card_update_card_params;
    }
    interface update_payment_method_params {
        redirect_url?: string;
        cancel_url?: string;
        pass_thru_content?: string;
        embed?: boolean;
        iframe_messaging?: boolean;
        customer?: customer_update_payment_method_params;
        card?: card_update_payment_method_params;
    }
    interface manage_payment_sources_params {
        redirect_url?: string;
        customer?: customer_manage_payment_sources_params;
        card?: card_manage_payment_sources_params;
    }
    interface collect_now_params {
        redirect_url?: string;
        currency_code?: string;
        customer?: customer_collect_now_params;
        card?: card_collect_now_params;
    }
    interface accept_quote_params {
        redirect_url?: string;
        layout?: string;
        quote?: quote_accept_quote_params;
    }
    interface extend_subscription_params {
        expiry?: number;
        billing_cycle?: number;
        subscription?: subscription_extend_subscription_params;
    }
    interface checkout_gift_params {
        redirect_url?: string;
        coupon_ids?: Array<string>;
        gifter?: gifter_checkout_gift_params;
        subscription?: subscription_checkout_gift_params;
        addons?: Array<addons_checkout_gift_params>;
    }
    interface checkout_gift_for_items_params {
        business_entity_id?: string;
        redirect_url?: string;
        coupon_ids?: Array<string>;
        gifter?: gifter_checkout_gift_for_items_params;
        subscription_items?: Array<subscription_items_checkout_gift_for_items_params>;
    }
    interface claim_gift_params {
        redirect_url?: string;
        gift?: gift_claim_gift_params;
        customer?: customer_claim_gift_params;
    }
    interface retrieve_agreement_pdf_params {
        payment_source_id: string;
    }
    interface hosted_page_list_params {
        limit?: number;
        offset?: string;
        id?: filter._string;
        type?: filter._enum;
        state?: filter._enum;
        updated_at?: filter._timestamp;
    }
    interface pre_cancel_params {
        pass_thru_content?: string;
        cancel_url?: string;
        redirect_url?: string;
        subscription?: subscription_pre_cancel_params;
    }
    interface events_params {
        event_name: string;
        occurred_at?: number;
        event_data: any;
    }
    interface view_voucher_params {
        payment_voucher?: payment_voucher_view_voucher_params;
        customer?: customer_view_voucher_params;
    }
    interface subscription_checkout_new_params {
        id?: string;
    }
    interface subscription_checkout_new_params {
        plan_id: string;
    }
    interface subscription_checkout_new_params {
        plan_quantity?: number;
    }
    interface subscription_checkout_new_params {
        plan_quantity_in_decimal?: string;
    }
    interface subscription_checkout_new_params {
        plan_unit_price?: number;
    }
    interface subscription_checkout_new_params {
        plan_unit_price_in_decimal?: string;
    }
    interface subscription_checkout_new_params {
        setup_fee?: number;
    }
    interface subscription_checkout_new_params {
        trial_end?: number;
    }
    interface subscription_checkout_new_params {
        start_date?: number;
    }
    interface subscription_checkout_new_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        coupon?: string;
    }
    interface subscription_checkout_new_params {
        auto_collection?: string;
    }
    interface subscription_checkout_new_params {
        offline_payment_method?: string;
    }
    interface subscription_checkout_new_params {
        invoice_notes?: string;
    }
    interface subscription_checkout_new_params {
        affiliate_token?: string;
    }
    interface subscription_checkout_new_params {
        contract_term_billing_cycle_on_renewal?: number;
    }
    interface customer_checkout_new_params {
        id?: string;
    }
    interface customer_checkout_new_params {
        email?: string;
    }
    interface customer_checkout_new_params {
        first_name?: string;
    }
    interface customer_checkout_new_params {
        last_name?: string;
    }
    interface customer_checkout_new_params {
        company?: string;
    }
    interface customer_checkout_new_params {
        phone?: string;
    }
    interface customer_checkout_new_params {
        locale?: string;
    }
    interface customer_checkout_new_params {
        taxability?: string;
    }
    interface customer_checkout_new_params {
        vat_number?: string;
    }
    interface customer_checkout_new_params {
        vat_number_prefix?: string;
    }
    interface customer_checkout_new_params {
        consolidated_invoicing?: boolean;
    }
    interface card_checkout_new_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        gateway?: string;
    }
    interface card_checkout_new_params {
        gateway_account_id?: string;
    }
    interface billing_address_checkout_new_params {
        first_name?: string;
    }
    interface billing_address_checkout_new_params {
        last_name?: string;
    }
    interface billing_address_checkout_new_params {
        email?: string;
    }
    interface billing_address_checkout_new_params {
        company?: string;
    }
    interface billing_address_checkout_new_params {
        phone?: string;
    }
    interface billing_address_checkout_new_params {
        line1?: string;
    }
    interface billing_address_checkout_new_params {
        line2?: string;
    }
    interface billing_address_checkout_new_params {
        line3?: string;
    }
    interface billing_address_checkout_new_params {
        city?: string;
    }
    interface billing_address_checkout_new_params {
        state_code?: string;
    }
    interface billing_address_checkout_new_params {
        state?: string;
    }
    interface billing_address_checkout_new_params {
        zip?: string;
    }
    interface billing_address_checkout_new_params {
        country?: string;
    }
    interface billing_address_checkout_new_params {
        validation_status?: string;
    }
    interface shipping_address_checkout_new_params {
        first_name?: string;
    }
    interface shipping_address_checkout_new_params {
        last_name?: string;
    }
    interface shipping_address_checkout_new_params {
        email?: string;
    }
    interface shipping_address_checkout_new_params {
        company?: string;
    }
    interface shipping_address_checkout_new_params {
        phone?: string;
    }
    interface shipping_address_checkout_new_params {
        line1?: string;
    }
    interface shipping_address_checkout_new_params {
        line2?: string;
    }
    interface shipping_address_checkout_new_params {
        line3?: string;
    }
    interface shipping_address_checkout_new_params {
        city?: string;
    }
    interface shipping_address_checkout_new_params {
        state_code?: string;
    }
    interface shipping_address_checkout_new_params {
        state?: string;
    }
    interface shipping_address_checkout_new_params {
        zip?: string;
    }
    interface shipping_address_checkout_new_params {
        country?: string;
    }
    interface shipping_address_checkout_new_params {
        validation_status?: string;
    }
    interface contract_term_checkout_new_params {
        action_at_term_end?: string;
    }
    interface contract_term_checkout_new_params {
        cancellation_cutoff_period?: number;
    }
    interface addons_checkout_new_params {
        id?: string;
    }
    interface addons_checkout_new_params {
        quantity?: number;
    }
    interface addons_checkout_new_params {
        quantity_in_decimal?: string;
    }
    interface addons_checkout_new_params {
        unit_price?: number;
    }
    interface addons_checkout_new_params {
        unit_price_in_decimal?: string;
    }
    interface addons_checkout_new_params {
        billing_cycles?: number;
    }
    interface event_based_addons_checkout_new_params {
        id?: string;
    }
    interface event_based_addons_checkout_new_params {
        quantity?: number;
    }
    interface event_based_addons_checkout_new_params {
        unit_price?: number;
    }
    interface event_based_addons_checkout_new_params {
        quantity_in_decimal?: string;
    }
    interface event_based_addons_checkout_new_params {
        unit_price_in_decimal?: string;
    }
    interface event_based_addons_checkout_new_params {
        service_period_in_days?: number;
    }
    interface event_based_addons_checkout_new_params {
        on_event?: string;
    }
    interface event_based_addons_checkout_new_params {
        charge_once?: boolean;
    }
    interface event_based_addons_checkout_new_params {
        charge_on?: string;
    }
    interface customer_checkout_one_time_params {
        id?: string;
    }
    interface customer_checkout_one_time_params {
        email?: string;
    }
    interface customer_checkout_one_time_params {
        first_name?: string;
    }
    interface customer_checkout_one_time_params {
        last_name?: string;
    }
    interface customer_checkout_one_time_params {
        company?: string;
    }
    interface customer_checkout_one_time_params {
        phone?: string;
    }
    interface customer_checkout_one_time_params {
        locale?: string;
    }
    interface customer_checkout_one_time_params {
        taxability?: string;
    }
    interface customer_checkout_one_time_params {
        vat_number?: string;
    }
    interface customer_checkout_one_time_params {
        vat_number_prefix?: string;
    }
    interface customer_checkout_one_time_params {
        consolidated_invoicing?: boolean;
    }
    interface invoice_checkout_one_time_params {
        po_number?: string;
    }
    interface card_checkout_one_time_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        gateway?: string;
    }
    interface card_checkout_one_time_params {
        gateway_account_id?: string;
    }
    interface billing_address_checkout_one_time_params {
        first_name?: string;
    }
    interface billing_address_checkout_one_time_params {
        last_name?: string;
    }
    interface billing_address_checkout_one_time_params {
        email?: string;
    }
    interface billing_address_checkout_one_time_params {
        company?: string;
    }
    interface billing_address_checkout_one_time_params {
        phone?: string;
    }
    interface billing_address_checkout_one_time_params {
        line1?: string;
    }
    interface billing_address_checkout_one_time_params {
        line2?: string;
    }
    interface billing_address_checkout_one_time_params {
        line3?: string;
    }
    interface billing_address_checkout_one_time_params {
        city?: string;
    }
    interface billing_address_checkout_one_time_params {
        state_code?: string;
    }
    interface billing_address_checkout_one_time_params {
        state?: string;
    }
    interface billing_address_checkout_one_time_params {
        zip?: string;
    }
    interface billing_address_checkout_one_time_params {
        country?: string;
    }
    interface billing_address_checkout_one_time_params {
        validation_status?: string;
    }
    interface shipping_address_checkout_one_time_params {
        first_name?: string;
    }
    interface shipping_address_checkout_one_time_params {
        last_name?: string;
    }
    interface shipping_address_checkout_one_time_params {
        email?: string;
    }
    interface shipping_address_checkout_one_time_params {
        company?: string;
    }
    interface shipping_address_checkout_one_time_params {
        phone?: string;
    }
    interface shipping_address_checkout_one_time_params {
        line1?: string;
    }
    interface shipping_address_checkout_one_time_params {
        line2?: string;
    }
    interface shipping_address_checkout_one_time_params {
        line3?: string;
    }
    interface shipping_address_checkout_one_time_params {
        city?: string;
    }
    interface shipping_address_checkout_one_time_params {
        state_code?: string;
    }
    interface shipping_address_checkout_one_time_params {
        state?: string;
    }
    interface shipping_address_checkout_one_time_params {
        zip?: string;
    }
    interface shipping_address_checkout_one_time_params {
        country?: string;
    }
    interface shipping_address_checkout_one_time_params {
        validation_status?: string;
    }
    interface addons_checkout_one_time_params {
        id?: string;
    }
    interface addons_checkout_one_time_params {
        quantity?: number;
    }
    interface addons_checkout_one_time_params {
        unit_price?: number;
    }
    interface addons_checkout_one_time_params {
        quantity_in_decimal?: string;
    }
    interface addons_checkout_one_time_params {
        unit_price_in_decimal?: string;
    }
    interface addons_checkout_one_time_params {
        date_from?: number;
    }
    interface addons_checkout_one_time_params {
        date_to?: number;
    }
    interface charges_checkout_one_time_params {
        amount?: number;
    }
    interface charges_checkout_one_time_params {
        amount_in_decimal?: string;
    }
    interface charges_checkout_one_time_params {
        description?: string;
    }
    interface charges_checkout_one_time_params {
        taxable?: boolean;
    }
    interface charges_checkout_one_time_params {
        tax_profile_id?: string;
    }
    interface charges_checkout_one_time_params {
        avalara_tax_code?: string;
    }
    interface charges_checkout_one_time_params {
        hsn_code?: string;
    }
    interface charges_checkout_one_time_params {
        taxjar_product_code?: string;
    }
    interface charges_checkout_one_time_params {
        avalara_sale_type?: string;
    }
    interface charges_checkout_one_time_params {
        avalara_transaction_type?: number;
    }
    interface charges_checkout_one_time_params {
        avalara_service_type?: number;
    }
    interface charges_checkout_one_time_params {
        date_from?: number;
    }
    interface charges_checkout_one_time_params {
        date_to?: number;
    }
    interface customer_checkout_one_time_for_items_params {
        id?: string;
    }
    interface customer_checkout_one_time_for_items_params {
        email?: string;
    }
    interface customer_checkout_one_time_for_items_params {
        first_name?: string;
    }
    interface customer_checkout_one_time_for_items_params {
        last_name?: string;
    }
    interface customer_checkout_one_time_for_items_params {
        company?: string;
    }
    interface customer_checkout_one_time_for_items_params {
        phone?: string;
    }
    interface customer_checkout_one_time_for_items_params {
        locale?: string;
    }
    interface customer_checkout_one_time_for_items_params {
        taxability?: string;
    }
    interface customer_checkout_one_time_for_items_params {
        vat_number?: string;
    }
    interface customer_checkout_one_time_for_items_params {
        vat_number_prefix?: string;
    }
    interface customer_checkout_one_time_for_items_params {
        einvoicing_method?: string;
    }
    interface customer_checkout_one_time_for_items_params {
        is_einvoice_enabled?: boolean;
    }
    interface customer_checkout_one_time_for_items_params {
        entity_identifier_scheme?: string;
    }
    interface customer_checkout_one_time_for_items_params {
        entity_identifier_standard?: string;
    }
    interface customer_checkout_one_time_for_items_params {
        consolidated_invoicing?: boolean;
    }
    interface invoice_checkout_one_time_for_items_params {
        po_number?: string;
    }
    interface card_checkout_one_time_for_items_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        gateway?: string;
    }
    interface card_checkout_one_time_for_items_params {
        gateway_account_id?: string;
    }
    interface billing_address_checkout_one_time_for_items_params {
        first_name?: string;
    }
    interface billing_address_checkout_one_time_for_items_params {
        last_name?: string;
    }
    interface billing_address_checkout_one_time_for_items_params {
        email?: string;
    }
    interface billing_address_checkout_one_time_for_items_params {
        company?: string;
    }
    interface billing_address_checkout_one_time_for_items_params {
        phone?: string;
    }
    interface billing_address_checkout_one_time_for_items_params {
        line1?: string;
    }
    interface billing_address_checkout_one_time_for_items_params {
        line2?: string;
    }
    interface billing_address_checkout_one_time_for_items_params {
        line3?: string;
    }
    interface billing_address_checkout_one_time_for_items_params {
        city?: string;
    }
    interface billing_address_checkout_one_time_for_items_params {
        state_code?: string;
    }
    interface billing_address_checkout_one_time_for_items_params {
        state?: string;
    }
    interface billing_address_checkout_one_time_for_items_params {
        zip?: string;
    }
    interface billing_address_checkout_one_time_for_items_params {
        country?: string;
    }
    interface billing_address_checkout_one_time_for_items_params {
        validation_status?: string;
    }
    interface shipping_address_checkout_one_time_for_items_params {
        first_name?: string;
    }
    interface shipping_address_checkout_one_time_for_items_params {
        last_name?: string;
    }
    interface shipping_address_checkout_one_time_for_items_params {
        email?: string;
    }
    interface shipping_address_checkout_one_time_for_items_params {
        company?: string;
    }
    interface shipping_address_checkout_one_time_for_items_params {
        phone?: string;
    }
    interface shipping_address_checkout_one_time_for_items_params {
        line1?: string;
    }
    interface shipping_address_checkout_one_time_for_items_params {
        line2?: string;
    }
    interface shipping_address_checkout_one_time_for_items_params {
        line3?: string;
    }
    interface shipping_address_checkout_one_time_for_items_params {
        city?: string;
    }
    interface shipping_address_checkout_one_time_for_items_params {
        state_code?: string;
    }
    interface shipping_address_checkout_one_time_for_items_params {
        state?: string;
    }
    interface shipping_address_checkout_one_time_for_items_params {
        zip?: string;
    }
    interface shipping_address_checkout_one_time_for_items_params {
        country?: string;
    }
    interface shipping_address_checkout_one_time_for_items_params {
        validation_status?: string;
    }
    interface item_prices_checkout_one_time_for_items_params {
        item_price_id?: string;
    }
    interface item_prices_checkout_one_time_for_items_params {
        quantity?: number;
    }
    interface item_prices_checkout_one_time_for_items_params {
        quantity_in_decimal?: string;
    }
    interface item_prices_checkout_one_time_for_items_params {
        unit_price?: number;
    }
    interface item_prices_checkout_one_time_for_items_params {
        unit_price_in_decimal?: string;
    }
    interface item_prices_checkout_one_time_for_items_params {
        date_from?: number;
    }
    interface item_prices_checkout_one_time_for_items_params {
        date_to?: number;
    }
    interface item_tiers_checkout_one_time_for_items_params {
        item_price_id?: string;
    }
    interface item_tiers_checkout_one_time_for_items_params {
        starting_unit?: number;
    }
    interface item_tiers_checkout_one_time_for_items_params {
        ending_unit?: number;
    }
    interface item_tiers_checkout_one_time_for_items_params {
        price?: number;
    }
    interface item_tiers_checkout_one_time_for_items_params {
        starting_unit_in_decimal?: string;
    }
    interface item_tiers_checkout_one_time_for_items_params {
        ending_unit_in_decimal?: string;
    }
    interface item_tiers_checkout_one_time_for_items_params {
        price_in_decimal?: string;
    }
    interface item_tiers_checkout_one_time_for_items_params {
        pricing_type?: string;
    }
    interface item_tiers_checkout_one_time_for_items_params {
        package_size?: number;
    }
    interface charges_checkout_one_time_for_items_params {
        amount?: number;
    }
    interface charges_checkout_one_time_for_items_params {
        amount_in_decimal?: string;
    }
    interface charges_checkout_one_time_for_items_params {
        description?: string;
    }
    interface charges_checkout_one_time_for_items_params {
        taxable?: boolean;
    }
    interface charges_checkout_one_time_for_items_params {
        tax_profile_id?: string;
    }
    interface charges_checkout_one_time_for_items_params {
        avalara_tax_code?: string;
    }
    interface charges_checkout_one_time_for_items_params {
        hsn_code?: string;
    }
    interface charges_checkout_one_time_for_items_params {
        taxjar_product_code?: string;
    }
    interface charges_checkout_one_time_for_items_params {
        avalara_sale_type?: string;
    }
    interface charges_checkout_one_time_for_items_params {
        avalara_transaction_type?: number;
    }
    interface charges_checkout_one_time_for_items_params {
        avalara_service_type?: number;
    }
    interface charges_checkout_one_time_for_items_params {
        date_from?: number;
    }
    interface charges_checkout_one_time_for_items_params {
        date_to?: number;
    }
    interface discounts_checkout_one_time_for_items_params {
        percentage?: number;
    }
    interface discounts_checkout_one_time_for_items_params {
        amount?: number;
    }
    interface discounts_checkout_one_time_for_items_params {
        apply_on: string;
    }
    interface discounts_checkout_one_time_for_items_params {
        item_price_id?: string;
    }
    interface entity_identifiers_checkout_one_time_for_items_params {
        id?: string;
    }
    interface entity_identifiers_checkout_one_time_for_items_params {
        scheme?: string;
    }
    interface entity_identifiers_checkout_one_time_for_items_params {
        value?: string;
    }
    interface entity_identifiers_checkout_one_time_for_items_params {
        operation?: string;
    }
    interface entity_identifiers_checkout_one_time_for_items_params {
        standard?: string;
    }
    interface subscription_checkout_new_for_items_params {
        id?: string;
    }
    interface subscription_checkout_new_for_items_params {
        trial_end?: number;
    }
    interface subscription_checkout_new_for_items_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        setup_fee?: number;
    }
    interface subscription_checkout_new_for_items_params {
        start_date?: number;
    }
    interface subscription_checkout_new_for_items_params {
        coupon?: string;
    }
    interface subscription_checkout_new_for_items_params {
        auto_collection?: string;
    }
    interface subscription_checkout_new_for_items_params {
        invoice_notes?: string;
    }
    interface subscription_checkout_new_for_items_params {
        po_number?: string;
    }
    interface subscription_checkout_new_for_items_params {
        contract_term_billing_cycle_on_renewal?: number;
    }
    interface customer_checkout_new_for_items_params {
        id?: string;
    }
    interface customer_checkout_new_for_items_params {
        email?: string;
    }
    interface customer_checkout_new_for_items_params {
        first_name?: string;
    }
    interface customer_checkout_new_for_items_params {
        last_name?: string;
    }
    interface customer_checkout_new_for_items_params {
        company?: string;
    }
    interface customer_checkout_new_for_items_params {
        phone?: string;
    }
    interface customer_checkout_new_for_items_params {
        locale?: string;
    }
    interface customer_checkout_new_for_items_params {
        taxability?: string;
    }
    interface customer_checkout_new_for_items_params {
        vat_number?: string;
    }
    interface customer_checkout_new_for_items_params {
        vat_number_prefix?: string;
    }
    interface customer_checkout_new_for_items_params {
        is_einvoice_enabled?: boolean;
    }
    interface customer_checkout_new_for_items_params {
        entity_identifier_scheme?: string;
    }
    interface customer_checkout_new_for_items_params {
        entity_identifier_standard?: string;
    }
    interface customer_checkout_new_for_items_params {
        einvoicing_method?: string;
    }
    interface card_checkout_new_for_items_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        gateway?: string;
    }
    interface card_checkout_new_for_items_params {
        gateway_account_id?: string;
    }
    interface billing_address_checkout_new_for_items_params {
        first_name?: string;
    }
    interface billing_address_checkout_new_for_items_params {
        last_name?: string;
    }
    interface billing_address_checkout_new_for_items_params {
        email?: string;
    }
    interface billing_address_checkout_new_for_items_params {
        company?: string;
    }
    interface billing_address_checkout_new_for_items_params {
        phone?: string;
    }
    interface billing_address_checkout_new_for_items_params {
        line1?: string;
    }
    interface billing_address_checkout_new_for_items_params {
        line2?: string;
    }
    interface billing_address_checkout_new_for_items_params {
        line3?: string;
    }
    interface billing_address_checkout_new_for_items_params {
        city?: string;
    }
    interface billing_address_checkout_new_for_items_params {
        state_code?: string;
    }
    interface billing_address_checkout_new_for_items_params {
        state?: string;
    }
    interface billing_address_checkout_new_for_items_params {
        zip?: string;
    }
    interface billing_address_checkout_new_for_items_params {
        country?: string;
    }
    interface billing_address_checkout_new_for_items_params {
        validation_status?: string;
    }
    interface shipping_address_checkout_new_for_items_params {
        first_name?: string;
    }
    interface shipping_address_checkout_new_for_items_params {
        last_name?: string;
    }
    interface shipping_address_checkout_new_for_items_params {
        email?: string;
    }
    interface shipping_address_checkout_new_for_items_params {
        company?: string;
    }
    interface shipping_address_checkout_new_for_items_params {
        phone?: string;
    }
    interface shipping_address_checkout_new_for_items_params {
        line1?: string;
    }
    interface shipping_address_checkout_new_for_items_params {
        line2?: string;
    }
    interface shipping_address_checkout_new_for_items_params {
        line3?: string;
    }
    interface shipping_address_checkout_new_for_items_params {
        city?: string;
    }
    interface shipping_address_checkout_new_for_items_params {
        state_code?: string;
    }
    interface shipping_address_checkout_new_for_items_params {
        state?: string;
    }
    interface shipping_address_checkout_new_for_items_params {
        zip?: string;
    }
    interface shipping_address_checkout_new_for_items_params {
        country?: string;
    }
    interface shipping_address_checkout_new_for_items_params {
        validation_status?: string;
    }
    interface contract_term_checkout_new_for_items_params {
        action_at_term_end?: string;
    }
    interface contract_term_checkout_new_for_items_params {
        cancellation_cutoff_period?: number;
    }
    interface subscription_items_checkout_new_for_items_params {
        item_price_id: string;
    }
    interface subscription_items_checkout_new_for_items_params {
        quantity?: number;
    }
    interface subscription_items_checkout_new_for_items_params {
        quantity_in_decimal?: string;
    }
    interface subscription_items_checkout_new_for_items_params {
        unit_price?: number;
    }
    interface subscription_items_checkout_new_for_items_params {
        unit_price_in_decimal?: string;
    }
    interface subscription_items_checkout_new_for_items_params {
        billing_cycles?: number;
    }
    interface subscription_items_checkout_new_for_items_params {
        trial_end?: number;
    }
    interface subscription_items_checkout_new_for_items_params {
        service_period_days?: number;
    }
    interface subscription_items_checkout_new_for_items_params {
        charge_on_event?: string;
    }
    interface subscription_items_checkout_new_for_items_params {
        charge_once?: boolean;
    }
    interface subscription_items_checkout_new_for_items_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        item_type?: string;
    }
    interface discounts_checkout_new_for_items_params {
        apply_on?: string;
    }
    interface discounts_checkout_new_for_items_params {
        duration_type: string;
    }
    interface discounts_checkout_new_for_items_params {
        percentage?: number;
    }
    interface discounts_checkout_new_for_items_params {
        amount?: number;
    }
    interface discounts_checkout_new_for_items_params {
        period?: number;
    }
    interface discounts_checkout_new_for_items_params {
        period_unit?: string;
    }
    interface discounts_checkout_new_for_items_params {
        included_in_mrr?: boolean;
    }
    interface discounts_checkout_new_for_items_params {
        item_price_id?: string;
    }
    interface subscription_items_checkout_new_for_items_params {
        charge_on_option?: string;
    }
    interface item_tiers_checkout_new_for_items_params {
        item_price_id?: string;
    }
    interface item_tiers_checkout_new_for_items_params {
        starting_unit?: number;
    }
    interface item_tiers_checkout_new_for_items_params {
        ending_unit?: number;
    }
    interface item_tiers_checkout_new_for_items_params {
        price?: number;
    }
    interface item_tiers_checkout_new_for_items_params {
        starting_unit_in_decimal?: string;
    }
    interface item_tiers_checkout_new_for_items_params {
        ending_unit_in_decimal?: string;
    }
    interface item_tiers_checkout_new_for_items_params {
        price_in_decimal?: string;
    }
    interface item_tiers_checkout_new_for_items_params {
        pricing_type?: string;
    }
    interface item_tiers_checkout_new_for_items_params {
        package_size?: number;
    }
    interface entity_identifiers_checkout_new_for_items_params {
        id?: string;
    }
    interface entity_identifiers_checkout_new_for_items_params {
        scheme?: string;
    }
    interface entity_identifiers_checkout_new_for_items_params {
        value?: string;
    }
    interface entity_identifiers_checkout_new_for_items_params {
        operation?: string;
    }
    interface entity_identifiers_checkout_new_for_items_params {
        standard?: string;
    }
    interface subscription_checkout_existing_params {
        id: string;
    }
    interface subscription_checkout_existing_params {
        plan_id?: string;
    }
    interface subscription_checkout_existing_params {
        plan_quantity?: number;
    }
    interface subscription_checkout_existing_params {
        plan_unit_price?: number;
    }
    interface subscription_checkout_existing_params {
        setup_fee?: number;
    }
    interface subscription_checkout_existing_params {
        plan_quantity_in_decimal?: string;
    }
    interface subscription_checkout_existing_params {
        plan_unit_price_in_decimal?: string;
    }
    interface subscription_checkout_existing_params {
        start_date?: number;
    }
    interface subscription_checkout_existing_params {
        trial_end?: number;
    }
    interface subscription_checkout_existing_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        coupon?: string;
    }
    interface subscription_checkout_existing_params {
        auto_collection?: string;
    }
    interface subscription_checkout_existing_params {
        offline_payment_method?: string;
    }
    interface subscription_checkout_existing_params {
        invoice_notes?: string;
    }
    interface subscription_checkout_existing_params {
        contract_term_billing_cycle_on_renewal?: number;
    }
    interface customer_checkout_existing_params {
        vat_number?: string;
    }
    interface customer_checkout_existing_params {
        vat_number_prefix?: string;
    }
    interface card_checkout_existing_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        gateway?: string;
    }
    interface card_checkout_existing_params {
        gateway_account_id?: string;
    }
    interface contract_term_checkout_existing_params {
        action_at_term_end?: string;
    }
    interface contract_term_checkout_existing_params {
        cancellation_cutoff_period?: number;
    }
    interface addons_checkout_existing_params {
        id?: string;
    }
    interface addons_checkout_existing_params {
        quantity?: number;
    }
    interface addons_checkout_existing_params {
        unit_price?: number;
    }
    interface addons_checkout_existing_params {
        billing_cycles?: number;
    }
    interface addons_checkout_existing_params {
        quantity_in_decimal?: string;
    }
    interface addons_checkout_existing_params {
        unit_price_in_decimal?: string;
    }
    interface event_based_addons_checkout_existing_params {
        id?: string;
    }
    interface event_based_addons_checkout_existing_params {
        quantity?: number;
    }
    interface event_based_addons_checkout_existing_params {
        unit_price?: number;
    }
    interface event_based_addons_checkout_existing_params {
        service_period_in_days?: number;
    }
    interface event_based_addons_checkout_existing_params {
        charge_on?: string;
    }
    interface event_based_addons_checkout_existing_params {
        on_event?: string;
    }
    interface event_based_addons_checkout_existing_params {
        charge_once?: boolean;
    }
    interface event_based_addons_checkout_existing_params {
        quantity_in_decimal?: string;
    }
    interface event_based_addons_checkout_existing_params {
        unit_price_in_decimal?: string;
    }
    interface subscription_checkout_existing_for_items_params {
        id: string;
    }
    interface subscription_checkout_existing_for_items_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        setup_fee?: number;
    }
    interface subscription_checkout_existing_for_items_params {
        start_date?: number;
    }
    interface subscription_checkout_existing_for_items_params {
        trial_end?: number;
    }
    interface subscription_checkout_existing_for_items_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        coupon?: string;
    }
    interface subscription_checkout_existing_for_items_params {
        auto_collection?: string;
    }
    interface subscription_checkout_existing_for_items_params {
        offline_payment_method?: string;
    }
    interface subscription_checkout_existing_for_items_params {
        invoice_notes?: string;
    }
    interface subscription_checkout_existing_for_items_params {
        contract_term_billing_cycle_on_renewal?: number;
    }
    interface customer_checkout_existing_for_items_params {
        vat_number?: string;
    }
    interface customer_checkout_existing_for_items_params {
        vat_number_prefix?: string;
    }
    interface customer_checkout_existing_for_items_params {
        is_einvoice_enabled?: boolean;
    }
    interface customer_checkout_existing_for_items_params {
        entity_identifier_scheme?: string;
    }
    interface customer_checkout_existing_for_items_params {
        entity_identifier_standard?: string;
    }
    interface card_checkout_existing_for_items_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        gateway?: string;
    }
    interface card_checkout_existing_for_items_params {
        gateway_account_id?: string;
    }
    interface contract_term_checkout_existing_for_items_params {
        action_at_term_end?: string;
    }
    interface contract_term_checkout_existing_for_items_params {
        cancellation_cutoff_period?: number;
    }
    interface subscription_items_checkout_existing_for_items_params {
        item_price_id: string;
    }
    interface subscription_items_checkout_existing_for_items_params {
        quantity?: number;
    }
    interface subscription_items_checkout_existing_for_items_params {
        quantity_in_decimal?: string;
    }
    interface subscription_items_checkout_existing_for_items_params {
        unit_price?: number;
    }
    interface subscription_items_checkout_existing_for_items_params {
        unit_price_in_decimal?: string;
    }
    interface subscription_items_checkout_existing_for_items_params {
        billing_cycles?: number;
    }
    interface subscription_items_checkout_existing_for_items_params {
        trial_end?: number;
    }
    interface subscription_items_checkout_existing_for_items_params {
        service_period_days?: number;
    }
    interface subscription_items_checkout_existing_for_items_params {
        charge_on_event?: string;
    }
    interface subscription_items_checkout_existing_for_items_params {
        charge_once?: boolean;
    }
    interface subscription_items_checkout_existing_for_items_params {
        charge_on_option?: string;
    }
    interface subscription_items_checkout_existing_for_items_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        item_type?: string;
    }
    interface discounts_checkout_existing_for_items_params {
        apply_on?: string;
    }
    interface discounts_checkout_existing_for_items_params {
        duration_type: string;
    }
    interface discounts_checkout_existing_for_items_params {
        percentage?: number;
    }
    interface discounts_checkout_existing_for_items_params {
        amount?: number;
    }
    interface discounts_checkout_existing_for_items_params {
        period?: number;
    }
    interface discounts_checkout_existing_for_items_params {
        period_unit?: string;
    }
    interface discounts_checkout_existing_for_items_params {
        included_in_mrr?: boolean;
    }
    interface discounts_checkout_existing_for_items_params {
        item_price_id?: string;
    }
    interface discounts_checkout_existing_for_items_params {
        operation_type: string;
    }
    interface discounts_checkout_existing_for_items_params {
        id?: string;
    }
    interface item_tiers_checkout_existing_for_items_params {
        item_price_id?: string;
    }
    interface item_tiers_checkout_existing_for_items_params {
        starting_unit?: number;
    }
    interface item_tiers_checkout_existing_for_items_params {
        ending_unit?: number;
    }
    interface item_tiers_checkout_existing_for_items_params {
        price?: number;
    }
    interface item_tiers_checkout_existing_for_items_params {
        starting_unit_in_decimal?: string;
    }
    interface item_tiers_checkout_existing_for_items_params {
        ending_unit_in_decimal?: string;
    }
    interface item_tiers_checkout_existing_for_items_params {
        price_in_decimal?: string;
    }
    interface item_tiers_checkout_existing_for_items_params {
        pricing_type?: string;
    }
    interface item_tiers_checkout_existing_for_items_params {
        package_size?: number;
    }
    interface entity_identifiers_checkout_existing_for_items_params {
        id?: string;
    }
    interface entity_identifiers_checkout_existing_for_items_params {
        scheme?: string;
    }
    interface entity_identifiers_checkout_existing_for_items_params {
        value?: string;
    }
    interface entity_identifiers_checkout_existing_for_items_params {
        operation?: string;
    }
    interface entity_identifiers_checkout_existing_for_items_params {
        standard?: string;
    }
    interface customer_update_card_params {
        id: string;
    }
    interface customer_update_card_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        vat_number?: string;
    }
    interface customer_update_card_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        vat_number_prefix?: string;
    }
    interface card_update_card_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        gateway?: string;
    }
    interface card_update_card_params {
        gateway_account_id?: string;
    }
    interface customer_update_payment_method_params {
        id: string;
    }
    interface customer_update_payment_method_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        vat_number?: string;
    }
    interface customer_update_payment_method_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        vat_number_prefix?: string;
    }
    interface card_update_payment_method_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        gateway?: string;
    }
    interface card_update_payment_method_params {
        gateway_account_id?: string;
    }
    interface customer_manage_payment_sources_params {
        id: string;
    }
    interface card_manage_payment_sources_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        gateway?: string;
    }
    interface card_manage_payment_sources_params {
        gateway_account_id?: string;
    }
    interface customer_collect_now_params {
        id: string;
    }
    interface card_collect_now_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        gateway?: string;
    }
    interface card_collect_now_params {
        gateway_account_id?: string;
    }
    interface quote_accept_quote_params {
        id: string;
    }
    interface subscription_extend_subscription_params {
        id: string;
    }
    interface gifter_checkout_gift_params {
        customer_id?: string;
    }
    interface subscription_checkout_gift_params {
        plan_id: string;
    }
    interface subscription_checkout_gift_params {
        plan_quantity?: number;
    }
    interface subscription_checkout_gift_params {
        plan_quantity_in_decimal?: string;
    }
    interface subscription_checkout_gift_params {
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        coupon?: string;
    }
    interface addons_checkout_gift_params {
        id?: string;
    }
    interface addons_checkout_gift_params {
        quantity?: number;
    }
    interface addons_checkout_gift_params {
        quantity_in_decimal?: string;
    }
    interface gifter_checkout_gift_for_items_params {
        customer_id?: string;
    }
    interface subscription_items_checkout_gift_for_items_params {
        item_price_id?: string;
    }
    interface subscription_items_checkout_gift_for_items_params {
        quantity?: number;
    }
    interface subscription_items_checkout_gift_for_items_params {
        quantity_in_decimal?: string;
    }
    interface gift_claim_gift_params {
        id: string;
    }
    interface customer_claim_gift_params {
        locale?: string;
    }
    interface subscription_pre_cancel_params {
        id: string;
    }
    interface payment_voucher_view_voucher_params {
        id: string;
    }
    interface customer_view_voucher_params {
        locale?: string;
    }
}
