"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HostedPage = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class HostedPage extends model_1.Model {
    // OPERATIONS
    //-----------
    static checkout_new(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'checkout_new',
            'httpMethod': 'POST',
            'urlPrefix': '/hosted_pages',
            'urlSuffix': '/checkout_new',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static checkout_one_time(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'checkout_one_time',
            'httpMethod': 'POST',
            'urlPrefix': '/hosted_pages',
            'urlSuffix': '/checkout_one_time',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static checkout_one_time_for_items(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'checkout_one_time_for_items',
            'httpMethod': 'POST',
            'urlPrefix': '/hosted_pages',
            'urlSuffix': '/checkout_one_time_for_items',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static checkout_new_for_items(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'checkout_new_for_items',
            'httpMethod': 'POST',
            'urlPrefix': '/hosted_pages',
            'urlSuffix': '/checkout_new_for_items',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static checkout_existing(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'checkout_existing',
            'httpMethod': 'POST',
            'urlPrefix': '/hosted_pages',
            'urlSuffix': '/checkout_existing',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static checkout_existing_for_items(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'checkout_existing_for_items',
            'httpMethod': 'POST',
            'urlPrefix': '/hosted_pages',
            'urlSuffix': '/checkout_existing_for_items',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static update_card(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'update_card',
            'httpMethod': 'POST',
            'urlPrefix': '/hosted_pages',
            'urlSuffix': '/update_card',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static update_payment_method(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'update_payment_method',
            'httpMethod': 'POST',
            'urlPrefix': '/hosted_pages',
            'urlSuffix': '/update_payment_method',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static manage_payment_sources(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'manage_payment_sources',
            'httpMethod': 'POST',
            'urlPrefix': '/hosted_pages',
            'urlSuffix': '/manage_payment_sources',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static collect_now(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'collect_now',
            'httpMethod': 'POST',
            'urlPrefix': '/hosted_pages',
            'urlSuffix': '/collect_now',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static accept_quote(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'accept_quote',
            'httpMethod': 'POST',
            'urlPrefix': '/hosted_pages',
            'urlSuffix': '/accept_quote',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static extend_subscription(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'extend_subscription',
            'httpMethod': 'POST',
            'urlPrefix': '/hosted_pages',
            'urlSuffix': '/extend_subscription',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static checkout_gift(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'checkout_gift',
            'httpMethod': 'POST',
            'urlPrefix': '/hosted_pages',
            'urlSuffix': '/checkout_gift',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static checkout_gift_for_items(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'checkout_gift_for_items',
            'httpMethod': 'POST',
            'urlPrefix': '/hosted_pages',
            'urlSuffix': '/checkout_gift_for_items',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static claim_gift(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'claim_gift',
            'httpMethod': 'POST',
            'urlPrefix': '/hosted_pages',
            'urlSuffix': '/claim_gift',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static retrieve_agreement_pdf(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'retrieve_agreement_pdf',
            'httpMethod': 'POST',
            'urlPrefix': '/hosted_pages',
            'urlSuffix': '/retrieve_agreement_pdf',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static acknowledge(hosted_page_id, params) {
        return new request_wrapper_1.RequestWrapper([hosted_page_id, params], {
            'methodName': 'acknowledge',
            'httpMethod': 'POST',
            'urlPrefix': '/hosted_pages',
            'urlSuffix': '/acknowledge',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static retrieve(hosted_page_id, params) {
        return new request_wrapper_1.RequestWrapper([hosted_page_id, params], {
            'methodName': 'retrieve',
            'httpMethod': 'GET',
            'urlPrefix': '/hosted_pages',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static list(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'list',
            'httpMethod': 'GET',
            'urlPrefix': '/hosted_pages',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static pre_cancel(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'pre_cancel',
            'httpMethod': 'POST',
            'urlPrefix': '/hosted_pages',
            'urlSuffix': '/pre_cancel',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static events(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'events',
            'httpMethod': 'POST',
            'urlPrefix': '/hosted_pages',
            'urlSuffix': '/events',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "event_data": 0,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static view_voucher(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'view_voucher',
            'httpMethod': 'POST',
            'urlPrefix': '/hosted_pages',
            'urlSuffix': '/view_voucher',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~HostedPage
exports.HostedPage = HostedPage;
