import { RequestWrapper } from "../request_wrapper";
import { Model } from "./model";
export declare class InAppSubscription extends Model {
    app_id: string;
    subscription_id: string;
    customer_id?: string;
    plan_id?: string;
    store_status?: string;
    invoice_id?: string;
    static process_receipt(in_app_subscription_id: string, params?: _in_app_subscription.process_receipt_params): RequestWrapper;
    static import_receipt(in_app_subscription_id: string, params?: _in_app_subscription.import_receipt_params): RequestWrapper;
    static import_subscription(in_app_subscription_id: string, params?: _in_app_subscription.import_subscription_params): RequestWrapper;
    static retrieve_store_subs(in_app_subscription_id: string, params?: _in_app_subscription.retrieve_store_subs_params): RequestWrapper;
}
export declare namespace _in_app_subscription {
    interface process_receipt_params {
        receipt: string;
        product?: product_process_receipt_params;
        customer?: customer_process_receipt_params;
    }
    interface import_receipt_params {
        receipt: string;
        product?: product_import_receipt_params;
        customer?: customer_import_receipt_params;
    }
    interface import_subscription_params {
        subscription?: subscription_import_subscription_params;
        customer?: customer_import_subscription_params;
    }
    interface retrieve_store_subs_params {
        receipt: string;
    }
    interface product_process_receipt_params {
        id: string;
    }
    interface product_process_receipt_params {
        currency_code: string;
    }
    interface product_process_receipt_params {
        price: number;
    }
    interface product_process_receipt_params {
        name?: string;
    }
    interface product_process_receipt_params {
        price_in_decimal?: string;
    }
    interface product_process_receipt_params {
        period?: string;
    }
    interface product_process_receipt_params {
        period_unit?: string;
    }
    interface customer_process_receipt_params {
        id?: string;
    }
    interface customer_process_receipt_params {
        email?: string;
    }
    interface customer_process_receipt_params {
        first_name?: string;
    }
    interface customer_process_receipt_params {
        last_name?: string;
    }
    interface product_import_receipt_params {
        currency_code: string;
    }
    interface customer_import_receipt_params {
        id?: string;
    }
    interface customer_import_receipt_params {
        email?: string;
    }
    interface subscription_import_subscription_params {
        id: string;
    }
    interface subscription_import_subscription_params {
        started_at: number;
    }
    interface subscription_import_subscription_params {
        term_start: number;
    }
    interface subscription_import_subscription_params {
        term_end: number;
    }
    interface subscription_import_subscription_params {
        product_id: string;
    }
    interface subscription_import_subscription_params {
        currency_code: string;
    }
    interface subscription_import_subscription_params {
        transaction_id: string;
    }
    interface subscription_import_subscription_params {
        is_trial?: boolean;
    }
    interface customer_import_subscription_params {
        id?: string;
    }
    interface customer_import_subscription_params {
        email?: string;
    }
}
