"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InAppSubscription = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class InAppSubscription extends model_1.Model {
    // OPERATIONS
    //-----------
    static process_receipt(in_app_subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([in_app_subscription_id, params], {
            'methodName': 'process_receipt',
            'httpMethod': 'POST',
            'urlPrefix': '/in_app_subscriptions',
            'urlSuffix': '/process_purchase_command',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static import_receipt(in_app_subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([in_app_subscription_id, params], {
            'methodName': 'import_receipt',
            'httpMethod': 'POST',
            'urlPrefix': '/in_app_subscriptions',
            'urlSuffix': '/import_receipt',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static import_subscription(in_app_subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([in_app_subscription_id, params], {
            'methodName': 'import_subscription',
            'httpMethod': 'POST',
            'urlPrefix': '/in_app_subscriptions',
            'urlSuffix': '/import_subscription',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static retrieve_store_subs(in_app_subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([in_app_subscription_id, params], {
            'methodName': 'retrieve_store_subs',
            'httpMethod': 'POST',
            'urlPrefix': '/in_app_subscriptions',
            'urlSuffix': '/retrieve',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~InAppSubscription
exports.InAppSubscription = InAppSubscription;
