"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BundleConfiguration = exports.BundleItem = exports.ApplicableItem = exports.Item = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class Item extends model_1.Model {
    // OPERATIONS
    //-----------
    static create(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create',
            'httpMethod': 'POST',
            'urlPrefix': '/items',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "metadata": 0,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static retrieve(item_id, params) {
        return new request_wrapper_1.RequestWrapper([item_id, params], {
            'methodName': 'retrieve',
            'httpMethod': 'GET',
            'urlPrefix': '/items',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static update(item_id, params) {
        return new request_wrapper_1.RequestWrapper([item_id, params], {
            'methodName': 'update',
            'httpMethod': 'POST',
            'urlPrefix': '/items',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "metadata": 0,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static list(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'list',
            'httpMethod': 'GET',
            'urlPrefix': '/items',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static delete(item_id, params) {
        return new request_wrapper_1.RequestWrapper([item_id, params], {
            'methodName': 'delete',
            'httpMethod': 'POST',
            'urlPrefix': '/items',
            'urlSuffix': '/delete',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~Item
exports.Item = Item;
class ApplicableItem extends model_1.Model {
} // ~ApplicableItem
exports.ApplicableItem = ApplicableItem;
class BundleItem extends model_1.Model {
} // ~BundleItem
exports.BundleItem = BundleItem;
class BundleConfiguration extends model_1.Model {
} // ~BundleConfiguration
exports.BundleConfiguration = BundleConfiguration;
