import { ListResult } from '../list_result';
import { RequestWrapper } from "../request_wrapper";
import { Model } from "./model";
export declare class ItemEntitlement extends Model {
    id: string;
    item_id?: string;
    item_type?: string;
    feature_id?: string;
    feature_name?: string;
    value?: string;
    name?: string;
    static item_entitlements_for_item(item_id: string, params?: _item_entitlement.item_entitlement_item_entitlements_for_item_params): RequestWrapper<ListResult>;
    static item_entitlements_for_feature(feature_id: string, params?: _item_entitlement.item_entitlement_item_entitlements_for_feature_params): RequestWrapper<ListResult>;
    static add_item_entitlements(feature_id: string, params?: _item_entitlement.add_item_entitlements_params): RequestWrapper;
    static upsert_or_remove_item_entitlements_for_item(item_id: string, params?: _item_entitlement.upsert_or_remove_item_entitlements_for_item_params): RequestWrapper;
}
export declare namespace _item_entitlement {
    interface item_entitlement_item_entitlements_for_item_params {
        limit?: number;
        offset?: string;
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        include_drafts?: boolean;
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        embed?: string;
    }
    interface item_entitlement_item_entitlements_for_feature_params {
        limit?: number;
        offset?: string;
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        include_drafts?: boolean;
    }
    interface add_item_entitlements_params {
        action: string;
        item_entitlements?: Array<item_entitlements_add_item_entitlements_params>;
    }
    interface upsert_or_remove_item_entitlements_for_item_params {
        action: string;
        item_entitlements?: Array<item_entitlements_upsert_or_remove_item_entitlements_for_item_params>;
    }
    interface item_entitlements_add_item_entitlements_params {
        item_id: string;
    }
    interface item_entitlements_add_item_entitlements_params {
        item_type?: string;
    }
    interface item_entitlements_add_item_entitlements_params {
        value?: string;
    }
    interface item_entitlements_upsert_or_remove_item_entitlements_for_item_params {
        feature_id: string;
    }
    interface item_entitlements_upsert_or_remove_item_entitlements_for_item_params {
        value?: string;
    }
}
