"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ItemEntitlement = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class ItemEntitlement extends model_1.Model {
    // OPERATIONS
    //-----------
    static item_entitlements_for_item(item_id, params) {
        return new request_wrapper_1.RequestWrapper([item_id, params], {
            'methodName': 'item_entitlements_for_item',
            'httpMethod': 'GET',
            'urlPrefix': '/items',
            'urlSuffix': '/item_entitlements',
            'hasIdInUrl': true,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static item_entitlements_for_feature(feature_id, params) {
        return new request_wrapper_1.RequestWrapper([feature_id, params], {
            'methodName': 'item_entitlements_for_feature',
            'httpMethod': 'GET',
            'urlPrefix': '/features',
            'urlSuffix': '/item_entitlements',
            'hasIdInUrl': true,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static add_item_entitlements(feature_id, params) {
        return new request_wrapper_1.RequestWrapper([feature_id, params], {
            'methodName': 'add_item_entitlements',
            'httpMethod': 'POST',
            'urlPrefix': '/features',
            'urlSuffix': '/item_entitlements',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static upsert_or_remove_item_entitlements_for_item(item_id, params) {
        return new request_wrapper_1.RequestWrapper([item_id, params], {
            'methodName': 'upsert_or_remove_item_entitlements_for_item',
            'httpMethod': 'POST',
            'urlPrefix': '/items',
            'urlSuffix': '/item_entitlements',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~ItemEntitlement
exports.ItemEntitlement = ItemEntitlement;
