import { ListResult } from '../list_result';
import { RequestWrapper } from "../request_wrapper";
import { Model } from "./model";
import { filter } from "../filter";
export declare class ItemFamily extends Model {
    id: string;
    name: string;
    description?: string;
    status?: string;
    resource_version?: number;
    updated_at?: number;
    channel?: string;
    business_entity_id?: string;
    deleted: boolean;
    static create(params?: _item_family.create_params): RequestWrapper;
    static retrieve(item_family_id: string, params?: any): RequestWrapper;
    static list(params?: _item_family.item_family_list_params): RequestWrapper<ListResult>;
    static update(item_family_id: string, params?: _item_family.update_params): RequestWrapper;
    static delete(item_family_id: string, params?: any): RequestWrapper;
}
export declare namespace _item_family {
    interface create_params {
        id: string;
        name: string;
        description?: string;
        business_entity_id?: string;
    }
    interface item_family_list_params {
        limit?: number;
        offset?: string;
        id?: filter._string;
        name?: filter._string;
        updated_at?: filter._timestamp;
        business_entity_id?: filter._string;
        include_site_level_resources?: filter._boolean;
    }
    interface update_params {
        name?: string;
        description?: string;
    }
}
