"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ItemFamily = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class ItemFamily extends model_1.Model {
    // OPERATIONS
    //-----------
    static create(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create',
            'httpMethod': 'POST',
            'urlPrefix': '/item_families',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static retrieve(item_family_id, params) {
        return new request_wrapper_1.RequestWrapper([item_family_id, params], {
            'methodName': 'retrieve',
            'httpMethod': 'GET',
            'urlPrefix': '/item_families',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static list(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'list',
            'httpMethod': 'GET',
            'urlPrefix': '/item_families',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static update(item_family_id, params) {
        return new request_wrapper_1.RequestWrapper([item_family_id, params], {
            'methodName': 'update',
            'httpMethod': 'POST',
            'urlPrefix': '/item_families',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static delete(item_family_id, params) {
        return new request_wrapper_1.RequestWrapper([item_family_id, params], {
            'methodName': 'delete',
            'httpMethod': 'POST',
            'urlPrefix': '/item_families',
            'urlSuffix': '/delete',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~ItemFamily
exports.ItemFamily = ItemFamily;
