"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccountingDetail = exports.TaxProvidersField = exports.TaxDetail = exports.Tier = exports.ItemPrice = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class ItemPrice extends model_1.Model {
    // OPERATIONS
    //-----------
    static create(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create',
            'httpMethod': 'POST',
            'urlPrefix': '/item_prices',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "metadata": 0,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static retrieve(item_price_id, params) {
        return new request_wrapper_1.RequestWrapper([item_price_id, params], {
            'methodName': 'retrieve',
            'httpMethod': 'GET',
            'urlPrefix': '/item_prices',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static update(item_price_id, params) {
        return new request_wrapper_1.RequestWrapper([item_price_id, params], {
            'methodName': 'update',
            'httpMethod': 'POST',
            'urlPrefix': '/item_prices',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "metadata": 0,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static list(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'list',
            'httpMethod': 'GET',
            'urlPrefix': '/item_prices',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static delete(item_price_id, params) {
        return new request_wrapper_1.RequestWrapper([item_price_id, params], {
            'methodName': 'delete',
            'httpMethod': 'POST',
            'urlPrefix': '/item_prices',
            'urlSuffix': '/delete',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static find_applicable_items(item_price_id, params) {
        return new request_wrapper_1.RequestWrapper([item_price_id, params], {
            'methodName': 'find_applicable_items',
            'httpMethod': 'GET',
            'urlPrefix': '/item_prices',
            'urlSuffix': '/applicable_items',
            'hasIdInUrl': true,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static find_applicable_item_prices(item_price_id, params) {
        return new request_wrapper_1.RequestWrapper([item_price_id, params], {
            'methodName': 'find_applicable_item_prices',
            'httpMethod': 'GET',
            'urlPrefix': '/item_prices',
            'urlSuffix': '/applicable_item_prices',
            'hasIdInUrl': true,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~ItemPrice
exports.ItemPrice = ItemPrice;
class Tier extends model_1.Model {
} // ~Tier
exports.Tier = Tier;
class TaxDetail extends model_1.Model {
} // ~TaxDetail
exports.TaxDetail = TaxDetail;
class TaxProvidersField extends model_1.Model {
} // ~TaxProvidersField
exports.TaxProvidersField = TaxProvidersField;
class AccountingDetail extends model_1.Model {
} // ~AccountingDetail
exports.AccountingDetail = AccountingDetail;
