import * as resources from ".";
import { ListResult } from '../list_result';
import { RequestWrapper } from "../request_wrapper";
import { Model } from "./model";
import { filter } from "../filter";
export declare class OmnichannelSubscription extends Model {
    id: string;
    id_at_source: string;
    app_id: string;
    source: string;
    customer_id?: string;
    created_at: number;
    resource_version?: number;
    omnichannel_subscription_items: Array<resources.OmnichannelSubscriptionItem>;
    initial_purchase_transaction?: OmnichannelTransaction;
    static retrieve(omnichannel_subscription_id: string, params?: any): RequestWrapper;
    static list(params?: _omnichannel_subscription.omnichannel_subscription_list_params): RequestWrapper<ListResult>;
    static omnichannel_transactions_for_omnichannel_subscription(omnichannel_subscription_id: string, params?: any): RequestWrapper<ListResult>;
}
export declare class OmnichannelTransaction extends Model {
    id: string;
    id_at_source: string;
    app_id: string;
    price_currency?: string;
    price_units?: number;
    price_nanos?: number;
    type: string;
    transacted_at?: number;
    created_at: number;
    resource_version?: number;
}
export declare namespace _omnichannel_subscription {
    interface omnichannel_subscription_list_params {
        limit?: number;
        offset?: string;
        source?: filter._enum;
        customer_id?: filter._string;
    }
}
