"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OmnichannelTransaction = exports.OmnichannelSubscription = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class OmnichannelSubscription extends model_1.Model {
    // OPERATIONS
    //-----------
    static retrieve(omnichannel_subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([omnichannel_subscription_id, params], {
            'methodName': 'retrieve',
            'httpMethod': 'GET',
            'urlPrefix': '/omnichannel_subscriptions',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static list(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'list',
            'httpMethod': 'GET',
            'urlPrefix': '/omnichannel_subscriptions',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static omnichannel_transactions_for_omnichannel_subscription(omnichannel_subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([omnichannel_subscription_id, params], {
            'methodName': 'omnichannel_transactions_for_omnichannel_subscription',
            'httpMethod': 'GET',
            'urlPrefix': '/omnichannel_subscriptions',
            'urlSuffix': '/omnichannel_transactions',
            'hasIdInUrl': true,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~OmnichannelSubscription
exports.OmnichannelSubscription = OmnichannelSubscription;
class OmnichannelTransaction extends model_1.Model {
} // ~OmnichannelTransaction
exports.OmnichannelTransaction = OmnichannelTransaction;
