import { ListResult } from '../list_result';
import { RequestWrapper } from "../request_wrapper";
import { Model } from "./model";
export declare class OmnichannelSubscriptionItem extends Model {
    id: string;
    item_id_at_source: string;
    item_parent_id_at_source?: string;
    status: string;
    auto_renew_status?: string;
    current_term_start?: number;
    current_term_end?: number;
    expired_at?: number;
    expiration_reason?: string;
    cancelled_at?: number;
    cancellation_reason?: string;
    grace_period_expires_at?: number;
    resumes_at?: number;
    has_scheduled_changes: boolean;
    resource_version?: number;
    upcoming_renewal?: UpcomingRenewal;
    linked_item?: LinkedItem;
    static list_omni_sub_item_schedule_changes(omnichannel_subscription_item_id: string, params?: any): RequestWrapper<ListResult>;
}
export declare class UpcomingRenewal extends Model {
    price_currency?: string;
    price_units?: number;
    price_nanos?: number;
}
export declare class LinkedItem extends Model {
    id: string;
    linked_at?: number;
}
export declare namespace _omnichannel_subscription_item {
}
