import * as resources from ".";
import { RequestWrapper } from "../request_wrapper";
import { Model } from "./model";
export declare class PaymentIntent extends Model {
    id: string;
    status: string;
    currency_code?: string;
    amount: number;
    gateway_account_id: string;
    expires_at: number;
    reference_id?: string;
    payment_method_type?: string;
    success_url?: string;
    failure_url?: string;
    created_at: number;
    modified_at: number;
    resource_version?: number;
    updated_at?: number;
    customer_id: string;
    gateway?: string;
    active_payment_attempt?: PaymentAttempt;
    business_entity_id?: string;
    static create(params?: _payment_intent.create_params): RequestWrapper;
    static update(payment_intent_id: string, params?: _payment_intent.update_params): RequestWrapper;
    static retrieve(payment_intent_id: string, params?: any): RequestWrapper;
}
export declare class PaymentAttempt extends Model {
    id?: string;
    status: string;
    payment_method_type?: string;
    id_at_gateway?: string;
    error_code?: string;
    error_text?: string;
    created_at: number;
    modified_at: number;
    error_detail?: resources.GatewayErrorDetail;
}
export declare namespace _payment_intent {
    interface create_params {
        business_entity_id?: string;
        customer_id?: string;
        amount: number;
        currency_code: string;
        gateway_account_id?: string;
        reference_id?: string;
        payment_method_type?: string;
        success_url?: string;
        failure_url?: string;
    }
    interface update_params {
        amount?: number;
        currency_code?: string;
        gateway_account_id?: string;
        payment_method_type?: string;
        success_url?: string;
        failure_url?: string;
    }
}
