"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PaymentAttempt = exports.PaymentIntent = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class PaymentIntent extends model_1.Model {
    // OPERATIONS
    //-----------
    static create(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create',
            'httpMethod': 'POST',
            'urlPrefix': '/payment_intents',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static update(payment_intent_id, params) {
        return new request_wrapper_1.RequestWrapper([payment_intent_id, params], {
            'methodName': 'update',
            'httpMethod': 'POST',
            'urlPrefix': '/payment_intents',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static retrieve(payment_intent_id, params) {
        return new request_wrapper_1.RequestWrapper([payment_intent_id, params], {
            'methodName': 'retrieve',
            'httpMethod': 'GET',
            'urlPrefix': '/payment_intents',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~PaymentIntent
exports.PaymentIntent = PaymentIntent;
class PaymentAttempt extends model_1.Model {
} // ~PaymentAttempt
exports.PaymentAttempt = PaymentAttempt;
