import { RequestWrapper } from "../request_wrapper";
import { Model } from "./model";
export declare class PaymentScheduleScheme extends Model {
    id: string;
    name?: string;
    description?: string;
    number_of_schedules: number;
    period_unit: string;
    period?: number;
    created_at: number;
    resource_version?: number;
    updated_at?: number;
    preferred_schedules?: Array<PreferredSchedule>;
    static create(params?: _payment_schedule_scheme.create_params): RequestWrapper;
    static retrieve(payment_schedule_scheme_id: string, params?: any): RequestWrapper;
    static delete(payment_schedule_scheme_id: string, params?: any): RequestWrapper;
}
export declare class PreferredSchedule extends Model {
    period?: number;
    amount_percentage?: number;
}
export declare namespace _payment_schedule_scheme {
    interface create_params {
        number_of_schedules: number;
        period_unit: string;
        period?: number;
        name: string;
        flexible_schedules?: Array<flexible_schedules_create_params>;
    }
    interface flexible_schedules_create_params {
        period?: number;
    }
    interface flexible_schedules_create_params {
        amount_percentage?: number;
    }
}
