"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PreferredSchedule = exports.PaymentScheduleScheme = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class PaymentScheduleScheme extends model_1.Model {
    // OPERATIONS
    //-----------
    static create(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create',
            'httpMethod': 'POST',
            'urlPrefix': '/payment_schedule_schemes',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static retrieve(payment_schedule_scheme_id, params) {
        return new request_wrapper_1.RequestWrapper([payment_schedule_scheme_id, params], {
            'methodName': 'retrieve',
            'httpMethod': 'GET',
            'urlPrefix': '/payment_schedule_schemes',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static delete(payment_schedule_scheme_id, params) {
        return new request_wrapper_1.RequestWrapper([payment_schedule_scheme_id, params], {
            'methodName': 'delete',
            'httpMethod': 'POST',
            'urlPrefix': '/payment_schedule_schemes',
            'urlSuffix': '/delete',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~PaymentScheduleScheme
exports.PaymentScheduleScheme = PaymentScheduleScheme;
class PreferredSchedule extends model_1.Model {
} // ~PreferredSchedule
exports.PreferredSchedule = PreferredSchedule;
