"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LinkedInvoice = exports.PaymentVoucher = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class PaymentVoucher extends model_1.Model {
    // OPERATIONS
    //-----------
    static create(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create',
            'httpMethod': 'POST',
            'urlPrefix': '/payment_vouchers',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static retrieve(payment_voucher_id, params) {
        return new request_wrapper_1.RequestWrapper([payment_voucher_id, params], {
            'methodName': 'retrieve',
            'httpMethod': 'GET',
            'urlPrefix': '/payment_vouchers',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static payment_vouchers_for_invoice(invoice_id, params) {
        return new request_wrapper_1.RequestWrapper([invoice_id, params], {
            'methodName': 'payment_vouchers_for_invoice',
            'httpMethod': 'GET',
            'urlPrefix': '/invoices',
            'urlSuffix': '/payment_vouchers',
            'hasIdInUrl': true,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static payment_vouchers_for_customer(customer_id, params) {
        return new request_wrapper_1.RequestWrapper([customer_id, params], {
            'methodName': 'payment_vouchers_for_customer',
            'httpMethod': 'GET',
            'urlPrefix': '/customers',
            'urlSuffix': '/payment_vouchers',
            'hasIdInUrl': true,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~PaymentVoucher
exports.PaymentVoucher = PaymentVoucher;
class LinkedInvoice extends model_1.Model {
} // ~LinkedInvoice
exports.LinkedInvoice = LinkedInvoice;
