"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EventBasedAddon = exports.AttachedAddon = exports.ApplicableAddon = exports.TaxProvidersField = exports.Tier = exports.Plan = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class Plan extends model_1.Model {
    // OPERATIONS
    //-----------
    static create(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create',
            'httpMethod': 'POST',
            'urlPrefix': '/plans',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "meta_data": 0,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static update(plan_id, params) {
        return new request_wrapper_1.RequestWrapper([plan_id, params], {
            'methodName': 'update',
            'httpMethod': 'POST',
            'urlPrefix': '/plans',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "meta_data": 0,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static list(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'list',
            'httpMethod': 'GET',
            'urlPrefix': '/plans',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static retrieve(plan_id, params) {
        return new request_wrapper_1.RequestWrapper([plan_id, params], {
            'methodName': 'retrieve',
            'httpMethod': 'GET',
            'urlPrefix': '/plans',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static delete(plan_id, params) {
        return new request_wrapper_1.RequestWrapper([plan_id, params], {
            'methodName': 'delete',
            'httpMethod': 'POST',
            'urlPrefix': '/plans',
            'urlSuffix': '/delete',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static copy(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'copy',
            'httpMethod': 'POST',
            'urlPrefix': '/plans',
            'urlSuffix': '/copy',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static unarchive(plan_id, params) {
        return new request_wrapper_1.RequestWrapper([plan_id, params], {
            'methodName': 'unarchive',
            'httpMethod': 'POST',
            'urlPrefix': '/plans',
            'urlSuffix': '/unarchive',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~Plan
exports.Plan = Plan;
class Tier extends model_1.Model {
} // ~Tier
exports.Tier = Tier;
class TaxProvidersField extends model_1.Model {
} // ~TaxProvidersField
exports.TaxProvidersField = TaxProvidersField;
class ApplicableAddon extends model_1.Model {
} // ~ApplicableAddon
exports.ApplicableAddon = ApplicableAddon;
class AttachedAddon extends model_1.Model {
} // ~AttachedAddon
exports.AttachedAddon = AttachedAddon;
class EventBasedAddon extends model_1.Model {
} // ~EventBasedAddon
exports.EventBasedAddon = EventBasedAddon;
