import { RequestWrapper } from "../request_wrapper";
import { Model } from "./model";
export declare class PortalSession extends Model {
    id: string;
    token: string;
    access_url: string;
    redirect_url?: string;
    status: string;
    created_at: number;
    expires_at?: number;
    customer_id: string;
    login_at?: number;
    logout_at?: number;
    login_ipaddress?: string;
    logout_ipaddress?: string;
    linked_customers?: Array<LinkedCustomer>;
    static create(params?: _portal_session.create_params): RequestWrapper;
    static retrieve(portal_session_id: string, params?: any): RequestWrapper;
    static logout(portal_session_id: string, params?: any): RequestWrapper;
    static activate(portal_session_id: string, params?: _portal_session.activate_params): RequestWrapper;
}
export declare class LinkedCustomer extends Model {
    customer_id: string;
    email?: string;
    has_billing_address: boolean;
    has_payment_method: boolean;
    has_active_subscription: boolean;
}
export declare namespace _portal_session {
    interface create_params {
        redirect_url?: string;
        forward_url?: string;
        customer?: customer_create_params;
    }
    interface activate_params {
        token: string;
    }
    interface customer_create_params {
        id: string;
    }
}
