"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LinkedCustomer = exports.PortalSession = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class PortalSession extends model_1.Model {
    // OPERATIONS
    //-----------
    static create(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create',
            'httpMethod': 'POST',
            'urlPrefix': '/portal_sessions',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static retrieve(portal_session_id, params) {
        return new request_wrapper_1.RequestWrapper([portal_session_id, params], {
            'methodName': 'retrieve',
            'httpMethod': 'GET',
            'urlPrefix': '/portal_sessions',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static logout(portal_session_id, params) {
        return new request_wrapper_1.RequestWrapper([portal_session_id, params], {
            'methodName': 'logout',
            'httpMethod': 'POST',
            'urlPrefix': '/portal_sessions',
            'urlSuffix': '/logout',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static activate(portal_session_id, params) {
        return new request_wrapper_1.RequestWrapper([portal_session_id, params], {
            'methodName': 'activate',
            'httpMethod': 'POST',
            'urlPrefix': '/portal_sessions',
            'urlSuffix': '/activate',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~PortalSession
exports.PortalSession = PortalSession;
class LinkedCustomer extends model_1.Model {
} // ~LinkedCustomer
exports.LinkedCustomer = LinkedCustomer;
