import { RequestWrapper } from "../request_wrapper";
import { Model } from "./model";
export declare class PricingPageSession extends Model {
    id?: string;
    url?: string;
    created_at?: number;
    expires_at?: number;
    static create_for_new_subscription(params?: _pricing_page_session.create_for_new_subscription_params): RequestWrapper;
    static create_for_existing_subscription(params?: _pricing_page_session.create_for_existing_subscription_params): RequestWrapper;
}
export declare namespace _pricing_page_session {
    interface create_for_new_subscription_params {
        redirect_url?: string;
        business_entity_id?: string;
        pricing_page?: pricing_page_create_for_new_subscription_params;
        subscription?: subscription_create_for_new_subscription_params;
        customer?: customer_create_for_new_subscription_params;
        billing_address?: billing_address_create_for_new_subscription_params;
        shipping_address?: shipping_address_create_for_new_subscription_params;
        discounts?: Array<discounts_create_for_new_subscription_params>;
    }
    interface create_for_existing_subscription_params {
        redirect_url?: string;
        pricing_page?: pricing_page_create_for_existing_subscription_params;
        subscription?: subscription_create_for_existing_subscription_params;
        discounts?: Array<discounts_create_for_existing_subscription_params>;
    }
    interface pricing_page_create_for_new_subscription_params {
        id: string;
    }
    interface subscription_create_for_new_subscription_params {
        id?: string;
    }
    interface customer_create_for_new_subscription_params {
        id?: string;
    }
    interface customer_create_for_new_subscription_params {
        email?: string;
    }
    interface customer_create_for_new_subscription_params {
        first_name?: string;
    }
    interface customer_create_for_new_subscription_params {
        last_name?: string;
    }
    interface customer_create_for_new_subscription_params {
        company?: string;
    }
    interface customer_create_for_new_subscription_params {
        phone?: string;
    }
    interface customer_create_for_new_subscription_params {
        locale?: string;
    }
    interface billing_address_create_for_new_subscription_params {
        first_name?: string;
    }
    interface billing_address_create_for_new_subscription_params {
        last_name?: string;
    }
    interface billing_address_create_for_new_subscription_params {
        email?: string;
    }
    interface billing_address_create_for_new_subscription_params {
        company?: string;
    }
    interface billing_address_create_for_new_subscription_params {
        phone?: string;
    }
    interface billing_address_create_for_new_subscription_params {
        line1?: string;
    }
    interface billing_address_create_for_new_subscription_params {
        line2?: string;
    }
    interface billing_address_create_for_new_subscription_params {
        line3?: string;
    }
    interface billing_address_create_for_new_subscription_params {
        city?: string;
    }
    interface billing_address_create_for_new_subscription_params {
        state_code?: string;
    }
    interface billing_address_create_for_new_subscription_params {
        state?: string;
    }
    interface billing_address_create_for_new_subscription_params {
        zip?: string;
    }
    interface billing_address_create_for_new_subscription_params {
        country?: string;
    }
    interface billing_address_create_for_new_subscription_params {
        validation_status?: string;
    }
    interface shipping_address_create_for_new_subscription_params {
        first_name?: string;
    }
    interface shipping_address_create_for_new_subscription_params {
        last_name?: string;
    }
    interface shipping_address_create_for_new_subscription_params {
        email?: string;
    }
    interface shipping_address_create_for_new_subscription_params {
        company?: string;
    }
    interface shipping_address_create_for_new_subscription_params {
        phone?: string;
    }
    interface shipping_address_create_for_new_subscription_params {
        line1?: string;
    }
    interface shipping_address_create_for_new_subscription_params {
        line2?: string;
    }
    interface shipping_address_create_for_new_subscription_params {
        line3?: string;
    }
    interface shipping_address_create_for_new_subscription_params {
        city?: string;
    }
    interface shipping_address_create_for_new_subscription_params {
        state_code?: string;
    }
    interface shipping_address_create_for_new_subscription_params {
        state?: string;
    }
    interface shipping_address_create_for_new_subscription_params {
        zip?: string;
    }
    interface shipping_address_create_for_new_subscription_params {
        country?: string;
    }
    interface shipping_address_create_for_new_subscription_params {
        validation_status?: string;
    }
    interface discounts_create_for_new_subscription_params {
        apply_on?: string;
    }
    interface discounts_create_for_new_subscription_params {
        duration_type: string;
    }
    interface discounts_create_for_new_subscription_params {
        percentage?: number;
    }
    interface discounts_create_for_new_subscription_params {
        amount?: number;
    }
    interface discounts_create_for_new_subscription_params {
        period?: number;
    }
    interface discounts_create_for_new_subscription_params {
        period_unit?: string;
    }
    interface discounts_create_for_new_subscription_params {
        included_in_mrr?: boolean;
    }
    interface discounts_create_for_new_subscription_params {
        item_price_id?: string;
    }
    interface discounts_create_for_new_subscription_params {
        label?: string;
    }
    interface pricing_page_create_for_existing_subscription_params {
        id: string;
    }
    interface subscription_create_for_existing_subscription_params {
        id: string;
    }
    interface discounts_create_for_existing_subscription_params {
        apply_on?: string;
    }
    interface discounts_create_for_existing_subscription_params {
        duration_type: string;
    }
    interface discounts_create_for_existing_subscription_params {
        percentage?: number;
    }
    interface discounts_create_for_existing_subscription_params {
        amount?: number;
    }
    interface discounts_create_for_existing_subscription_params {
        period?: number;
    }
    interface discounts_create_for_existing_subscription_params {
        period_unit?: string;
    }
    interface discounts_create_for_existing_subscription_params {
        included_in_mrr?: boolean;
    }
    interface discounts_create_for_existing_subscription_params {
        item_price_id?: string;
    }
    interface discounts_create_for_existing_subscription_params {
        label?: string;
    }
}
