"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PricingPageSession = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class PricingPageSession extends model_1.Model {
    // OPERATIONS
    //-----------
    static create_for_new_subscription(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create_for_new_subscription',
            'httpMethod': 'POST',
            'urlPrefix': '/pricing_page_sessions',
            'urlSuffix': '/create_for_new_subscription',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static create_for_existing_subscription(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create_for_existing_subscription',
            'httpMethod': 'POST',
            'urlPrefix': '/pricing_page_sessions',
            'urlSuffix': '/create_for_existing_subscription',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~PricingPageSession
exports.PricingPageSession = PricingPageSession;
