"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PromotionalCredit = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class PromotionalCredit extends model_1.Model {
    // OPERATIONS
    //-----------
    static add(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'add',
            'httpMethod': 'POST',
            'urlPrefix': '/promotional_credits',
            'urlSuffix': '/add',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static deduct(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'deduct',
            'httpMethod': 'POST',
            'urlPrefix': '/promotional_credits',
            'urlSuffix': '/deduct',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static set(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'set',
            'httpMethod': 'POST',
            'urlPrefix': '/promotional_credits',
            'urlSuffix': '/set',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static list(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'list',
            'httpMethod': 'GET',
            'urlPrefix': '/promotional_credits',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static retrieve(promotional_credit_id, params) {
        return new request_wrapper_1.RequestWrapper([promotional_credit_id, params], {
            'methodName': 'retrieve',
            'httpMethod': 'GET',
            'urlPrefix': '/promotional_credits',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~PromotionalCredit
exports.PromotionalCredit = PromotionalCredit;
