"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Purchase = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class Purchase extends model_1.Model {
    // OPERATIONS
    //-----------
    static create(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create',
            'httpMethod': 'POST',
            'urlPrefix': '/purchases',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "additional_information": 1,
                "meta_data": 1,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static estimate(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'estimate',
            'httpMethod': 'POST',
            'urlPrefix': '/purchases',
            'urlSuffix': '/estimate',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "exemption_details": 1,
            }
        }, chargebee_1.ChargeBee._env);
    }
} // ~Purchase
exports.Purchase = Purchase;
