"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BillingAddress = exports.ShippingAddress = exports.LineItemTier = exports.LineItemTax = exports.Tax = exports.LineItemDiscount = exports.Discount = exports.LineItem = exports.Quote = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class Quote extends model_1.Model {
    // OPERATIONS
    //-----------
    static retrieve(quote_id, params) {
        return new request_wrapper_1.RequestWrapper([quote_id, params], {
            'methodName': 'retrieve',
            'httpMethod': 'GET',
            'urlPrefix': '/quotes',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static create_sub_for_customer_quote(customer_id, params) {
        return new request_wrapper_1.RequestWrapper([customer_id, params], {
            'methodName': 'create_sub_for_customer_quote',
            'httpMethod': 'POST',
            'urlPrefix': '/customers',
            'urlSuffix': '/create_subscription_quote',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static edit_create_sub_for_customer_quote(quote_id, params) {
        return new request_wrapper_1.RequestWrapper([quote_id, params], {
            'methodName': 'edit_create_sub_for_customer_quote',
            'httpMethod': 'POST',
            'urlPrefix': '/quotes',
            'urlSuffix': '/edit_create_subscription_quote',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static update_subscription_quote(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'update_subscription_quote',
            'httpMethod': 'POST',
            'urlPrefix': '/quotes',
            'urlSuffix': '/update_subscription_quote',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static edit_update_subscription_quote(quote_id, params) {
        return new request_wrapper_1.RequestWrapper([quote_id, params], {
            'methodName': 'edit_update_subscription_quote',
            'httpMethod': 'POST',
            'urlPrefix': '/quotes',
            'urlSuffix': '/edit_update_subscription_quote',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static create_for_onetime_charges(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create_for_onetime_charges',
            'httpMethod': 'POST',
            'urlPrefix': '/quotes',
            'urlSuffix': '/create_for_onetime_charges',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static edit_one_time_quote(quote_id, params) {
        return new request_wrapper_1.RequestWrapper([quote_id, params], {
            'methodName': 'edit_one_time_quote',
            'httpMethod': 'POST',
            'urlPrefix': '/quotes',
            'urlSuffix': '/edit_one_time_quote',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static create_sub_items_for_customer_quote(customer_id, params) {
        return new request_wrapper_1.RequestWrapper([customer_id, params], {
            'methodName': 'create_sub_items_for_customer_quote',
            'httpMethod': 'POST',
            'urlPrefix': '/customers',
            'urlSuffix': '/create_subscription_quote_for_items',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static edit_create_sub_customer_quote_for_items(quote_id, params) {
        return new request_wrapper_1.RequestWrapper([quote_id, params], {
            'methodName': 'edit_create_sub_customer_quote_for_items',
            'httpMethod': 'POST',
            'urlPrefix': '/quotes',
            'urlSuffix': '/edit_create_subscription_quote_for_items',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static update_subscription_quote_for_items(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'update_subscription_quote_for_items',
            'httpMethod': 'POST',
            'urlPrefix': '/quotes',
            'urlSuffix': '/update_subscription_quote_for_items',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static edit_update_subscription_quote_for_items(quote_id, params) {
        return new request_wrapper_1.RequestWrapper([quote_id, params], {
            'methodName': 'edit_update_subscription_quote_for_items',
            'httpMethod': 'POST',
            'urlPrefix': '/quotes',
            'urlSuffix': '/edit_update_subscription_quote_for_items',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static create_for_charge_items_and_charges(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create_for_charge_items_and_charges',
            'httpMethod': 'POST',
            'urlPrefix': '/quotes',
            'urlSuffix': '/create_for_charge_items_and_charges',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static edit_for_charge_items_and_charges(quote_id, params) {
        return new request_wrapper_1.RequestWrapper([quote_id, params], {
            'methodName': 'edit_for_charge_items_and_charges',
            'httpMethod': 'POST',
            'urlPrefix': '/quotes',
            'urlSuffix': '/edit_for_charge_items_and_charges',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static list(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'list',
            'httpMethod': 'GET',
            'urlPrefix': '/quotes',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static quote_line_groups_for_quote(quote_id, params) {
        return new request_wrapper_1.RequestWrapper([quote_id, params], {
            'methodName': 'quote_line_groups_for_quote',
            'httpMethod': 'GET',
            'urlPrefix': '/quotes',
            'urlSuffix': '/quote_line_groups',
            'hasIdInUrl': true,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static convert(quote_id, params) {
        return new request_wrapper_1.RequestWrapper([quote_id, params], {
            'methodName': 'convert',
            'httpMethod': 'POST',
            'urlPrefix': '/quotes',
            'urlSuffix': '/convert',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static update_status(quote_id, params) {
        return new request_wrapper_1.RequestWrapper([quote_id, params], {
            'methodName': 'update_status',
            'httpMethod': 'POST',
            'urlPrefix': '/quotes',
            'urlSuffix': '/update_status',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static extend_expiry_date(quote_id, params) {
        return new request_wrapper_1.RequestWrapper([quote_id, params], {
            'methodName': 'extend_expiry_date',
            'httpMethod': 'POST',
            'urlPrefix': '/quotes',
            'urlSuffix': '/extend_expiry_date',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static delete(quote_id, params) {
        return new request_wrapper_1.RequestWrapper([quote_id, params], {
            'methodName': 'delete',
            'httpMethod': 'POST',
            'urlPrefix': '/quotes',
            'urlSuffix': '/delete',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static pdf(quote_id, params) {
        return new request_wrapper_1.RequestWrapper([quote_id, params], {
            'methodName': 'pdf',
            'httpMethod': 'POST',
            'urlPrefix': '/quotes',
            'urlSuffix': '/pdf',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~Quote
exports.Quote = Quote;
class LineItem extends model_1.Model {
} // ~LineItem
exports.LineItem = LineItem;
class Discount extends model_1.Model {
} // ~Discount
exports.Discount = Discount;
class LineItemDiscount extends model_1.Model {
} // ~LineItemDiscount
exports.LineItemDiscount = LineItemDiscount;
class Tax extends model_1.Model {
} // ~Tax
exports.Tax = Tax;
class LineItemTax extends model_1.Model {
} // ~LineItemTax
exports.LineItemTax = LineItemTax;
class LineItemTier extends model_1.Model {
} // ~LineItemTier
exports.LineItemTier = LineItemTier;
class ShippingAddress extends model_1.Model {
} // ~ShippingAddress
exports.ShippingAddress = ShippingAddress;
class BillingAddress extends model_1.Model {
} // ~BillingAddress
exports.BillingAddress = BillingAddress;
