import { Model } from "./model";
export declare class QuotedCharge extends Model {
    charges?: Array<Charge>;
    addons?: Array<Addon>;
    invoice_items?: Array<InvoiceItem>;
    item_tiers?: Array<ItemTier>;
    coupons?: Array<Coupon>;
}
export declare class Charge extends Model {
    amount?: number;
    amount_in_decimal?: string;
    description?: string;
    service_period_in_days?: number;
    avalara_sale_type?: string;
    avalara_transaction_type?: number;
    avalara_service_type?: number;
}
export declare class Addon extends Model {
    id: string;
    quantity?: number;
    unit_price?: number;
    quantity_in_decimal?: string;
    unit_price_in_decimal?: string;
    proration_type?: string;
    service_period?: number;
}
export declare class InvoiceItem extends Model {
    item_price_id: string;
    quantity?: number;
    quantity_in_decimal?: string;
    unit_price?: number;
    unit_price_in_decimal?: string;
    service_period_days?: number;
}
export declare class ItemTier extends Model {
    item_price_id: string;
    starting_unit: number;
    ending_unit?: number;
    price: number;
    starting_unit_in_decimal?: string;
    ending_unit_in_decimal?: string;
    price_in_decimal?: string;
    pricing_type?: string;
    package_size?: number;
    index: number;
}
export declare class Coupon extends Model {
    coupon_id: string;
}
export declare namespace _quoted_charge {
}
