import { Model } from "./model";
export declare class QuotedRamp extends Model {
    id: string;
    line_items?: Array<LineItem>;
    discounts?: Array<Discount>;
    item_tiers?: Array<ItemTier>;
}
export declare class LineItem extends Model {
    item_price_id: string;
    item_type: string;
    quantity?: number;
    quantity_in_decimal?: string;
    metered_quantity?: string;
    unit_price?: number;
    unit_price_in_decimal?: string;
    amount?: number;
    amount_in_decimal?: string;
    billing_period?: number;
    billing_period_unit?: string;
    free_quantity?: number;
    free_quantity_in_decimal?: string;
    billing_cycles?: number;
    service_period_days?: number;
    charge_on_event?: string;
    charge_once?: boolean;
    charge_on_option?: string;
    start_date?: number;
    end_date?: number;
    ramp_tier_id?: string;
    discount_amount?: number;
    md_discount_amount?: string;
    item_level_discount_amount?: number;
    md_item_level_discount_amount?: string;
    discount_per_billing_cycle?: number;
    discount_per_billing_cycle_in_decimal?: string;
    item_level_discount_per_billing_cycle?: number;
    item_level_discount_per_billing_cycle_in_decimal?: string;
    net_amount?: number;
    md_net_amount?: string;
    amount_per_billing_cycle?: number;
    amount_per_billing_cycle_in_decimal?: string;
    net_amount_per_billing_cycle?: number;
    net_amount_per_billing_cycle_in_decimal?: string;
}
export declare class Discount extends Model {
    id: string;
    name: string;
    invoice_name?: string;
    type: string;
    percentage?: number;
    amount?: number;
    duration_type: string;
    entity_type: string;
    entity_id?: string;
    period?: number;
    period_unit?: string;
    included_in_mrr: boolean;
    apply_on: string;
    apply_on_item_type?: string;
    item_price_id?: string;
    created_at: number;
    updated_at?: number;
    start_date?: number;
    end_date?: number;
}
export declare class ItemTier extends Model {
    item_price_id: string;
    starting_unit: number;
    ending_unit?: number;
    price: number;
    starting_unit_in_decimal?: string;
    ending_unit_in_decimal?: string;
    price_in_decimal?: string;
    ramp_tier_id?: string;
}
export declare namespace _quoted_ramp {
}
