import { Model } from "./model";
export declare class QuotedSubscription extends Model {
    id: string;
    plan_id: string;
    plan_quantity: number;
    plan_unit_price?: number;
    setup_fee?: number;
    billing_period?: number;
    billing_period_unit?: string;
    start_date?: number;
    trial_end?: number;
    remaining_billing_cycles?: number;
    po_number?: string;
    auto_collection?: string;
    plan_quantity_in_decimal?: string;
    plan_unit_price_in_decimal?: string;
    changes_scheduled_at?: number;
    change_option?: string;
    contract_term_billing_cycle_on_renewal?: number;
    addons?: Array<Addon>;
    event_based_addons?: Array<EventBasedAddon>;
    coupons?: Array<Coupon>;
    subscription_items?: Array<SubscriptionItem>;
    item_tiers?: Array<ItemTier>;
    quoted_contract_term?: QuotedContractTerm;
}
export declare class Addon extends Model {
    id: string;
    quantity?: number;
    unit_price?: number;
    amount?: number;
    trial_end?: number;
    remaining_billing_cycles?: number;
    quantity_in_decimal?: string;
    unit_price_in_decimal?: string;
    amount_in_decimal?: string;
    proration_type?: string;
}
export declare class EventBasedAddon extends Model {
    id: string;
    quantity: number;
    unit_price: number;
    service_period_in_days?: number;
    on_event: string;
    charge_once: boolean;
    quantity_in_decimal?: string;
    unit_price_in_decimal?: string;
}
export declare class Coupon extends Model {
    coupon_id: string;
}
export declare class SubscriptionItem extends Model {
    item_price_id: string;
    item_type: string;
    quantity?: number;
    quantity_in_decimal?: string;
    metered_quantity?: string;
    last_calculated_at?: number;
    unit_price?: number;
    unit_price_in_decimal?: string;
    amount?: number;
    current_term_start?: number;
    current_term_end?: number;
    next_billing_at?: number;
    amount_in_decimal?: string;
    billing_period?: number;
    billing_period_unit?: string;
    free_quantity?: number;
    free_quantity_in_decimal?: string;
    trial_end?: number;
    billing_cycles?: number;
    service_period_days?: number;
    charge_on_event?: string;
    charge_once?: boolean;
    charge_on_option?: string;
    proration_type?: string;
    usage_accumulation_reset_frequency?: string;
}
export declare class ItemTier extends Model {
    item_price_id: string;
    starting_unit: number;
    ending_unit?: number;
    price: number;
    starting_unit_in_decimal?: string;
    ending_unit_in_decimal?: string;
    price_in_decimal?: string;
    pricing_type?: string;
    package_size?: number;
    index: number;
}
export declare class QuotedContractTerm extends Model {
    contract_start: number;
    contract_end: number;
    billing_cycle: number;
    action_at_term_end: string;
    total_contract_value: number;
    cancellation_cutoff_period?: number;
}
export declare namespace _quoted_subscription {
}
