"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StatusTransitionReason = exports.ItemTier = exports.DiscountsToAdd = exports.CouponsToAdd = exports.ItemsToUpdate = exports.ItemsToAdd = exports.Ramp = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class Ramp extends model_1.Model {
    // OPERATIONS
    //-----------
    static create_for_subscription(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'create_for_subscription',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/create_ramp',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static update(ramp_id, params) {
        return new request_wrapper_1.RequestWrapper([ramp_id, params], {
            'methodName': 'update',
            'httpMethod': 'POST',
            'urlPrefix': '/ramps',
            'urlSuffix': '/update',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static retrieve(ramp_id, params) {
        return new request_wrapper_1.RequestWrapper([ramp_id, params], {
            'methodName': 'retrieve',
            'httpMethod': 'GET',
            'urlPrefix': '/ramps',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static delete(ramp_id, params) {
        return new request_wrapper_1.RequestWrapper([ramp_id, params], {
            'methodName': 'delete',
            'httpMethod': 'POST',
            'urlPrefix': '/ramps',
            'urlSuffix': '/delete',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static list(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'list',
            'httpMethod': 'GET',
            'urlPrefix': '/ramps',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~Ramp
exports.Ramp = Ramp;
class ItemsToAdd extends model_1.Model {
} // ~ItemsToAdd
exports.ItemsToAdd = ItemsToAdd;
class ItemsToUpdate extends model_1.Model {
} // ~ItemsToUpdate
exports.ItemsToUpdate = ItemsToUpdate;
class CouponsToAdd extends model_1.Model {
} // ~CouponsToAdd
exports.CouponsToAdd = CouponsToAdd;
class DiscountsToAdd extends model_1.Model {
} // ~DiscountsToAdd
exports.DiscountsToAdd = DiscountsToAdd;
class ItemTier extends model_1.Model {
} // ~ItemTier
exports.ItemTier = ItemTier;
class StatusTransitionReason extends model_1.Model {
} // ~StatusTransitionReason
exports.StatusTransitionReason = StatusTransitionReason;
