import { RequestWrapper } from "../request_wrapper";
import { Model } from "./model";
export declare class RecordedPurchase extends Model {
    id: string;
    customer_id: string;
    app_id: string;
    source: string;
    status: string;
    omnichannel_transaction_id?: string;
    created_at: number;
    resource_version?: number;
    linked_omnichannel_subscriptions?: Array<LinkedOmnichannelSubscription>;
    error_detail?: ErrorDetail;
    static create(params?: _recorded_purchase.create_params): RequestWrapper;
    static retrieve(recorded_purchase_id: string, params?: any): RequestWrapper;
}
export declare class LinkedOmnichannelSubscription extends Model {
    omnichannel_subscription_id?: string;
}
export declare class ErrorDetail extends Model {
    error_message?: string;
}
export declare namespace _recorded_purchase {
    interface create_params {
        app_id: string;
        customer?: customer_create_params;
        apple_app_store?: apple_app_store_create_params;
        google_play_store?: google_play_store_create_params;
    }
    interface customer_create_params {
        id: string;
    }
    interface apple_app_store_create_params {
        transaction_id?: string;
    }
    interface apple_app_store_create_params {
        receipt?: string;
    }
    interface apple_app_store_create_params {
        product_id?: string;
    }
    interface google_play_store_create_params {
        purchase_token?: string;
    }
}
