"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ErrorDetail = exports.LinkedOmnichannelSubscription = exports.RecordedPurchase = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class RecordedPurchase extends model_1.Model {
    // OPERATIONS
    //-----------
    static create(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create',
            'httpMethod': 'POST',
            'urlPrefix': '/recorded_purchases',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static retrieve(recorded_purchase_id, params) {
        return new request_wrapper_1.RequestWrapper([recorded_purchase_id, params], {
            'methodName': 'retrieve',
            'httpMethod': 'GET',
            'urlPrefix': '/recorded_purchases',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~RecordedPurchase
exports.RecordedPurchase = RecordedPurchase;
class LinkedOmnichannelSubscription extends model_1.Model {
} // ~LinkedOmnichannelSubscription
exports.LinkedOmnichannelSubscription = LinkedOmnichannelSubscription;
class ErrorDetail extends model_1.Model {
} // ~ErrorDetail
exports.ErrorDetail = ErrorDetail;
