"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Discount = exports.ContractTerm = exports.BillingOverride = exports.ReferralInfo = exports.ShippingAddress = exports.Coupon = exports.ChargedEventBasedAddon = exports.EventBasedAddon = exports.Addon = exports.ChargedItem = exports.ItemTier = exports.SubscriptionItem = exports.Subscription = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class Subscription extends model_1.Model {
    // OPERATIONS
    //-----------
    static create(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "meta_data": 0,
                "exemption_details": 1,
                "additional_information": 1,
                "billing_address": 1,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static create_for_customer(customer_id, params) {
        return new request_wrapper_1.RequestWrapper([customer_id, params], {
            'methodName': 'create_for_customer',
            'httpMethod': 'POST',
            'urlPrefix': '/customers',
            'urlSuffix': '/subscriptions',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "meta_data": 0,
                "additional_information": 1,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static create_with_items(customer_id, params) {
        return new request_wrapper_1.RequestWrapper([customer_id, params], {
            'methodName': 'create_with_items',
            'httpMethod': 'POST',
            'urlPrefix': '/customers',
            'urlSuffix': '/subscription_for_items',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "meta_data": 0,
                "additional_information": 1,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static list(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'list',
            'httpMethod': 'GET',
            'urlPrefix': '/subscriptions',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static subscriptions_for_customer(customer_id, params) {
        return new request_wrapper_1.RequestWrapper([customer_id, params], {
            'methodName': 'subscriptions_for_customer',
            'httpMethod': 'GET',
            'urlPrefix': '/customers',
            'urlSuffix': '/subscriptions',
            'hasIdInUrl': true,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static contract_terms_for_subscription(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'contract_terms_for_subscription',
            'httpMethod': 'GET',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/contract_terms',
            'hasIdInUrl': true,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static list_discounts(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'list_discounts',
            'httpMethod': 'GET',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/discounts',
            'hasIdInUrl': true,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static retrieve(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'retrieve',
            'httpMethod': 'GET',
            'urlPrefix': '/subscriptions',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static retrieve_with_scheduled_changes(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'retrieve_with_scheduled_changes',
            'httpMethod': 'GET',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/retrieve_with_scheduled_changes',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static remove_scheduled_changes(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'remove_scheduled_changes',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/remove_scheduled_changes',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static remove_scheduled_cancellation(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'remove_scheduled_cancellation',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/remove_scheduled_cancellation',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static remove_coupons(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'remove_coupons',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/remove_coupons',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static update(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'update',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "meta_data": 0,
                "additional_information": 1,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static update_for_items(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'update_for_items',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/update_for_items',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "meta_data": 0,
                "additional_information": 1,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static change_term_end(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'change_term_end',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/change_term_end',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static reactivate(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'reactivate',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/reactivate',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "additional_information": 1,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static add_charge_at_term_end(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'add_charge_at_term_end',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/add_charge_at_term_end',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static charge_addon_at_term_end(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'charge_addon_at_term_end',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/charge_addon_at_term_end',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static charge_future_renewals(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'charge_future_renewals',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/charge_future_renewals',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static edit_advance_invoice_schedule(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'edit_advance_invoice_schedule',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/edit_advance_invoice_schedule',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static retrieve_advance_invoice_schedule(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'retrieve_advance_invoice_schedule',
            'httpMethod': 'GET',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/retrieve_advance_invoice_schedule',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static remove_advance_invoice_schedule(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'remove_advance_invoice_schedule',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/remove_advance_invoice_schedule',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static regenerate_invoice(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'regenerate_invoice',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/regenerate_invoice',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static import_subscription(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'import_subscription',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/import_subscription',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "meta_data": 0,
                "additional_information": 1,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static import_for_customer(customer_id, params) {
        return new request_wrapper_1.RequestWrapper([customer_id, params], {
            'methodName': 'import_for_customer',
            'httpMethod': 'POST',
            'urlPrefix': '/customers',
            'urlSuffix': '/import_subscription',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "meta_data": 0,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static import_contract_term(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'import_contract_term',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/import_contract_term',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static import_unbilled_charges(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'import_unbilled_charges',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/import_unbilled_charges',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static import_for_items(customer_id, params) {
        return new request_wrapper_1.RequestWrapper([customer_id, params], {
            'methodName': 'import_for_items',
            'httpMethod': 'POST',
            'urlPrefix': '/customers',
            'urlSuffix': '/import_for_items',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "meta_data": 0,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static override_billing_profile(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'override_billing_profile',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/override_billing_profile',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static delete(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'delete',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/delete',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static pause(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'pause',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/pause',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static cancel(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'cancel',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/cancel',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static cancel_for_items(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'cancel_for_items',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/cancel_for_items',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static resume(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'resume',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/resume',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {
                "additional_information": 1,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static remove_scheduled_pause(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'remove_scheduled_pause',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/remove_scheduled_pause',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static remove_scheduled_resumption(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'remove_scheduled_resumption',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/remove_scheduled_resumption',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static move(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'move',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/move',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~Subscription
exports.Subscription = Subscription;
class SubscriptionItem extends model_1.Model {
} // ~SubscriptionItem
exports.SubscriptionItem = SubscriptionItem;
class ItemTier extends model_1.Model {
} // ~ItemTier
exports.ItemTier = ItemTier;
class ChargedItem extends model_1.Model {
} // ~ChargedItem
exports.ChargedItem = ChargedItem;
class Addon extends model_1.Model {
} // ~Addon
exports.Addon = Addon;
class EventBasedAddon extends model_1.Model {
} // ~EventBasedAddon
exports.EventBasedAddon = EventBasedAddon;
class ChargedEventBasedAddon extends model_1.Model {
} // ~ChargedEventBasedAddon
exports.ChargedEventBasedAddon = ChargedEventBasedAddon;
class Coupon extends model_1.Model {
} // ~Coupon
exports.Coupon = Coupon;
class ShippingAddress extends model_1.Model {
} // ~ShippingAddress
exports.ShippingAddress = ShippingAddress;
class ReferralInfo extends model_1.Model {
} // ~ReferralInfo
exports.ReferralInfo = ReferralInfo;
class BillingOverride extends model_1.Model {
} // ~BillingOverride
exports.BillingOverride = BillingOverride;
class ContractTerm extends model_1.Model {
} // ~ContractTerm
exports.ContractTerm = ContractTerm;
class Discount extends model_1.Model {
} // ~Discount
exports.Discount = Discount;
