import * as resources from ".";
import { ListResult } from '../list_result';
import { RequestWrapper } from "../request_wrapper";
import { Model } from "./model";
export declare class SubscriptionEntitlement extends Model {
    subscription_id: string;
    feature_id?: string;
    feature_name?: string;
    feature_unit?: string;
    feature_type?: string;
    value?: string;
    name?: string;
    is_overridden: boolean;
    is_enabled: boolean;
    effective_from?: number;
    schedule_status?: string;
    expires_at?: number;
    components?: Component;
    static subscription_entitlements_for_subscription(subscription_id: string, params?: _subscription_entitlement.subscription_entitlement_subscription_entitlements_for_subscription_params): RequestWrapper<ListResult>;
    static set_subscription_entitlement_availability(subscription_id: string, params?: _subscription_entitlement.set_subscription_entitlement_availability_params): RequestWrapper;
}
export declare class Component extends Model {
    entitlement_overrides?: resources.EntitlementOverride;
}
export declare namespace _subscription_entitlement {
    interface subscription_entitlement_subscription_entitlements_for_subscription_params {
        limit?: number;
        offset?: string;
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        include_drafts?: boolean;
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        embed?: string;
        /**
         * @deprecated Please refer API docs to use other attributes
         */
        include_scheduled_overrides?: boolean;
    }
    interface set_subscription_entitlement_availability_params {
        is_enabled: boolean;
        subscription_entitlements?: Array<subscription_entitlements_set_subscription_entitlement_availability_params>;
    }
    interface subscription_entitlements_set_subscription_entitlement_availability_params {
        feature_id: string;
    }
}
