"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Component = exports.SubscriptionEntitlement = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class SubscriptionEntitlement extends model_1.Model {
    // OPERATIONS
    //-----------
    static subscription_entitlements_for_subscription(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'subscription_entitlements_for_subscription',
            'httpMethod': 'GET',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/subscription_entitlements',
            'hasIdInUrl': true,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static set_subscription_entitlement_availability(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'set_subscription_entitlement_availability',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/subscription_entitlements/set_availability',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~SubscriptionEntitlement
exports.SubscriptionEntitlement = SubscriptionEntitlement;
class Component extends model_1.Model {
} // ~Component
exports.Component = Component;
