import { RequestWrapper } from "../request_wrapper";
import { Model } from "./model";
import { ProcessWait } from "../process_wait";
export declare class TimeMachine extends Model {
    name: string;
    time_travel_status: string;
    genesis_time: number;
    destination_time: number;
    failure_code?: string;
    failure_reason?: string;
    error_json?: string;
    static wait_for_time_travel_completion(): ProcessWait;
    static retrieve(time_machine_id: string, params?: any): RequestWrapper;
    static start_afresh(time_machine_id: string, params?: _time_machine.start_afresh_params): RequestWrapper;
    static travel_forward(time_machine_id: string, params?: _time_machine.travel_forward_params): RequestWrapper;
}
export declare namespace _time_machine {
    interface start_afresh_params {
        genesis_time?: number;
    }
    interface travel_forward_params {
        destination_time?: number;
    }
}
