import { ListResult } from '../list_result';
import { RequestWrapper } from "../request_wrapper";
import { Model } from "./model";
import { filter } from "../filter";
export declare class UnbilledCharge extends Model {
    id?: string;
    customer_id?: string;
    subscription_id?: string;
    date_from?: number;
    date_to?: number;
    unit_amount?: number;
    pricing_model?: string;
    quantity?: number;
    amount?: number;
    currency_code: string;
    discount_amount?: number;
    description?: string;
    entity_type: string;
    entity_id?: string;
    is_voided: boolean;
    voided_at?: number;
    unit_amount_in_decimal?: string;
    quantity_in_decimal?: string;
    amount_in_decimal?: string;
    updated_at: number;
    tiers?: Array<Tier>;
    is_advance_charge?: boolean;
    business_entity_id?: string;
    deleted: boolean;
    static create_unbilled_charge(params?: _unbilled_charge.create_unbilled_charge_params): RequestWrapper;
    static create(params?: _unbilled_charge.create_params): RequestWrapper;
    static invoice_unbilled_charges(params?: _unbilled_charge.invoice_unbilled_charges_params): RequestWrapper;
    static delete(unbilled_charge_id: string, params?: any): RequestWrapper;
    static list(params?: _unbilled_charge.unbilled_charge_list_params): RequestWrapper<ListResult>;
    static invoice_now_estimate(params?: _unbilled_charge.invoice_now_estimate_params): RequestWrapper;
}
export declare class Tier extends Model {
    starting_unit: number;
    ending_unit?: number;
    quantity_used: number;
    unit_amount: number;
    starting_unit_in_decimal?: string;
    ending_unit_in_decimal?: string;
    quantity_used_in_decimal?: string;
    unit_amount_in_decimal?: string;
    pricing_type?: string;
    package_size?: number;
}
export declare namespace _unbilled_charge {
    interface create_unbilled_charge_params {
        subscription_id: string;
        currency_code?: string;
        addons?: Array<addons_create_unbilled_charge_params>;
        charges?: Array<charges_create_unbilled_charge_params>;
        tax_providers_fields?: Array<tax_providers_fields_create_unbilled_charge_params>;
    }
    interface create_params {
        subscription_id: string;
        currency_code?: string;
        item_prices?: Array<item_prices_create_params>;
        item_tiers?: Array<item_tiers_create_params>;
        charges?: Array<charges_create_params>;
        tax_providers_fields?: Array<tax_providers_fields_create_params>;
    }
    interface invoice_unbilled_charges_params {
        subscription_id?: string;
        customer_id?: string;
    }
    interface unbilled_charge_list_params {
        limit?: number;
        offset?: string;
        include_deleted?: boolean;
        is_voided?: boolean;
        subscription_id?: filter._string;
        customer_id?: filter._string;
    }
    interface invoice_now_estimate_params {
        subscription_id?: string;
        customer_id?: string;
    }
    interface addons_create_unbilled_charge_params {
        id?: string;
    }
    interface addons_create_unbilled_charge_params {
        quantity?: number;
    }
    interface addons_create_unbilled_charge_params {
        unit_price?: number;
    }
    interface addons_create_unbilled_charge_params {
        quantity_in_decimal?: string;
    }
    interface addons_create_unbilled_charge_params {
        unit_price_in_decimal?: string;
    }
    interface addons_create_unbilled_charge_params {
        date_from?: number;
    }
    interface addons_create_unbilled_charge_params {
        date_to?: number;
    }
    interface charges_create_unbilled_charge_params {
        amount?: number;
    }
    interface charges_create_unbilled_charge_params {
        amount_in_decimal?: string;
    }
    interface charges_create_unbilled_charge_params {
        description?: string;
    }
    interface charges_create_unbilled_charge_params {
        taxable?: boolean;
    }
    interface charges_create_unbilled_charge_params {
        tax_profile_id?: string;
    }
    interface charges_create_unbilled_charge_params {
        avalara_tax_code?: string;
    }
    interface charges_create_unbilled_charge_params {
        hsn_code?: string;
    }
    interface charges_create_unbilled_charge_params {
        taxjar_product_code?: string;
    }
    interface charges_create_unbilled_charge_params {
        avalara_sale_type?: string;
    }
    interface charges_create_unbilled_charge_params {
        avalara_transaction_type?: number;
    }
    interface charges_create_unbilled_charge_params {
        avalara_service_type?: number;
    }
    interface charges_create_unbilled_charge_params {
        date_from?: number;
    }
    interface charges_create_unbilled_charge_params {
        date_to?: number;
    }
    interface tax_providers_fields_create_unbilled_charge_params {
        provider_name?: string;
    }
    interface tax_providers_fields_create_unbilled_charge_params {
        field_id?: string;
    }
    interface tax_providers_fields_create_unbilled_charge_params {
        field_value?: string;
    }
    interface item_prices_create_params {
        item_price_id?: string;
    }
    interface item_prices_create_params {
        quantity?: number;
    }
    interface item_prices_create_params {
        quantity_in_decimal?: string;
    }
    interface item_prices_create_params {
        unit_price?: number;
    }
    interface item_prices_create_params {
        unit_price_in_decimal?: string;
    }
    interface item_prices_create_params {
        date_from?: number;
    }
    interface item_prices_create_params {
        date_to?: number;
    }
    interface item_tiers_create_params {
        item_price_id?: string;
    }
    interface item_tiers_create_params {
        starting_unit?: number;
    }
    interface item_tiers_create_params {
        ending_unit?: number;
    }
    interface item_tiers_create_params {
        price?: number;
    }
    interface item_tiers_create_params {
        starting_unit_in_decimal?: string;
    }
    interface item_tiers_create_params {
        ending_unit_in_decimal?: string;
    }
    interface item_tiers_create_params {
        price_in_decimal?: string;
    }
    interface item_tiers_create_params {
        pricing_type?: string;
    }
    interface item_tiers_create_params {
        package_size?: number;
    }
    interface charges_create_params {
        amount?: number;
    }
    interface charges_create_params {
        amount_in_decimal?: string;
    }
    interface charges_create_params {
        description?: string;
    }
    interface charges_create_params {
        taxable?: boolean;
    }
    interface charges_create_params {
        tax_profile_id?: string;
    }
    interface charges_create_params {
        avalara_tax_code?: string;
    }
    interface charges_create_params {
        hsn_code?: string;
    }
    interface charges_create_params {
        taxjar_product_code?: string;
    }
    interface charges_create_params {
        avalara_sale_type?: string;
    }
    interface charges_create_params {
        avalara_transaction_type?: number;
    }
    interface charges_create_params {
        avalara_service_type?: number;
    }
    interface charges_create_params {
        date_from?: number;
    }
    interface charges_create_params {
        date_to?: number;
    }
    interface tax_providers_fields_create_params {
        provider_name?: string;
    }
    interface tax_providers_fields_create_params {
        field_id?: string;
    }
    interface tax_providers_fields_create_params {
        field_value?: string;
    }
}
