"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Tier = exports.UnbilledCharge = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class UnbilledCharge extends model_1.Model {
    // OPERATIONS
    //-----------
    static create_unbilled_charge(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create_unbilled_charge',
            'httpMethod': 'POST',
            'urlPrefix': '/unbilled_charges',
            'urlSuffix': '/create',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static create(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create',
            'httpMethod': 'POST',
            'urlPrefix': '/unbilled_charges',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static invoice_unbilled_charges(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'invoice_unbilled_charges',
            'httpMethod': 'POST',
            'urlPrefix': '/unbilled_charges',
            'urlSuffix': '/invoice_unbilled_charges',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static delete(unbilled_charge_id, params) {
        return new request_wrapper_1.RequestWrapper([unbilled_charge_id, params], {
            'methodName': 'delete',
            'httpMethod': 'POST',
            'urlPrefix': '/unbilled_charges',
            'urlSuffix': '/delete',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static list(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'list',
            'httpMethod': 'GET',
            'urlPrefix': '/unbilled_charges',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static invoice_now_estimate(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'invoice_now_estimate',
            'httpMethod': 'POST',
            'urlPrefix': '/unbilled_charges',
            'urlSuffix': '/invoice_now_estimate',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~UnbilledCharge
exports.UnbilledCharge = UnbilledCharge;
class Tier extends model_1.Model {
} // ~Tier
exports.Tier = Tier;
