"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Usage = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class Usage extends model_1.Model {
    // OPERATIONS
    //-----------
    static create(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'create',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/usages',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static retrieve(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'retrieve',
            'httpMethod': 'GET',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/usages',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static delete(subscription_id, params) {
        return new request_wrapper_1.RequestWrapper([subscription_id, params], {
            'methodName': 'delete',
            'httpMethod': 'POST',
            'urlPrefix': '/subscriptions',
            'urlSuffix': '/delete_usage',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static list(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'list',
            'httpMethod': 'GET',
            'urlPrefix': '/usages',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static pdf(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'pdf',
            'httpMethod': 'POST',
            'urlPrefix': '/usages',
            'urlSuffix': '/pdf',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~Usage
exports.Usage = Usage;
