"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UsageEvent = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class UsageEvent extends model_1.Model {
    // OPERATIONS
    //-----------
    static create(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create',
            'httpMethod': 'POST',
            'urlPrefix': '/usage_events',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': 'ingest',
            'isOperationNeedsJsonInput': true,
            'jsonKeys': {
                "properties": 0,
            }
        }, chargebee_1.ChargeBee._env);
    }
    static batch_ingest(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'batch_ingest',
            'httpMethod': 'POST',
            'urlPrefix': '/batch',
            'urlSuffix': '/usage_events',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': 'ingest',
            'isOperationNeedsJsonInput': true,
            'jsonKeys': {
                "properties": 1,
            }
        }, chargebee_1.ChargeBee._env);
    }
} // ~UsageEvent
exports.UsageEvent = UsageEvent;
