import { RequestWrapper } from "../request_wrapper";
import { Model } from "./model";
export declare class UsageFile extends Model {
    id: string;
    name: string;
    mime_type: string;
    error_code?: string;
    error_reason?: string;
    status?: string;
    total_records_count?: number;
    processed_records_count?: number;
    failed_records_count?: number;
    file_size_in_bytes?: number;
    processing_started_at?: number;
    processing_completed_at?: number;
    uploaded_by?: string;
    uploaded_at?: number;
    upload_details?: UploadDetail;
    static upload(params?: _usage_file.upload_params): RequestWrapper;
    static status(usage_file_id: string, params?: any): RequestWrapper;
}
export declare class UploadDetail extends Model {
    url: string;
    expires_at: number;
}
export declare namespace _usage_file {
    interface upload_params {
        file_name: string;
        mime_type: string;
    }
}
