"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UploadDetail = exports.UsageFile = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class UsageFile extends model_1.Model {
    // OPERATIONS
    //-----------
    static upload(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'upload',
            'httpMethod': 'POST',
            'urlPrefix': '/usage_files',
            'urlSuffix': '/upload',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': 'file-ingest',
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static status(usage_file_id, params) {
        return new request_wrapper_1.RequestWrapper([usage_file_id, params], {
            'methodName': 'status',
            'httpMethod': 'GET',
            'urlPrefix': '/usage_files',
            'urlSuffix': '/status',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': 'file-ingest',
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~UsageFile
exports.UsageFile = UsageFile;
class UploadDetail extends model_1.Model {
} // ~UploadDetail
exports.UploadDetail = UploadDetail;
