import { ListResult } from '../list_result';
import { RequestWrapper } from "../request_wrapper";
import { Model } from "./model";
import { filter } from "../filter";
export declare class VirtualBankAccount extends Model {
    id: string;
    customer_id: string;
    email: string;
    scheme?: string;
    bank_name?: string;
    account_number: string;
    routing_number?: string;
    swift_code?: string;
    gateway: string;
    gateway_account_id: string;
    resource_version?: number;
    updated_at?: number;
    created_at: number;
    reference_id: string;
    deleted: boolean;
    static create_using_permanent_token(params?: _virtual_bank_account.create_using_permanent_token_params): RequestWrapper;
    static create(params?: _virtual_bank_account.create_params): RequestWrapper;
    static retrieve(virtual_bank_account_id: string, params?: any): RequestWrapper;
    static list(params?: _virtual_bank_account.virtual_bank_account_list_params): RequestWrapper<ListResult>;
    static delete(virtual_bank_account_id: string, params?: any): RequestWrapper;
    static delete_local(virtual_bank_account_id: string, params?: any): RequestWrapper;
}
export declare namespace _virtual_bank_account {
    interface create_using_permanent_token_params {
        customer_id: string;
        reference_id: string;
        scheme?: string;
    }
    interface create_params {
        customer_id: string;
        email?: string;
        scheme?: string;
    }
    interface virtual_bank_account_list_params {
        limit?: number;
        offset?: string;
        customer_id?: filter._string;
        updated_at?: filter._timestamp;
        created_at?: filter._timestamp;
    }
}
