"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VirtualBankAccount = void 0;
const request_wrapper_1 = require("../request_wrapper");
const model_1 = require("./model");
const chargebee_1 = require("../chargebee");
class VirtualBankAccount extends model_1.Model {
    // OPERATIONS
    //-----------
    static create_using_permanent_token(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create_using_permanent_token',
            'httpMethod': 'POST',
            'urlPrefix': '/virtual_bank_accounts',
            'urlSuffix': '/create_using_permanent_token',
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static create(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'create',
            'httpMethod': 'POST',
            'urlPrefix': '/virtual_bank_accounts',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static retrieve(virtual_bank_account_id, params) {
        return new request_wrapper_1.RequestWrapper([virtual_bank_account_id, params], {
            'methodName': 'retrieve',
            'httpMethod': 'GET',
            'urlPrefix': '/virtual_bank_accounts',
            'urlSuffix': null,
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static list(params) {
        return new request_wrapper_1.RequestWrapper([params], {
            'methodName': 'list',
            'httpMethod': 'GET',
            'urlPrefix': '/virtual_bank_accounts',
            'urlSuffix': null,
            'hasIdInUrl': false,
            'isListReq': true,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static delete(virtual_bank_account_id, params) {
        return new request_wrapper_1.RequestWrapper([virtual_bank_account_id, params], {
            'methodName': 'delete',
            'httpMethod': 'POST',
            'urlPrefix': '/virtual_bank_accounts',
            'urlSuffix': '/delete',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
    static delete_local(virtual_bank_account_id, params) {
        return new request_wrapper_1.RequestWrapper([virtual_bank_account_id, params], {
            'methodName': 'delete_local',
            'httpMethod': 'POST',
            'urlPrefix': '/virtual_bank_accounts',
            'urlSuffix': '/delete_local',
            'hasIdInUrl': true,
            'isListReq': false,
            'subDomain': null,
            'isOperationNeedsJsonInput': false,
            'jsonKeys': {}
        }, chargebee_1.ChargeBee._env);
    }
} // ~VirtualBankAccount
exports.VirtualBankAccount = VirtualBankAccount;
