import * as resources from "./resources";
export declare class Result {
    #private;
    readonly responseHeaders: any;
    readonly responseStatusCode: number | string;
    get subscription(): resources.Subscription;
    get contract_term(): resources.ContractTerm;
    get discount(): resources.Discount;
    get advance_invoice_schedule(): resources.AdvanceInvoiceSchedule;
    get customer(): resources.Customer;
    get hierarchy(): resources.Hierarchy;
    get contact(): resources.Contact;
    get business_entity_transfer(): resources.BusinessEntityTransfer;
    get token(): resources.Token;
    get payment_source(): resources.PaymentSource;
    get third_party_payment_method(): resources.ThirdPartyPaymentMethod;
    get virtual_bank_account(): resources.VirtualBankAccount;
    get card(): resources.Card;
    get promotional_credit(): resources.PromotionalCredit;
    get invoice(): resources.Invoice;
    get payment_reference_number(): resources.PaymentReferenceNumber;
    get payment_schedule(): resources.PaymentSchedule;
    get tax_withheld(): resources.TaxWithheld;
    get credit_note(): resources.CreditNote;
    get unbilled_charge(): resources.UnbilledCharge;
    get order(): resources.Order;
    get gift(): resources.Gift;
    get transaction(): resources.Transaction;
    get hosted_page(): resources.HostedPage;
    get estimate(): resources.Estimate;
    get quote(): resources.Quote;
    get quoted_subscription(): resources.QuotedSubscription;
    get quoted_charge(): resources.QuotedCharge;
    get quoted_ramp(): resources.QuotedRamp;
    get quote_line_group(): resources.QuoteLineGroup;
    get plan(): resources.Plan;
    get addon(): resources.Addon;
    get coupon(): resources.Coupon;
    get coupon_set(): resources.CouponSet;
    get coupon_code(): resources.CouponCode;
    get address(): resources.Address;
    get usage(): resources.Usage;
    get event(): resources.Event;
    get comment(): resources.Comment;
    get download(): resources.Download;
    get portal_session(): resources.PortalSession;
    get site_migration_detail(): resources.SiteMigrationDetail;
    get resource_migration(): resources.ResourceMigration;
    get time_machine(): resources.TimeMachine;
    get export(): resources.Export;
    get payment_intent(): resources.PaymentIntent;
    get gateway_error_detail(): resources.GatewayErrorDetail;
    get item_family(): resources.ItemFamily;
    get item(): resources.Item;
    get price_variant(): resources.PriceVariant;
    get attribute(): resources.Attribute;
    get item_price(): resources.ItemPrice;
    get attached_item(): resources.AttachedItem;
    get differential_price(): resources.DifferentialPrice;
    get configuration(): resources.Configuration;
    get feature(): resources.Feature;
    get impacted_subscription(): resources.ImpactedSubscription;
    get impacted_item(): resources.ImpactedItem;
    get impacted_item_price(): resources.ImpactedItemPrice;
    get metadata(): resources.Metadata;
    get subscription_entitlement(): resources.SubscriptionEntitlement;
    get customer_entitlement(): resources.CustomerEntitlement;
    get item_entitlement(): resources.ItemEntitlement;
    get entitlement(): resources.Entitlement;
    get in_app_subscription(): resources.InAppSubscription;
    get non_subscription(): resources.NonSubscription;
    get entitlement_override(): resources.EntitlementOverride;
    get business_entity(): resources.BusinessEntity;
    get purchase(): resources.Purchase;
    get payment_voucher(): resources.PaymentVoucher;
    get currency(): resources.Currency;
    get ramp(): resources.Ramp;
    get payment_schedule_scheme(): resources.PaymentScheduleScheme;
    get pricing_page_session(): resources.PricingPageSession;
    get omnichannel_subscription(): resources.OmnichannelSubscription;
    get omnichannel_transaction(): resources.OmnichannelTransaction;
    get omnichannel_subscription_item(): resources.OmnichannelSubscriptionItem;
    get recorded_purchase(): resources.RecordedPurchase;
    get rule(): resources.Rule;
    get usage_event(): resources.UsageEvent;
    get omnichannel_subscription_item_scheduled_change(): resources.OmnichannelSubscriptionItemScheduledChange;
    get usage_file(): resources.UsageFile;
    get advance_invoice_schedules(): resources.AdvanceInvoiceSchedule[];
    get hierarchies(): resources.Hierarchy[];
    get invoices(): resources.Invoice[];
    get payment_schedules(): resources.PaymentSchedule[];
    get credit_notes(): resources.CreditNote[];
    get unbilled_charges(): resources.UnbilledCharge[];
    get downloads(): resources.Download[];
    get configurations(): resources.Configuration[];
    get in_app_subscriptions(): resources.InAppSubscription[];
    get response(): any;
    constructor(response: any, responseHeaders?: any, responseStatusCode?: any);
    getResponseHeaders(): any;
    isIdempotencyReplayed(): boolean;
    private get;
    private get_list;
    private toString;
    getResponseStatusCode(): string | number;
}
